###############################################################################
#
# changeToWindow.tcl
# 
# 
# Prozeduren zur Knotendarstellung WINDOW
#
###############################################################################


# Procedure: changeToWindow
# aendert Knotendarstellung auf Window - momentan nicht benutzt
proc changeToWindow { item {canv "."} } {
    if {$canv == "." } {
        global symbolicName
        set canv $symbolicName(graphView)
    }
    
    scan [$canv coords $item] {%f %f} x y
    removeItem $canv $item
    return [addNodeSubWindow $canv $x $y]
}

# Procedure: addNodeSubWindow
# wird momentan nicht benutzt
proc addNodeSubWindow { canv x y } {
  set SubWindowWidth 180
  set SubWindowHeight 180
  set cfTmpTag [$canv create window $x $y -width $SubWindowWidth -height $SubWindowHeight]

  # build widget .frame0
  frame $canv.$cfTmpTag \
    -bd {3} \
    -width $SubWindowWidth \
    -height $SubWindowHeight \
    -bg {black} \
    -relief {ridge}
  
  # build widget .frame0.canvas2
  canvas $canv.$cfTmpTag.canvas2 \
    -background {lightgrey} \
    -closeenough {3.0} \
    -height {60} \
    -insertbackground {black} \
    -insertofftime {600} \
    -relief {sunken} \
    -selectbackground {black} \
    -selectforeground {gainsboro} \
    -width $SubWindowWidth 
 
  frame $canv.$cfTmpTag.f1 -bd 1 -relief groove -height 5
  label $canv.$cfTmpTag.f1.l1 -text "node type: window"
  pack $canv.$cfTmpTag.f1.l1
  
  frame $canv.$cfTmpTag.f2 -bd 1 -relief groove -height [expr $SubWindowHeight/2]
  label $canv.$cfTmpTag.f2.l2 -text Attribute:
  entry $canv.$cfTmpTag.f2.a -width 20 -relief sunken -textvariable attribute

  pack $canv.$cfTmpTag.f2.l2 $canv.$cfTmpTag.f2.a -padx 10 -pady 5 -side top
  pack $canv.$cfTmpTag.f1 -side top -fill both -expand yes
  pack $canv.$cfTmpTag.f2 -side top -fill both -expand yes
  
  set box [tixButtonBox $canv.$cfTmpTag.b -bd 1 -relief raised]
  $canv.$cfTmpTag.b add ok -text Transaction -underline 0 -command ShowMessage -width 10 -cursor {hand2}
  pack $canv.$cfTmpTag.b -side bottom -fill both -expand yes

  pack append $canv.$cfTmpTag $canv.$cfTmpTag.canvas2 {top frame center expand fill} 

  $canv itemconfigure $cfTmpTag -window $canv.$cfTmpTag
  bind $canv <Destroy> exit
  bind $canv.$cfTmpTag.f2.a <ButtonRelease-3> ShowMessage
    
### Bindings
  # s. AddBoxWindow - sind hier noch einzubauen

  $canv addtag nodetag withtag $cfTmpTag

  # cfTmpTag fuer alle neuen Darstellungsformen setzen - sonst gibts Segmentation Fault bei Anklicken eines Knotens in dieser Darstellung !!!
  set cfTmpTag "$canv.$cfTmpTag.canvas2 $cfTmpTag"
 
  return $cfTmpTag
}

return ok