###############################################################################
#
# edge.tcl
# 
# 
# Prozeduren fuer die Behandlung von Kanten im Haupt-TCL-Fenster
#
###############################################################################
global nodeTypeName
set nodeTypeName ""
global edgeTypeName
set edgeTypeName ""
global isNode
set isNode 1

# Procedure: setDirected
proc setDirected { {fenster "."} } {
    global isDirected

    if {$fenster == "."} {
        global symbolicName
        set fenster $symbolicName(graphView)
    }
    set isDirected($fenster) {YES}
    $fenster itemconfigure edgetag -arrow {last} 
}

# Procedure: unsetDirected
proc unsetDirected { {fenster "."} } {
    global isDirected
    if {$fenster == "."} {
        global symbolicName
        set fenster $symbolicName(graphView)
    }
    set isDirected($fenster) {NO}
    $fenster itemconfigure edgetag -arrow {none} 
}

# Procedure addLineBindings
proc addLineBindings {canv cfTmpTag} {
    global nodeTypeName
    global edgeTypeName
    global isNode
    $canv bind $cfTmpTag <Button-1> {
	recall setCurrentEdge [%W find withtag current] [%W canvasx %x] \
	    [%W canvasy %y]
    }
    $canv bind $cfTmpTag <Shift-Button-1> {
	recall setCurrentEdge [%W find withtag current] [%W canvasx %x] \
	    [%W canvasy %y]
    }
    $canv bind $cfTmpTag <B1-Motion> {
	recall moveCurrent [%W find withtag current] [%W canvasx %x] \
	    [%W canvasy %y]
    }
    $canv bind $cfTmpTag <Shift-B1-Motion> {
	recall movePoint [%W find withtag current] [%W canvasx %x] [%W canvasy %y]
    }
    $canv bind $cfTmpTag <Button-2> {
	#JK alt fuer ffgraph manipulationen
	#recall removeEdge [%W find withtag current]
	#already defined in canvas.tcl
        #recall removeInstantPoint [%W canvasx %x] [%W canvasy %y]
    }
    $canv bind $cfTmpTag <Shift-Button-2> {
        #JK alt fuer ffgraph manipulationen
        #recall removeEdge [%W find withtag current]
	#already defined in canvas.tcl
        #recall addInstantPoint [%W canvasx %x] [%W canvasy %y]
    }
    $canv bind $cfTmpTag <M1-Button-1> {
	recall setCurrentEdge [%W find withtag current] %x %y;
	recall modPress i
    }
    
    $canv bind $cfTmpTag <Button-3> {
	recall setCurrentEdge [%W find withtag current] [%W canvasx %x] \
	    [%W canvasy %y];
	# hier wird globale Variable isNode gesetzt
	# 1 = Knoten , 0 = Kante
	recall "getEdgeIsNode";
	if { $isNode != 0 } then { 
	    recall "getEdgeNodeTypeName";
	} else {
	    recall "getEdgeTypeName";
	}
	buildEdgeMenu;
	.frame0.canvas2.menu1 post %W %x %y}
    
    # Menu ausblenden
    $canv bind $cfTmpTag <ButtonRelease-3> {
	.statusbar.status1 configure -text " "
    }

    $canv bind $cfTmpTag <Shift-Button-3> {
	recall setCurrentEdge [%W find withtag current] [%W canvasx %x] \
	    [%W canvasy %y];
	# hier wird globale Variable isNode gesetzt
	# 1 = Knoten , 0 = Kante
	recall "getEdgeIsNode";
	if { $isNode != 0 } then { 
	    .statusbar.status1 configure -text "Kante-Knoten-Kante"
	} {
	    .statusbar.status1 configure -text "stinknormale Kante"
	}
    }
}

# Procedure: addLine
proc addLine { canv col args} {

    global isDirected
    global typeArray

    set cfTmpTag [eval $canv create line $args]
    $canv lower $cfTmpTag all
    
    $canv addtag edgetag withtag $cfTmpTag

    # Defaultwerte - z.B. fuer Kante-Knoten-Kante-Konstrukt
    set edgeArrowShapeDefine "7 12 5"
    set strength 2
    set directed last
    
    if { $isDirected($canv) == "YES" } {
	$canv itemconfigure $cfTmpTag -fill $col -joinstyle {miter} -arrow $directed -width $strength -arrowshape $edgeArrowShapeDefine 
    } {
	$canv itemconfigure $cfTmpTag -fill $col -joinstyle {miter} -width $strength -arrowshape $edgeArrowShapeDefine 
    }
    
    addLineBindings $canv $cfTmpTag

#    setSelected $cfTmpTag $canv
    return $cfTmpTag
}

# Procedure: changeEdgeDisplay
# changes style of edge as defined in settings
proc changeEdgeDisplay {item edgeType {canv "."}} {

    global typeArray
    if {$canv == "."} {
        global symbolicName
        set canv [set symbolicName(graphView)]
    }
    
    focus $canv
    # change only if edge
    if {[lsearch [$canv gettags $item] edgetag] != -1} {
#	puts "$typeArray(STDEDGESTRENGTH) $typeArray(STDEDGEARROWSTYLE) $typeArray(STDEDGECOLOR) $typeArray(STDEDGEISDIRECTED) "
	set style $typeArray($edgeType,STYLE)

	if { [string compare $style USER1] == 0 } then { 
	 #  set edgeArrowShapeDefine "12 12 6"
	    set edgeArrowShapeDefine "7 12 5"
	    set col BLACK
            set dashed YES
	    set strength 2
	    set directed last
	} else {
	    if { [string compare $style USER2] == 0 } then { 
		###set edgeArrowShapeDefine "20 10 5" DEMO Paderborn
		set edgeArrowShapeDefine "7 12 5"
		set col BLACK
                set dashed NO
		set strength 2
		set directed none
	    } else {
		if { [string compare $style USER3] == 0 } then { 
		    ###set edgeArrowShapeDefine "12 0 6" DEMO Paderborn
		    set edgeArrowShapeDefine "12 12 6"
		    set col BLACK
                    set dashed YES
		    set strength 2
		    set directed none
		} else {
		    # $style DEFAULT
		    set arrowStyle $typeArray(STDEDGEARROWSTYLE)
		    if { [string compare $arrowStyle DIAMOND] == 0 } then { 
			set edgeArrowShapeDefine "20 10 5"
		    } else {
			if { [string compare $arrowStyle TRIANGLE] == 0 } then { 
			    set edgeArrowShapeDefine "12 12 6"
			} else {
			    if { [string compare $arrowStyle PYRAMID] == 0 } then { 
				set edgeArrowShapeDefine "12 0 6"
			    } else {
				set edgeArrowShapeDefine "7 12 5"
			    }
			}
		    }
		    set col $typeArray(STDEDGECOLOR)
                    set dashed NO
		    set strength $typeArray(STDEDGESTRENGTH)
		    if { $typeArray(STDEDGEISDIRECTED) == "YES" } {
			set directed last
		    } else {
			set directed none
		    }
		}
	    }
	}

	$canv itemconfigure $item -fill $col -joinstyle {miter} -arrow $directed -width $strength -arrowshape $edgeArrowShapeDefine -dash $dashed
    }
    return
}

# Procedure: addStdLine
proc addStdLine { col args} {
global symbolicName
return [eval addLine [set symbolicName(graphView)] $col $args]
}

# Procedure: changeEdgeColor
proc changeEdgeColor { edge col {fenster "."}} {
    if {$fenster == "."} {
        global symbolicName
        set fenster $symbolicName(graphView)
    }
    $fenster itemconfigure $edge -fill $col
}

# Procedure: smoothLine
proc smoothLine { c s {fenster "."}} {
  if {$fenster == "."} {
    global symbolicName
    set fenster $symbolicName(graphView)
  }
  $fenster itemconfigure $c -smooth $s
}

proc selectEdge {} {
    showMessage "under construction"
}

# Procedure buildEdgeMenu
proc buildEdgeMenu2 {} {
    # globale Variable isNode:
    # 1 = Knoten , 0 = Kante
    global isNode

    # falls vorhanden, Menu zerstoeren - damit die Kante ihr eigenes erhaelt
    catch {destroy .frame0.canvas2.menu1 ; return 0 } error_code
    if { $error_code != 0 } then { 
	#puts "Menu nicht zerstoert!"
    }
    
    # build widget .frame0.canvas2.menu1
    set m .frame0.canvas2.menu1
    menu $m -activebackground {AliceBlue} -bg {LightBlue} 
    
    if { $isNode != 0 } then { 
	$m add command  -label {Edge-Node-Edge menu} -state {disabled} 
    } {
	$m add command -label {Edge menu} -state {disabled} 
    }
    
    $m add separator
    
    if { $isNode != 0 } then { 
	$m add command  -command {recall "showEdgeAttr"} -label {Show Attributes} 
	$m add command -command "configureEdgeNode" -label {configure node}
	$m add separator
    }
       
#@    $m add command -command {recall "toggleSpline"} -label {Spline} 
    $m add separator
    
    $m add command -command "selectEdge" -label {Change Style} 
    $m add command -command "selectEdge" -label {Configuration} 
}

# Procedure buildEdgeMenu
proc buildEdgeMenu {} {
    # globale Variable isNode:
    # 1 = Knoten , 0 = Kante
    global isNode
    global nodeTypeName
    global edgeTypeName
    global typeArray

    # falls vorhanden, Menu zerstoeren - damit die Kante ihr eigenes erhaelt
    catch {destroy .frame0.canvas2.menu1 ; return 0 } error_code
    if { $error_code != 0 } then { 
	#puts "Menu nicht zerstoert!"
    }

    tixPopupMenu .frame0.canvas2.menu1 -height 1

    set m [.frame0.canvas2.menu1 subwidget menu]
    
    if { $isNode != 0 } then { 
	if { [string compare $nodeTypeName ""] != 0 } {
	    $m add command  -label "NodeType $nodeTypeName" -state {disabled} 
	} else {
	    $m add command -label {Edge Menu} -state {disabled} 
	}
	$m add separator
	$m add command -command "configureEdgeNode" -label {Configure NodeType}	 -state {disabled} 
	$m add cascade -label {Change EdgeStyle} -menu $m.menu3
	menu $m.menu3
	
	$m.menu3 add command -label "Current Style NONE" -state {disabled} 
	$m.menu3 add command -label DEFAULT
	$m.menu3 add command -label DARROW  
	$m.menu3 add command -label SLINE  
	$m.menu3 add command -label DLINE  

	$m add separator
	$m add command  -command {recall "showEdgeAttr"} -label {Show Attributes} 
    } else {
	$m add separator
	$m add command -label "EdgeType $edgeTypeName" -state {disabled} 
	$m add separator
	$m add command -command "selectEdge" -label {Configure EdgeType}  -state {disabled} 

	$m add cascade -label {Change EdgeStyle} -menu $m.menu3
	menu $m.menu3
	
	$m.menu3 add command -label "Current Style $typeArray($edgeTypeName,STYLE)" -state {disabled} 
	$m.menu3 add command -label DEFAULT  -command {selectEdgeStyle $edgeTypeName DEFAULT}
	$m.menu3 add command -label DARROW    -command {selectEdgeStyle $edgeTypeName USER1}
	$m.menu3 add command -label SLINE    -command {selectEdgeStyle $edgeTypeName USER2}
	$m.menu3 add command -label DLINE    -command {selectEdgeStyle $edgeTypeName USER3}
	
    }
    
#@    $m add separator
#@    $m add command -command {recall "toggleSpline"} -label {Spline} 

}

proc selectEdgeStyle {type style} {
    #--------------------------------------------------------------
    # entsprechend ausgewaehltem Style Optionen anbieten (s.dort)
    #--------------------------------------------------------------
    global typeArray
    global edgeTypeName

    set typeArray($type,STYLE) $style
#    set typeArray($edgeTypeName,STYLE) $style
    saveSettings APPLY
}

return ok
