#JK ermittle pfad aus env-variablen:
set scriptpath $env(TCL_PATH)
set scriptpath $scriptpath/tcl
#ungewoenlich zu lesen aber war: an den inhalt von "scriptpath" wird unmittelbar "/tcl" angehaengt

# GENDIR ist die env- Variable die auf den Ordner mit dem gen. Code zeigt
# da man an einigen stellen KEINEN zugriff auf env- variablen hat, wird der wert dieser
# variablen in eine globale tcl var kopiert
global GENDIR
set GENDIR $env(GENDIR)

# wenn error_code != ok ist wird message auf stdout ausgegeben !
proc on_error_message { error_code message} {
    if { [ string compare $error_code ok  ] != 0 } then { 
	puts stdout "-----------------------------------------------------"
	puts stdout "*** Severe Error executing file >> $message << ***"
	puts stdout "*** $error_code"
	puts stdout "-----------------------------------------------------"
    }
}

proc on_error_detail { error_code message} {
    if { [ string compare $error_code ok  ] != 0 } then { 
	puts stdout "-----------------------------------------------------"
	puts stdout $message
	puts stdout "-----------------------------------------------------"
    }
}

# catch { source "$scriptpath/visibility.tcl" } error_code
# on_error_message $error_code visibility.tcl
 
if { [file exists $GENDIR/wrapper.tcl] } then {
    catch { source "$GENDIR/wrapper.tcl" } error_code
    on_error_message $error_code wrapper.tcl
} 

catch { source "$scriptpath/attr_win.tcl" } error_code
on_error_message $error_code attr_win.tcl

catch { source "$scriptpath/common.tcl" } error_code
on_error_message $error_code common.tcl

catch { source "$scriptpath/settingsWin.tcl" } error_code
on_error_message $error_code settingsWin.tcl

catch { source "$scriptpath/text_graph.tcl" } error_code
on_error_message $error_code text_graph.tcl

catch { source "$scriptpath/execTclScript.tcl" } error_code
on_error_message $error_code execTclScript.tcl

catch { source "$scriptpath/proto_start.tcl" } error_code
on_error_message $error_code proto_start.tcl

catch { source "$scriptpath/proto_end.tcl" } error_code
on_error_message $error_code proto_end.tcl

catch { source "$scriptpath/transaction_failed_err_mssg.tcl" } error_code
on_error_message $error_code transaction_failed_err_mssg.tcl

catch { source "$scriptpath/viewManWin.tcl" } error_code
on_error_message $error_code viewManWin.tcl

catch { source "$scriptpath/tkbrowser/PrototypeMain.tcl" } error_code
on_error_message $error_code PrototypeMain.tcl

#puts stdout "... und noch nen Interp"
