###############################################################################
#
# setAttributes.tcl
# 
# 
# Erzeugung der Notebook-Seite fuer Attribute
#
#
###############################################################################


proc createPage_Attributes {win} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_nodetype
    global allAttr

    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w [$win.nb subwidget attributes]

    #--------------------------------------------------------------
    # Hilfsvariable - kein Knotentyp gesetzt
    #--------------------------------------------------------------
    set h1 "not_yet"

    #--------------------------------------------------------------
    # Container fuer gesamtes Tab
    #--------------------------------------------------------------
    frame $w.top -border 1
    pack $w.top -side top -fill both -expand yes

    #--------------------------------------------------------------
    # Rahmen rechte Seite
    #--------------------------------------------------------------
    set right $w.top
    $right config -border 1 -relief ridge

    #--------------------------------------------------------------
    # Attribut-Liste
    #--------------------------------------------------------------
    set typeArray($actualType,LISTATTR) [lsort  $typeArray($actualType,LISTATTR)]
    set c1 [tixCheckList $right.c -scrollbar auto -browsecmd listattr:update  -command listattr:update]
    
    set h1 [$c1 subwidget hlist]
    if { [string compare $typeArray($actualType,LISTATTR)  ""] != 0 } {
	foreach ent  $typeArray($actualType,LISTATTR)  {
	    set dispEnt [string trimright $ent "|YES"]
	    set dispEnt [string trimright $dispEnt "|NO"]
	    if { [string first "|YES" $ent] != -1 } { 
		$h1 add $dispEnt  -itemtype imagetext -text $dispEnt
		$c1 setstatus $dispEnt on 
	    } else { 
		$h1 add $dispEnt  -itemtype imagetext -text $dispEnt
#		$c1 setstatus $dispEnt default
		$c1 setstatus $dispEnt off
	    }
	}
    }

    #--------------------------------------------------------------
    # Option NodeLabel
    #--------------------------------------------------------------
    tixOptionMenu $right.nodeLabel -label "NodeLabel:" \
	-variable nodelabel\
	-command nodelabel:set \
	-options { label.width  19   label.anchor w   menubutton.width 16 }

    $right.nodeLabel add command $typeArray(NODELABEL) -label $typeArray(NODELABEL)
    if { [string compare $typeArray(NODELABEL) YES] == 0}  {
	$right.nodeLabel add command NO  -label NO
    } else {
	$right.nodeLabel add command YES   -label YES
    }

    #--------------------------------------------------------------
    # Label Attribut
    #--------------------------------------------------------------
    tixComboBox $right.labelAttr -label "NodeLabel Attribute:" -dropdown true \
	-command labelAttr:select_attr -editable false  \
	-options { listbox.height 8   label.width 19   label.anchor w }

    foreach attr $allAttr { $right.labelAttr insert end $attr }
    #hier LABELATTR einsetzen
    tixSetSilent $right.labelAttr $typeArray(LABELATTR);

    #--------------------------------------------------------------
    # now do some packing
    #--------------------------------------------------------------
    pack $right -side left  -expand yes -fill both -padx 1
    pack $c1 -expand yes -fill both -padx 1 -pady 1
    pack $right.nodeLabel -side top -anchor w
    pack $right.labelAttr -side top -anchor w

}

proc nodelabel:set { sel } {
    #--------------------------------------------------------------
    # nodeLabel speichern
    #--------------------------------------------------------------
    global typeArray
    set typeArray(NODELABEL) $sel
}

proc labelAttr:select_attr { selection } {
    #--------------------------------------------------------------
    # Label-Attribut speichern
    #--------------------------------------------------------------
    global typeArray
    set typeArray(LABELATTR) $selection
}

proc listattr:update { dummy } {
    #--------------------------------------------------------------
    # Attributliste updaten
    #--------------------------------------------------------------
    global nodeStyle
    global typeArray
    global actualType
    global h1
    global c1
    
    set selection [$c1 getselection on] 
    set selection " $selection "
    set newList ""
    foreach elm  $typeArray($actualType,LISTATTR)  {
	set elm [string trimright $elm "|YES"]
	set elm [string trimright $elm "|NO"]
	if { [string first " $elm " $selection] != -1 } { set newList "$newList $elm|YES" } else { set newList "$newList $elm|NO" }
    }
    set typeArray($actualType,LISTATTR) $newList
#    set typeArray($actualType,LISTATTR) [lsort  $typeArray($actualType,LISTATTR)]
}

return ok