###############################################################################
#
# setEdgeStyle.tcl
# 
# 
# Erzeugung der Notebook-Seite fuer EdgeStyle
#
#
###############################################################################

proc createPage_EdgeStyle {w} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_estyle
    global win_path_for_layout
    global stdEdgeIsDirected
    global selectedEType
    global current_etype

    set selectedEType ""


    #--------------------------------------------------------------
    # Create page EdgeStyle
    #--------------------------------------------------------------
###    set w [$main_window.nb subwidget estyle]

    #--------------------------------------------------------------
    # Container-Rahmen fuer das gesamte Tab
    #--------------------------------------------------------------
    frame $w.top 

    #--------------------------------------------------------------
    # linke Seite
    #--------------------------------------------------------------
    set left [frame $w.top.left]
    $left config -border 1 -relief ridge
    pack $left -side left  -expand no -fill both -padx 1

    #--------------------------------------------------------------
    # rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.top.right]
    $right config -border 1 -relief ridge
    pack $right -side left  -expand yes -fill both -padx 1

    #--------------------------------------------------------------
    # Type Combobox
    #--------------------------------------------------------------
#    create_etype_combo_box $left
    create_edgeTree $left

    #--------------------------------------------------------------
    # Notebook fuer Kanten aufbauen
    #--------------------------------------------------------------
    createNoteBook_EdgeSettings $right

    #--------------------------------------------------------------
    # Initialwert setzen
    #--------------------------------------------------------------
    if { [string compare  "" $selectedEType] != 0 } {
	set hlist [$left.classTree subwidget hlist]
	$hlist selection set $selectedEType
	set current_etype $selectedEType
    }


    #--------------------------------------------------------------
    # do some packing
    #--------------------------------------------------------------
    pack $w.top -side top -fill both -expand yes

}

proc createNoteBook_EdgeSettings {w} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree

#### noteBook #####################################################
#                                                                 #
    set name [tixOptionName $w]
    option add *$name*TixControl*entry.width 10
    option add *$name*TixControl*label.width 18
    option add *$name*TixControl*label.anchor e

    tixNoteBook $w.nb -ipadx 6 -ipady 6

    $w.nb add eStyle      -label "Appearance"        -underline 0
    $w.nb add eAttributes -label "Label"             -underline 0
    $w.nb add ePreview    -label "Preview"           -underline 0 -state disabled

    pack $w.nb -expand yes -fill both -padx 0 -pady 0 -side top
    
#                                                                 #
#### noteBook #####################################################

#### pages ########################################################
#                                                                 #

    #--------------------------------------------------------------
    # Create page Attributes                                      
    #--------------------------------------------------------------
    createPage_EdgeAttributes $w

    #--------------------------------------------------------------
    # Create page Appearence                                        
    #--------------------------------------------------------------
    createPage_EdgeAppearence $w

    #--------------------------------------------------------------
    # Create page EdgePreview                                     
    #--------------------------------------------------------------
    createPage_EdgePreview $w

}


proc createPage_EdgeAttributes { w } {
    global typeArray
    global applyChanges
    global stdEdgeIsDirected
    global selectedEType
    global current_etype
    global win_path_for_estyle
    global edgeStyle
    global edgelabel

    #--------------------------------------------------------------
    # Fenster des Tabs nodeType ermitteln
    #--------------------------------------------------------------
    set w [$w.nb subwidget eAttributes]

    #--------------------------------------------------------------
    # Container-Rahmen
    #--------------------------------------------------------------
    frame $w.top -border 1
    pack $w.top -side top -fill both -expand yes

    #--------------------------------------------------------------
    # Rahmen fuer die linke Seite
    #--------------------------------------------------------------
    set left [frame $w.top.left]
    $left config -border 1 -relief ridge
    pack $left -side left  -expand no -fill both -padx 1

    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.top.right]
    $right config -border 1 -relief ridge
    pack $right -side left  -expand yes -fill both -padx 1


    #--------------------------------------------------------------
    # EdgeLabel
    #--------------------------------------------------------------
    tixOptionMenu $left.edgeLabel -label "EdgeLabel:" \
	-variable edgelabel\
	-command edgelabel:set \
	-options { label.width  16   label.anchor w   menubutton.width 16 }
    $left.edgeLabel add command $typeArray(EDGELABEL) -label $typeArray(EDGELABEL)
    if { [string compare $typeArray(EDGELABEL) YES] == 0 }  {$left.edgeLabel add command NO  -label NO}
    if { [string compare $typeArray(EDGELABEL) NO] == 0 }   {$left.edgeLabel add command YES  -label YES}

    pack $left.edgeLabel -side top -anchor w


}

proc edgelabel:set { sel } {
    #--------------------------------------------------------------
    # Edgelabel speichern
    #--------------------------------------------------------------
    global typeArray
    set typeArray(EDGELABEL) $sel
}

proc createPage_EdgePreview { w } {
    global typeArray
    global applyChanges
    global stdEdgeIsDirected
    global selectedEType
    global current_etype
    global win_path_for_estyle
    global edgeStyle
    global edgelabel

    #--------------------------------------------------------------
    # Fenster des Tabs nodeType ermitteln
    #--------------------------------------------------------------
    set w [$w.nb subwidget ePreview]

    #--------------------------------------------------------------
    # Container-Rahmen
    #--------------------------------------------------------------
    frame $w.top -border 1
    pack $w.top -side top -fill both -expand yes

    #--------------------------------------------------------------
    # Rahmen fuer die linke Seite
    #--------------------------------------------------------------
    set left [frame $w.top.left]
    $left config -border 1 -relief ridge
    pack $left -side left  -expand no -fill both -padx 1

    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.top.right]
    $right config -border 1 -relief ridge
    pack $right -side left  -expand yes -fill both -padx 1

}

proc createPage_EdgeAppearence { w } {
    global typeArray
    global applyChanges
    global stdEdgeIsDirected
    global selectedEType
    global current_etype
    global win_path_for_estyle
    global edgeStyle

    #--------------------------------------------------------------
    # Fenster des Tabs nodeType ermitteln
    #--------------------------------------------------------------
    set w [$w.nb subwidget eStyle]

    #--------------------------------------------------------------
    # Container-Rahmen
    #--------------------------------------------------------------
    frame $w.top -border 1
    pack $w.top -side top -fill both -expand yes

    #--------------------------------------------------------------
    # Rahmen fuer die linke Seite
    #--------------------------------------------------------------
    set left [frame $w.top.left]
    $left config -border 1 -relief ridge
    pack $left -side left  -expand no -fill both -padx 1

    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.top.right]
    $right config -border 1 -relief ridge
    pack $right -side left  -expand yes -fill both -padx 1

    #--------------------------------------------------------------
    # Rahmen fuer die Buttons
    #--------------------------------------------------------------
    frame $right.frButtons -border 1 -relief raised
    pack $right.frButtons -side top  -expand no -fill x

    #--------------------------------------------------------------
    # Rahmen fuer die Styles
    #--------------------------------------------------------------
    frame $right.frStyles -border 1 -relief raised
    pack $right.frStyles -side top  -expand yes -fill both

    # Container fuer Styles
    set win_path_for_estyle $right.frStyles

    set right  $right.frButtons 

    #--------------------------------------------------------------
    # Splines (toggle the spline flag)
    #--------------------------------------------------------------
    checkbutton $right.useSpline -anchor nw \
	-offvalue 0 -onvalue 1 -variable splineFlag \
	-selectcolor {gold} -text {Use Splines} \
	-command {recall toggleSplineAll}
    pack $right.useSpline  -side top -anchor w
    
    #--------------------------------------------------------------
    # EdgeStyle
    #--------------------------------------------------------------
    tixOptionMenu $right.edgeStyle -label "EdgeStyle:" \
	-variable edgeStyle \
	-command edgestyle:set \
	-options { label.width  16   label.anchor w   menubutton.width 10 }
    set l [$right.edgeStyle subwidget label]
    $l config -fg blue

    $right.edgeStyle add command DEFAULT -label DEFAULT 
    $right.edgeStyle add command USER1 -label DARROW 
    $right.edgeStyle add command USER2 -label SLINE 
    $right.edgeStyle add command USER3 -label DLINE

    pack $right.edgeStyle -side top -anchor w -padx 3

}

proc create_edgeTree {w} {
    #--------------------------------------------------------------
    # Klassenbaum erzeugen
    #--------------------------------------------------------------
    global typeArray
    global selectedEType
    global typeList
    global current_etype

    set left $w
    if { [winfo exists $left.classTree] == 1  } { destroy $left.classTree }

    tixTree $left.classTree -options { separator "\\" }
    pack $left.classTree -expand yes -fill both -padx 4 -pady 4 -side left
 
    set tree $left.classTree 
    set hlist [$left.classTree subwidget hlist]

    $hlist config -selectmode single -browsecmd "edgeTree:OpenDir $tree" -width 30
    
    #  Add the directories into the TixTree widget (using the
    #  hlist subwidget)

    global edgeList
    foreach type  $edgeList  { 
	# nur die sichtbaren Kantentypen sind editierbar
	###if { [string first "YES" $typeArray($type,VISI)] != -1 } { 
            set text [lindex [split $type \\] end]
	    $hlist add $type -itemtype imagetext \
	      -text $text -image [tix getimage file]
	    set selectedEType $type
	###    }
    }

    set current_etype $selectedEType
    $tree autosetmode

    pack $left.classTree    -side top -anchor w
}

proc edgeTree:OpenDir {tree dir} {
    #--------------------------------------------------------------
    # Klassenbaum aufbauen
    #--------------------------------------------------------------
    set hlist [$tree subwidget hlist]
    set tmpListe [split $dir "\\"]
    set text [lindex $tmpListe end]
    update
    select_edgeType $text
}

proc select_edgeType {type} {
    global edgeStyle
    global typeArray
    global current_etype
    set current_etype $type

    if {[string compare $type ""] != 0} {
	set edgeStyle $typeArray($type,STYLE)
    }
}

proc selectEdgeFont {} {
    #--------------------------------------------------------------
    # Aufruf des Fontdialogs
    #--------------------------------------------------------------
    global win_path_for_font
    global tmpFont
    global edgeFont
    set win_path_for_font edgeFont

    callFontDialog
    MainTextFont tmpFont

}

proc create_default_estyle { } {
    #--------------------------------------------------------------
    # Default EdgeStyle
    #--------------------------------------------------------------
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_estyle
    global wtextfont
    set wtextfont "-*-helvetica-medium-r-*-*-*-120-*-*-p-*-*-*"
    global wtextsize
    global sel_just 
    global isDirected
    global edgeArrowShape
    global edgeArrowShapeDefine
    global edgeColor
    global lStrength
    global win_path_for_layout
    global win_path_for_font
    global edgeFont
    global stdEdgeIsDirected
    global edgeStyle
    global lineStyle

    set edgeFont *
    set win_path_for_font edgeFont
    
    #--------------------------------------------------------------
    # init values
    #--------------------------------------------------------------
    set edgeArrowShapeDefine "7 12 5"
    set edgeArrowShape $typeArray(STDEDGEARROWSTYLE)
    set edgeColor $typeArray(STDEDGECOLOR)
    set tmpColor $edgeColor
    set lStrength $typeArray(STDEDGESTRENGTH)
    set stdEdgeIsDirected $typeArray(STDEDGEISDIRECTED)

    #--------------------------------------------------------------
    # Set the default value of the two Select widgets
    #--------------------------------------------------------------
    set sel_just left

    set w $win_path_for_estyle

    if { [winfo exists $w.right] == 1  } { 
	#destroy $w.right 
	set win_path_for_layout $win_path_for_estyle.right.frame1.preview.border.frame.canvas1
	return OK
    }
    
    #--------------------------------------------------------------
    # Rahmen fuer rechte Seite des Tabs
    #--------------------------------------------------------------
    frame $w.right
    set right $w.right

    #--------------------------------------------------------------
    # Ueberschrift
    #--------------------------------------------------------------
    label $right.label1 -text "Style Specific Options" -fg blue

    #--------------------------------------------------------------
    # oberen Teil der Seite aufbauen - 1. Rahmen
    #--------------------------------------------------------------
    frame $right.frame1

    #--------------------------------------------------------------
    # linke Seite des oberen Teils
    #--------------------------------------------------------------
    frame $right.frame1.frame2
    #--------------------------------------------------------------
    # rechte Seite des oberen Teils == Preview-Fenster
    #--------------------------------------------------------------
    tixLabelFrame $right.frame1.preview -label Preview
    set frame2 $right.frame1.frame2
    set preview [$right.frame1.preview subwidget frame]

    #--------------------------------------------------------------
    # Edge Canvas
    #--------------------------------------------------------------
    canvas $preview.canvas1 -relief {sunken} -height 130 -width 140
    #pack append $canv.$cfTmpTag $canv.$cfTmpTag.canvas2 {top frame center expand fill} 
    set c $preview.canvas1

    set win_path_for_layout $preview.canvas1

    set stdEdgeIsDirected $typeArray(STDEDGEISDIRECTED)
#    puts "IsDirected: $typeArray(STDEDGEISDIRECTED) $stdEdgeIsDirected"

    #--------------------------------------------------------------
    # Option gerichtet
    #--------------------------------------------------------------
    tixOptionMenu $frame2.arrowMode -label "ArrowMode:" \
	-options { label.width  16   label.anchor w   menubutton.width 10 }
###	-variable stdEdgeIsDirected \
###	-command stdEdgeIsDirected:set \

    $frame2.arrowMode add command cmd1 -label "------"
    $frame2.arrowMode add command cmd2 -label "----->"
    $frame2.arrowMode add command cmd3 -label "<-----"
    $frame2.arrowMode add command cmd4 -label "<---->"
    $frame2.arrowMode add command cmd5 -label "ATTRDEFINED"
    
    #--------------------------------------------------------------
    # Option LineStyle
    #--------------------------------------------------------------
    tixOptionMenu $frame2.lineStyle -label "LineStyle:" \
	-variable lineStyle -command stdEdgeLineStyle:set \
	-options { label.width  16   label.anchor w   menubutton.width 10 } 
#	-state disabled
    $frame2.lineStyle add command $typeArray(STDEDGELINESTYLE) -label $typeArray(STDEDGELINESTYLE)
    if { [string compare $typeArray(STDEDGELINESTYLE)  SOLID] != 0 } then { 
	$frame2.lineStyle add command SOLID  -label SOLID
    }
    if { [string compare $typeArray(STDEDGELINESTYLE)  DOTTED] != 0 } then { 
	$frame2.lineStyle add command DOTTED  -label DOTTED
    }
    if { [string compare $typeArray(STDEDGELINESTYLE)  DASHED] != 0 } then { 
	$frame2.lineStyle add command DASHED  -label DASHED
    }
#    set lineStyle $typeArray(STDEDGELINESTYLE)
#    tixSetSilent $frame2.lineStyle $typeArray(STDEDGELINESTYLE)
    
    #--------------------------------------------------------------
    # Option lineStrength
    #--------------------------------------------------------------
    tixControl $frame2.lineStrength -label "LineThickness:" -integer true \
	-variable lStrength -min 1 -max 20 \
	-command stdEdgeStrength:set \
	-options { entry.width 12 label.width 16 label.anchor w	}
#    tixSetSilent $frame2.lineStrength 2
    

    #--------------------------------------------------------------
    # Option ArrowShape
    #--------------------------------------------------------------
    set edgeArrowShape $typeArray(STDEDGEARROWSTYLE)
    tixOptionMenu $frame2.arrowShape -label "ArrowShape:" \
	-variable edgeArrowShape \
	-command stdEdgeArrowStyle:set \
	-options { label.width  16   label.anchor w   menubutton.width 10 }
    $frame2.arrowShape add command $typeArray(STDEDGEARROWSTYLE) -label $typeArray(STDEDGEARROWSTYLE)
    foreach shape $typeArray(STDEDGEARROWSHAPE)  {
	if { [string compare  $typeArray(STDEDGEARROWSTYLE) $shape] != 0 } { $frame2.arrowShape add command $shape -label $shape }
    }

    #--------------------------------------------------------------
    # Option lineColor
    #--------------------------------------------------------------
    tixOptionMenu $frame2.color -label "Color:" \
	-variable edgeColor \
	-command stdEdgeColor:set \
	-options { label.width  16   label.anchor w   menubutton.width 10 }
    fillColorBox $frame2.color
    tixSetSilent $frame2.color $tmpColor
    if { [string compare $edgeStyle DEFAULT] == 0 } then { 
	set typeArray(STDEDGECOLOR) $tmpColor
    }

    #--------------------------------------------------------------
    # unterer Teil der rechten Seite
    #--------------------------------------------------------------

    #--------------------------------------------------------------
    # Rahmen fuer Font
    #--------------------------------------------------------------
    frame $right.frame3
    set frame3 $right.frame3

    #--------------------------------------------------------------
    # Textfont
    #--------------------------------------------------------------
    tixLabelEntry $frame3.f -label "Label Font: "
    $frame3.f subwidget label configure -width 16 -anchor w
    $frame3.f subwidget entry configure -width 30 -textvariable edgeFont -state disabled

    # hier Wert einlesen!
    set edgeFont "*"

    #--------------------------------------------------------------
    # Select Button
    #--------------------------------------------------------------
    button $frame3.selectButton -text " Select " -command selectEdgeFont -padx 0 -pady 0
    pack $frame3.f $frame3.selectButton -side left -anchor w

    #--------------------------------------------------------------
    # Justification - Rahmen fuer Bitmaps
    #--------------------------------------------------------------
    frame $right.frame4
    set frame4 $right.frame4
    tixSelect $frame4.font -allowzero true  -radio false \
	-label "Justification: "\
	-options {
	    label.width 16
	    label.anchor w
	}
    tixSelect $frame4.just -allowzero true  -radio true 

    #--------------------------------------------------------------
    # packing
    #--------------------------------------------------------------
    pack $w.right -side top -fill both -expand yes
###    pack $right.label1 -side top -padx 2 -pady 5
    pack $right.frame1 -side top -fill both -expand no 
    pack $right.frame1.frame2 $right.frame1.preview -side left -fill both -expand no -padx 2
    pack $preview.canvas1

    pack $frame2.color -side top -anchor w
    pack $frame2.lineStyle -side top -anchor w
    pack $frame2.arrowMode -side top -anchor w
    pack $frame2.arrowShape -side top -anchor w
    pack $frame2.lineStrength -side top -anchor w

    pack $right.frame3 -side top -fill both -expand no -padx 2 -pady 1
    pack $right.frame4 -side top -fill both -expand no -pady 2
    pack $frame4.font $frame4.just -side left -padx 1 -pady 1


    #--------------------------------------------------------------
    # Bitmaps
    #--------------------------------------------------------------
    global scriptpath
    $frame4.just add left      -bitmap @$scriptpath/bitmaps/leftj.xbm
    $frame4.just add center    -bitmap @$scriptpath/bitmaps/centerj.xbm
    $frame4.just add right     -bitmap @$scriptpath/bitmaps/rightj.xbm
    $frame4.just config -variable sel_just -command "MainTextFont $frame3" 

    #--------------------------------------------------------------
    # add some little help
    #--------------------------------------------------------------
    tixBalloon $w.balloon
    $w.balloon bind [$frame4.just subwidget left] -balloonmsg "Justification Left"
    $w.balloon bind [$frame4.just subwidget center] -balloonmsg "Justification Center"
    $w.balloon bind [$frame4.just subwidget right] -balloonmsg "Justification Right"
    $w.balloon bind $frame3.selectButton -balloonmsg "Press button to start the font dialog"

}

proc create_ArrowShape { sel } {
    #--------------------------------------------------------------
    # Vorgaben fuer Pfeilspitzen
    #--------------------------------------------------------------
    global edgeArrowShapeDefine
    global win_path_for_layout

    if { [string compare $sel ARROW] == 0 } then { 
      set edgeArrowShapeDefine "7 12 5"
    }
    if { [string compare $sel DIAMOND] == 0 } then { 
      set edgeArrowShapeDefine "20 10 5"
    }
    if { [string compare $sel TRIANGLE] == 0 } then { 
      set edgeArrowShapeDefine "12 12 6"
    }
    if { [string compare $sel PYRAMID] == 0 } then { 
      set edgeArrowShapeDefine "12 0 6"
    }
    if { [string compare $sel NONE] == 0 } then { 
      set edgeArrowShapeDefine "0 0 0"
    }

    create_EdgeLayout $sel
}    


proc MainTextFont {w args} {
    #--------------------------------------------------------------
    # Beispiel-Text in ausgewaehltem Font anzeigen
    #--------------------------------------------------------------
    global sel_just 
    global win_path_for_font
    global ${win_path_for_font}
    global win_path_for_layout

    set xfont [expr $$win_path_for_font]
    if { [string compare $xfont "*"] == 0 } then { 
      set xfont "-*-courier-*-*-*-*-*-*-*-*-*-*-*-*"
    }

    set c $win_path_for_layout
    # Test ob Canvas vorhanden, wenn ja, text ausgeben
    catch {$c delete text ; return 0 } error_code
    if { $error_code == 0 } then { 
	$c create text 50 70 -text "EdgeLabel justified" -tag text -font $xfont -justify $sel_just -width 100
    }

}

proc create_etype_combo_box { w } {
    #--------------------------------------------------------------
    # Combobox fuer EdgeType
    #--------------------------------------------------------------
    global typeList
    global actualType
    global win_path_for_types
    global typeArray
    global h1
    global c1

    #set w $win_path_for_types

    if { [winfo exists $w.edgeType] == 1  } { destroy $w.edgeType }
    
    tixComboBox $w.edgeType -label "EdgeType:" -dropdown true -editable false  \
	-options { listbox.height 6  entry.width 16  label.width 10   label.anchor w }
#	-command cbx:select_type  \
# Select-Prozedur ist noch zu implementieren !!!

    set tmp " "


#    foreach ent  $typeArray(EDGEVISI) {
#	set edge [string trimright $ent "|YES"]
#	set edge [string trimright $edge "|NO"]
#	    $w.edgeType insert end $edge
#	    set tmp $edge
#    }
    if { [string compare  "" $tmp] != 0 } {
	tixSetSilent $w.edgeType $tmp
	#set actualType $tmp  aktuellen Typen setzen
	if { [string compare $h1 "not_yet"] != 0 } {
#	    cbx:select_type $tmp
# Select-Prozedur ist noch zu implementieren !!!
	}
    } else { 
	$h1 del all
    }
    
    pack $w.edgeType -side top -anchor w
}

proc stdEdgeIsDirected:set { sel } {
    #--------------------------------------------------------------
    # isDirected speichern
    #--------------------------------------------------------------
    global typeArray
    global isDirected
    global stdEdgeIsDirected
    global edgeStyle
    global win_path_for_layout

    if { [string compare $edgeStyle DEFAULT] == 0 } then { 
	set typeArray(STDEDGEISDIRECTED) $sel
    }
#    puts "Set: frame:$isDirected(.frame0.canvas2) stdeEdge:$stdEdgeIsDirected Sel:$sel"
    create_EdgeLayout $sel
}

proc stdEdgeArrowStyle:set { sel } {
    #--------------------------------------------------------------
    # ArrowStyle speichern
    #--------------------------------------------------------------
    global typeArray
    global edgeArrowShape
    global edgeStyle

    if { [string compare $edgeStyle DEFAULT] == 0 } then { 
	set typeArray(STDEDGEARROWSTYLE) $edgeArrowShape
    }
    create_ArrowShape $sel
}

proc stdEdgeLineStyle:set { sel } {
    #--------------------------------------------------------------
    # ArrowStyle speichern
    #--------------------------------------------------------------
    global typeArray
    global lineStyle
    global edgeStyle

    if { [string compare $edgeStyle DEFAULT] == 0 } then { 
	# LineStyle nur fuer Default speichern
	set typeArray(STDEDGELINESTYLE) $lineStyle
    }
    create_EdgeLayout $sel
}

proc stdEdgeColor:set { sel} {
    #--------------------------------------------------------------
    # Color speichern
    #--------------------------------------------------------------
    global typeArray
    global edgeColor
    global edgeStyle
    global win_path_for_layout

    if { [string compare $edgeStyle DEFAULT] == 0 } then { 
	set typeArray(STDEDGECOLOR) $edgeColor
    }
    create_EdgeLayout $sel
}

proc stdEdgeStrength:set { sel} {
    #--------------------------------------------------------------
    # Strength speichern
    #--------------------------------------------------------------
    global typeArray
    global lStrength
    global edgeStyle
    global win_path_for_layout

    if { [string compare $edgeStyle DEFAULT] == 0 } then { 
	set typeArray(STDEDGESTRENGTH) $lStrength
    }
    create_EdgeLayout $sel
}

#new!!!
proc edgestyle:set { sel } {
    #--------------------------------------------------------------
    # EdgeStyle speichern
    #--------------------------------------------------------------
    global typeArray
    global edgeColor
    global edgeStyle
    global current_etype
    global lStrength
    global lineStyle
    global edgeArrowShape
    create_default_estyle 
    global win_path_for_estyle
    global win_path_for_layout
    
    set w $win_path_for_estyle.right.frame1.frame2
    set typeArray($current_etype,STYLE) $edgeStyle

# !!! hier sind bei allen Faellen ausser DEFAULT noch die globalen Variablen der Eingabefelder zu setzen !!!

    if { [string compare $sel DEFAULT] == 0 } then { 
###	tixSetSilent $w.directed $typeArray(STDEDGEISDIRECTED)
	set lineStyle $typeArray(STDEDGELINESTYLE)
	tixSetSilent $w.lineStyle $lineStyle
	set lStrength $typeArray(STDEDGESTRENGTH)
	tixSetSilent $w.lineStrength $lStrength
	set edgeArrowShape $typeArray(STDEDGEARROWSTYLE)
        tixSetSilent $w.arrowShape $edgeArrowShape
	set edgeColor $typeArray(STDEDGECOLOR)
	tixSetSilent $w.color $edgeColor
        create_ArrowShape $edgeArrowShape
#	set a $typeArray(STDEDGEARROWSTYLE)
#        tixSetSilent $w.arrowShape $a
#        create_ArrowShape $a
    } 
    if { [string compare $sel USER1] == 0 } then { 
###	tixSetSilent $w.directed YES
	set lineStyle DOTTED
	tixSetSilent $w.lineStyle $lineStyle
	set lStrength 2
	tixSetSilent $w.lineStrength $lStrength
	set edgeArrowShape ARROW
        tixSetSilent $w.arrowShape $edgeArrowShape
	set edgeColor BLACK
	tixSetSilent $w.color $edgeColor
        create_ArrowShape $edgeArrowShape
    } 
    if { [string compare $sel USER2 ] == 0 } then { 
###	tixSetSilent $w.directed YES
	set lineStyle SOLID
	tixSetSilent $w.lineStyle $lineStyle
	set lStrength 2
	tixSetSilent $w.lineStrength $lStrength
	set edgeArrowShape NONE
        tixSetSilent $w.arrowShape $edgeArrowShape
	set edgeColor BLACK
	tixSetSilent $w.color $edgeColor
        create_ArrowShape $edgeArrowShape
    }
    if { [string compare $sel USER3 ] == 0 } then { 
###	tixSetSilent $w.directed YES
	set lineStyle DOTTED
	tixSetSilent $w.lineStyle $lineStyle
	set lStrength 2
	tixSetSilent $w.lineStrength $lStrength
	set edgeArrowShape NONE
        tixSetSilent $w.arrowShape $edgeArrowShape
	set edgeColor BLACK
	tixSetSilent $w.color $edgeColor
        create_ArrowShape $edgeArrowShape
    }
    if { [string compare $sel USER4 ] == 0 } then { 
###	tixSetSilent $w.directed YES
	set lineStyle SOLID
	tixSetSilent $w.lineStyle $lineStyle
	set lStrength 2
	tixSetSilent $w.lineStrength $lStrength
	set edgeArrowShape NONE
        tixSetSilent $w.arrowShape $edgeArrowShape
	set edgeColor BLACK
	tixSetSilent $w.color $edgeColor
        create_ArrowShape $edgeArrowShape
    }

}

proc create_EdgeLayout { sel } {
    #--------------------------------------------------------------
    # Edge Preview 
    #--------------------------------------------------------------
    global scriptpath
    global lStrength
    global lineStyle
    global edgeColor
    global win_path_for_estyle
    global isDirected
    global edgeArrowShapeDefine
    global win_path_for_layout

    if { [string compare $lineStyle DASHED ] == 0 } then { 
	set dashoption YES
    }
    if { [string compare $lineStyle DOTTED ] == 0 } then { 
	set dashoption YES
    }

    set preview $win_path_for_estyle.right.frame1.preview.border.frame
    set c $preview.canvas1
    # Test ob Canvas vorhanden, wenn ja, Arrow zeichnen
    catch {$c delete arrow ; return 0 } error_code
    if { $error_code == 0 } then { 
	if { $isDirected(.frame0.canvas2) == "YES" } {
	    if { [string compare $lineStyle SOLID ] == 0 } then { 
		$c create line 110 10 110 120 -width $lStrength -arrow both -arrowshape $edgeArrowShapeDefine -tag arrow -fill $edgeColor
		$c create line 10 40 130 40 -width $lStrength -arrow last -arrowshape $edgeArrowShapeDefine -tag arrow -fill $edgeColor
	    } else {
		$c create line 110 10 110 120 -width $lStrength -arrow both -arrowshape $edgeArrowShapeDefine -tag arrow -fill $edgeColor -dash $dashoption
		$c create line 10 40 130 40 -width $lStrength -arrow last -arrowshape $edgeArrowShapeDefine -tag arrow -fill $edgeColor -dash $dashoption
	    }
	} else {
	    if { [string compare $lineStyle SOLID ] == 0 } then { 
		$c create line 110 10 110 120 -width $lStrength -arrow none -stipple gray50 -capstyle round -tag arrow -fill $edgeColor
		$c create line 10 40 130 40 -width $lStrength -arrow none -stipple gray50 -capstyle round -tag arrow -fill $edgeColor
	    } else {
		$c create line 110 10 110 120 -width $lStrength -arrow none -stipple gray50 -capstyle round -tag arrow -fill $edgeColor -dash $dashoption
		$c create line 10 40 130 40 -width $lStrength -arrow none -stipple gray50 -capstyle round -tag arrow -fill $edgeColor -dash $dashoption
	    }
	}
	MainTextFont $win_path_for_layout
    }

}


return ok
