###############################################################################
#
# setGraph.tcl
# 
# 
# Erzeugung der Notebook-Seite fuer Graph Settings
#
#
###############################################################################


proc createPage_Graph {main_window} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_nodetype

    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w [$main_window.nb subwidget graph]

    #--------------------------------------------------------------
    # Hilfsvariable - kein Knotentyp gesetzt
    #--------------------------------------------------------------
    set h1 "not_yet"

    #--------------------------------------------------------------
    # Container fuer gesamtes Tab
    #--------------------------------------------------------------
    frame $w.top -border 1

    #--------------------------------------------------------------
    # Rahmen linke Seite
    #--------------------------------------------------------------
    set left $w.top
    $left config -border 1 -relief ridge

    #--------------------------------------------------------------
    #build list of all types:
    #--------------------------------------------------------------
    set allAttr " "
    # da muss ein Space Stehen !!!!
    foreach ent $typeList {
	foreach attr $typeArray($ent,LISTATTR) {
	    set attr [string trimright $attr "|YES"]
	    set attr [string trimright $attr "|NO"]
	    if { [string first " $attr " $allAttr] == -1 && [string first NodeNumber $attr] == -1 } { set allAttr "$allAttr$attr " }
	}
    }
    set allAttr [lsort $allAttr]
    set allAttr "$allAttr None "

    #--------------------------------------------------------------
    # Icon Attribut
    #--------------------------------------------------------------
    tixComboBox $left.iconAttr -label "Icon Attribute:" -dropdown true \
	-command iconAttr:select_attr -editable false  \
	-options { listbox.height 8   label.width 19   label.anchor w }

    foreach attr $allAttr { $left.iconAttr insert end $attr }
    tixSetSilent $left.iconAttr $typeArray(ICONATTR);

    #--------------------------------------------------------------
    # Visibility Attribut
    #--------------------------------------------------------------
    tixComboBox $left.visiAttr -label "Visibility Attribute:" -dropdown true \
	-command visiAttr:select_attr -editable false  \
	-options { listbox.height 8   label.width 19   label.anchor w }
    foreach attr $allAttr { if {[string first NodeType $attr] == -1} {$left.visiAttr insert end $attr } }
    tixSetSilent $left.visiAttr $typeArray(VISIATTR);    
    
    #--------------------------------------------------------------
    # Visibility Wert
    #--------------------------------------------------------------
    tixLabelEntry $left.visiValue -label "Visibility Value:" \
	-options { entry.width 20    label.width 19    label.anchor w    entry.textVariable  visi_value } 
    set visi_value $typeArray(VISIATTRVALUE) 


    #--------------------------------------------------------------
    # now do some packing
    #--------------------------------------------------------------
    #pack $w.top -side top -fill both -expand yes
    pack $left -side top  -expand yes -fill both -padx 4
    pack $left.iconAttr  -side top -anchor w
    pack $left.visiAttr  -side top -anchor w
    pack $left.visiValue -side top -anchor w    

}

proc visiAttr:select_attr { selection } {
    #--------------------------------------------------------------
    # Visibility-Attribut speichern
    #--------------------------------------------------------------
    global typeArray
    set typeArray(VISIATTR) $selection
}

proc iconAttr:select_attr { selection } {
    #--------------------------------------------------------------
    # Icon-Attribut speichern
    #--------------------------------------------------------------
    global typeArray
    set typeArray(ICONATTR) $selection
}

return ok