###############################################################################
#
# setLayout.tcl
# 
# 
# Erzeugung der Notebook-Seite fuer Layout
#
#
###############################################################################

proc createPage_Layout {} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree

    # globals dynamite layouter

    global dyn_module
    global dyn_input
    global dyn_output   
    global dyn_in_edge  
    global dyn_out_edge 
    global dyn_c_flow   
    global dyn_d_flow   
    global dyn_xdistance
    global dyn_ydistance
    global dyn_paradiff 

    # globals sugiyama II layouter

    global sug_xoffset
    global sug_yoffset
    global sug_zoffset
    global sug_xdistance
    global sug_ydistance
    global sug_zdistance
    global sug_edgepoint_offset
    global sug_crossing
    global sug_quality
    global sug_dim
    global sug_use_startnode
    global sug_use_endnodes
    global sug_use_grid
    global sug_leafs_down
    global sug_deterministic
    global sug_keep_edgepoints

    ##############################################################################

    #### get Layout-Settings  #####################################################

    #### dynamite

    set dyn_module    [dyn_getValue "<TaskNid>"]
    set dyn_input     [dyn_getValue "<InputNid>"]
    set dyn_output    [dyn_getValue "<OutputNid>"]
    set dyn_in_edge   [dyn_getValue "<InKante>"]
    set dyn_out_edge  [dyn_getValue "<OutKante>"]
    set dyn_c_flow    [dyn_getValue "<CFlow>"]
    set dyn_d_flow    [dyn_getValue "<DFlow>"]
    set dyn_xdistance [dyn_getValue "<xDid>"]
    set dyn_ydistance [dyn_getValue "<yDid>"]
    set dyn_paradiff  [dyn_getValue "<parid>"]


    #### sugiyama

    set sug_xoffset         [sug_getValue "<off0>"]
    set sug_yoffset         [sug_getValue "<off1>"]
    set sug_zoffset         [sug_getValue "<off2>"]
    set sug_xdistance       [sug_getValue "<xDis>"]
    set sug_ydistance       [sug_getValue "<yDis>"]
    set sug_zdistance       [sug_getValue "<zDis>"]
    set sug_use_startnode   [sug_getValue "<Start>"]
    set sug_use_endnodes    [sug_getValue "<End>"]
    set sug_use_grid        [sug_getValue "<grid>"]
    set sug_leafs_down      [sug_getValue "<leav>"]
    set sug_deterministic   [sug_getValue "<det>"]
    set sug_keep_edgepoints [sug_getValue "<keep>"]
    set sug_edgepoint_offset  [sug_getValue "<dummy0>"]
    set sug_quality           [sug_getValue "<Iter1>"]
    set sug_dim               [sug_getValue "<dim>"]
    set sug_crossing          [sug_getValue "<same>"]

    #--------------------------------------------------------------
    # Create page Layout                                         
    #--------------------------------------------------------------
    
    set w [$main_window.nb subwidget layout]

    #-----------

   
    set top [frame $w.f ]
    set box [tixButtonBox $w.b ]

    pack $box -side bottom -fill both
    pack $top -side top -fill both -expand yes
    

    #----------------------------------------------------------------------
    # Create the ListNoteBook (with nice icons)
    #----------------------------------------------------------------------
    label $top.label1 -text "Default Layout :" -fg blue

    tixListNoteBook $top.n -ipadx 6 -ipady 6

    $top.n subwidget hlist add none      -text "None"        -under 0
    $top.n subwidget hlist add sugi      -text "Sugiyama II"        -under 0
    $top.n subwidget hlist add dynamite  -text "Dynamite"           -under 0
    $top.n subwidget hlist add spring   -text "Springembedder"      -under 0

    $top.n add none      -raisecmd listNoteBook:none_raised
    $top.n add sugi      -raisecmd listNoteBook:sugi_raised
    $top.n add dynamite  -raisecmd listNoteBook:dyna_raised
    $top.n add spring    -raisecmd listNoteBook:spri_raised

    #
    # Create the widgets inside the two pages
    
    # We use these options to set the sizes of the subwidgets inside the
    # notebook, so that they are well-aligned on the screen.
    #
    set name [tixOptionName $w]
    option add *$name*TixControl*entry.width 10
    option add *$name*TixControl*label.width 18
    option add *$name*TixControl*label.anchor e

    set f [$top.n subwidget none]
    frame $f.frame1
    pack $f.frame1 -side left -padx 10 -pady 0 -anchor ne

    set f [$top.n subwidget dynamite]
    frame $f.frame1
    frame $f.frame2
    set f $f.frame1


 # dynamite ---->>

  # ---- COMBO BOX module ---- >>>
    
    
    tixComboBox $f.module -label "Module: " -dropdown true \
	-editable true -variable dyn_module \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO BOX input ---- >>>


    tixComboBox $f.input -label "Input: " -dropdown true \
	-editable true -variable dyn_input \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO BOX output ---- >>>


    tixComboBox $f.output -label "Output: " -dropdown true \
	-editable true -variable dyn_output \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}

    # ---- COMBO BOX c_flow ---- >>>


    tixComboBox $f.c_flow -label "C - Flow: " -dropdown true \
	-editable true -variable dyn_c_flow \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO BOX d_flow ---- >>>


    tixComboBox $f.d_flow -label "D - Flow: " -dropdown true \
	-editable true -variable dyn_d_flow \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO BOX in_edge ---- >>>


    tixComboBox $f.in_edge -label "In - Edge: " -dropdown true \
	-editable true -variable dyn_in_edge \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO BOX out_edge ---- >>>


    tixComboBox $f.out_edge -label "Out - Edge: " -dropdown true \
	-editable true -variable dyn_out_edge \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}

    # ---- Scale xDistance  ---- >>> 

    label $f.label_whitespace

    tixControl $f.scale_xDistance2 -label "xDistance: " -integer true \
	-variable dyn_xdistance -min 2 -max 200 \
	-options { entry.width 10 label.width 17 label.anchor n label.pady 5}

    # ---- Scale yDistance  ---- >>> 
   
    tixControl $f.scale_yDistance2 -label "yDistance: " -integer true \
	-variable dyn_ydistance -min 2 -max 200 \
	-options { entry.width 10 label.width 17 label.anchor n label.pady 5}

    # ---- Scale ParaDiff  ---- >>> 
   
    tixControl $f.scale_ParaDiff2 -label "ParaDiff: " -integer true \
	-variable dyn_paradiff -min 2 -max 200 \
	-options { entry.width 10 label.width 17 label.anchor n label.pady 5}

    # packing
    set f [$top.n subwidget dynamite]
    pack $f.frame1 $f.frame2 -side left -padx 10 -pady 0 -anchor ne
    set f $f.frame1

    pack $f.module -side top -anchor w
    pack $f.input  -side top -anchor w
    pack $f.output  -side top -anchor w
    pack $f.c_flow  -side top -anchor w
    pack $f.d_flow  -side top -anchor w
    pack $f.in_edge  -side top -anchor w
    pack $f.out_edge  -side top -anchor w 

    pack $f.label_whitespace                 -pady 1
    pack $f.scale_xDistance2 -side top -pady 0 -anchor w
    pack $f.scale_yDistance2 -side top -pady 0 -anchor w
    pack $f.scale_ParaDiff2  -side top -pady 0 -anchor w


# ----------------------------------------------------------------------------------------------------------------------------------------------

# ---- SUGIYAMA ---- >>> 

    set f [$top.n subwidget sugi]
    frame $f.frame1
    frame $f.frame2
    set f $f.frame1

    label $f.label_whitespace -text { }

  # ---- COMBO BOX xoffset ---- >>>
    
    
    tixComboBox $f.xoffset -label "X-Offset: " -dropdown true -variable sug_xoffset \
	-editable true \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO BOX yoffset ---- >>>


    tixComboBox $f.yoffset -label "Y-Offset: " -dropdown true -variable sug_yoffset \
	-editable true \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO BOX zoffset ---- >>>


    tixComboBox $f.zoffset -label "Z-Offset: " -dropdown true -variable sug_zoffset \
	-editable true \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}

    # ---- COMBO BOX xdistance ---- >>>


    tixComboBox $f.xdistance -label "X - Distance: " -dropdown true  -variable sug_xdistance \
	-editable true \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO Box ydistance ---- >>>


    tixComboBox $f.ydistance -label "Y - Distance: " -dropdown true -variable sug_ydistance \
	-editable true \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- COMBO Box zdistance ---- >>>


    tixComboBox $f.zdistance -label "Z - Distance: " -dropdown true   -variable sug_zdistance \
	-editable true \
	-options {
	    listbox.height 4
	    entry.width 10
	    label.padY 5
	    label.width 17
	    label.anchor n
	}


    # ---- CHOICES FOR COMBO BOXES ---- >>> 

    # ---- PRESETS FOR COMBO BOXES ---- >>> 

    # ---- Edgepoint Offset ---- >>> 


    tixControl $f.scale_edgepoint_offset2 -label "Edgepoint Offset: " -integer true \
	-variable sug_edgepoint_offset -min 2 -max 200 \
	-options { entry.width 10 label.width 17 label.anchor n}

    # ---- Quality  ---- >>> 
   
    tixControl $f.scale_quality2 -label "Quality: " -integer true \
	-variable sug_quality -min 1 -max 15 \
	-options { entry.width 10 label.width 17 label.anchor n}


    # ---- Parameters ---- >>> 

    set f [$top.n subwidget sugi]
    set f $f.frame2

    label $f.label_global -text {Global:}

  radiobutton $f.3dlayout \
    -foreground {black} \
    -text {3D layout} \
    -variable {sug_dim} \
    -value {3}

  radiobutton $f.2dlayout \
    -foreground {black} \
    -text {2D layout} \
    -variable {sug_dim} \
    -value {2}

  checkbutton $f.use_startnode \
    -foreground {black} \
    -text {use startnode} \
    -variable {sug_use_startnode}

  checkbutton $f.use_endnodes \
    -foreground {black} \
    -text {use end-nodes} \
    -variable {sug_use_endnodes}

  checkbutton $f.use_grid \
    -foreground {black} \
    -text {use grid} \
    -variable {sug_use_grid}

  checkbutton $f.leafs_down \
    -foreground {black} \
    -text {leaves down} \
    -variable {sug_leafs_down}

  checkbutton $f.deterministic\
    -foreground {black} \
    -text {deterministic} \
    -variable {sug_deterministic}

    # ---- Reduce Crossing   ---- >>> 

  label $f.label_reduce_crossing -text {Reduce Crossing:}

  radiobutton $f.adjazenzmatrix \
    -foreground {black} \
    -text {Adjazenzmatrix} \
    -variable {sug_crossing} \
    -value {0} 


  radiobutton $f.bubbling \
    -foreground {black} \
    -text {Bubbling} \
    -variable {sug_crossing} \
    -value {1} 


  label $f.label_local -text {Local:}

  checkbutton $f.keep_edgepoints \
    -foreground {black} \
    -text {keep edgepoints} \
    -variable {sug_keep_edgepoints}

    set f [$top.n subwidget sugi]
    pack $f.frame1 $f.frame2 -side left -padx 10 -pady 0 -anchor ne
    set f $f.frame1

    pack $f.xoffset    -side top -anchor w
    pack $f.yoffset    -side top -anchor w
    pack $f.zoffset    -side top -anchor w
    pack $f.xdistance  -side top -anchor w
    pack $f.ydistance  -side top -anchor w
    pack $f.zdistance  -side top -anchor w

    pack $f.label_whitespace -side top -anchor w -pady 1

    pack $f.scale_edgepoint_offset2            -side top -pady 0 -anchor w
    pack $f.scale_quality2                     -side top -pady 0 -anchor w

    set f [$top.n subwidget sugi]
    set f $f.frame2

    pack $f.label_global              -side top -anchor w -padx 12
   
    pack $f.3dlayout                  -side top -anchor w -padx 12
    pack $f.2dlayout                  -side top -anchor w -padx 12
    pack $f.use_startnode             -side top -anchor w -padx 12
    pack $f.use_endnodes              -side top -anchor w -padx 12
    pack $f.use_grid                  -side top -anchor w -padx 12
    pack $f.leafs_down                -side top -anchor w -padx 12
    pack $f.deterministic             -side top -anchor w -padx 12
    pack $f.label_reduce_crossing     -side top -anchor w -padx 12
    pack $f.adjazenzmatrix            -side top -anchor w -padx 12
    pack $f.bubbling                  -side top -anchor w -padx 12
    pack $f.label_local               -side top -anchor w -padx 12
    pack $f.keep_edgepoints           -side top -anchor w -padx 12


# ----------------------------------------------------------------------------------------------------------------------------------------------------

# ---- SPRINGEMB. ---- >>> 


    set f [$top.n subwidget spring]

    frame $f.frame1
    frame $f.frame2
    pack $f.frame1 $f.frame2 -side left -padx 10 -pady 0 -anchor ne
    set f $f.frame2

    label $f.label_global -text {Global:}


  checkbutton $f.animate \
    -background {lightgrey} \
    -activebackground {gainsboro} \
    -command {recall animate} \
    -foreground {black} \
    -text {Animate} \
    -variable {a}


  checkbutton $f.layout \
    -background {lightgrey} \
    -activebackground {gainsboro} \
    -command {recall toggle3D} \
    -foreground {black} \
    -text {3D Layout} \
    -variable {b}

  checkbutton $f.edge \
    -background {lightgrey} \
    -activebackground {gainsboro} \
    -command {recall setEdgeWeight} \
    -foreground {black} \
    -text {Use Edgeweight} \
    -variable {c}


    pack $f.label_global     -side top -anchor w -padx 12
   
    pack $f.animate          -side top -anchor w -padx 12
    pack $f.layout           -side top -anchor w -padx 12
    pack $f.edge             -side top -anchor w -padx 12


    # ---- COMBO BOX xoffset ---- >>>
    
    set f [$top.n subwidget spring]
    set f $f.frame1
    
    tixComboBox $f.xoffset -label "X Offset: " -dropdown true -editable true \
	-options {
	    listbox.height 4
	    label.padY 3
	    label.width 10
	    label.anchor n
	}


    # ---- COMBO BOX yoffset ---- >>>


    tixComboBox $f.yoffset -label "Y Offset: " -dropdown true -editable true \
	-options {
	    listbox.height 4
	    label.padY 3
	    label.width 10
	    label.anchor n
	}


    # ---- COMBO BOX zoffset ---- >>>


    tixComboBox $f.zoffset -label "Z Offset: " -dropdown true -editable true \
        -options {
	    listbox.height 4
	    label.padY 3
	    label.width 10
	    label.anchor n
	}

    # ---- COMBO BOX distance ---- >>>


    tixComboBox $f.distance -label "Distance: " -dropdown true  -editable true\
	-options {
	    listbox.height 4
	    label.padY 3
	    label.width 10
	    label.anchor n
	}

    

    pack $f.xoffset      -side top -anchor w
    pack $f.yoffset      -side top -anchor w
    pack $f.zoffset      -side top -anchor w
    pack $f.distance     -side top -anchor w




    # ---- CHOICES FOR COMBO BOXES ---- >>> 



#    set list {a b c d e f g h}
    
#    foreach cut $list {$f.xoffset insert end $cut}
#    $f.xoffset insert end NULL



    # ---- PRESETS FOR COMBO BOXES ---- >>> 


#    tixSetSilent $f.xoffset unbekannt
#    tixSetSilent $f.yoffset unbekannt


    # ---- Scale xDistance  ---- >>> 

    label $f.label_whitespace
    pack $f.label_whitespace -pady 3


    label $f.label_iterations               -text {Iterations}
    scale $f.scale_iterations               -background {gainsboro} -foreground {black} -from {200} -orient {horizontal} -relief {raised} -to {2000} \
				                -variable V_xDistance

    pack $f.label_iterations                  -pady 3 -expand no
    pack $f.scale_iterations -fill x -padx 10 -pady 0 -expand no
#    pack $f.scale_iterations -padx 10 -pady 0 -expand no -anchor w


    # ---- Scale yDistance  ---- >>> 
   
    label $f.label_iterations_p_Animations  -text {Iterations per Animation}
    scale $f.scale_iterations_p_Animations  -background {gainsboro} -foreground {black} -from {2} -orient {horizontal} -relief {raised} -to {30} \
				            -variable V_yDistance
#@    pack $f.label_whitespace                -pady 3
    pack $f.label_iterations_p_Animations   -pady 3 -expand no
    pack $f.scale_iterations_p_Animations   -fill x -padx 10 -pady 0 -expand no
#    pack $f.scale_iterations_p_Animations   -padx 10 -pady 0 -expand no -anchor w

    # ---- .... ---- >>> 

# ---------------------

    pack $top.label1 -side top -padx 8 -anchor w
    pack $top.n -side top -expand yes -fill both -padx 5 -pady 5

    # Page gemaess gespeicherten Einstellungen anzeigen
    if {[string compare $typeArray(DEFLAYOUT) "None"] == 0} {
	$top.n raise none
    }
    if {[string compare $typeArray(DEFLAYOUT) "Sugiyama"] == 0} {
	$top.n raise sugi
    }
    if {[string compare $typeArray(DEFLAYOUT) "DynamiteLayout"] == 0} {
	$top.n raise dynamite
    }
    if {[string compare $typeArray(DEFLAYOUT) "Springembedder"] == 0} {
	$top.n raise spring
    }

#-----------
    ### End page Layout

}

proc dynamite:update { dummy } {

    global typeArray
    global dyn_module
    global dyn_input
    global dyn_output
    global dyn_c_flow
    global dyn_d_flow
    global dyn_in_edge
    global dyn_out_edge
    global dyn_xdistance
    global dyn_ydistance
    global dyn_paradiff


    set adummy  {<TaskNid>}
    set bdummy {:<InputNid>}
    set cdummy {:<OutputNid>}
    set ddummy {:<CFlow>}
    set edummy {:<DFlow>}
    set fdummy {:<xDid>}
    set gdummy {:<yDid>}
    set hdummy {:<parid>}
    set idummy {:<InKante>}
    set jdummy {:<OutKante>}
    set kdummy {:}
    
    append dummy $adummy $dyn_module $bdummy $dyn_input $cdummy $dyn_output $ddummy $dyn_c_flow $edummy $dyn_d_flow $fdummy $dyn_xdistance \
                 $gdummy $dyn_ydistance $hdummy $dyn_paradiff $idummy $dyn_in_edge $jdummy $dyn_out_edge $kdummy
    set typeArray(DYNALAYOUT) $dummy

}


proc sugiyama:update { dummy } {


    global typeArray
    global sug_xoffset
    global sug_yoffset
    global sug_zoffset
    global sug_xdistance
    global sug_ydistance
    global sug_zdistance
    global sug_edgepoint_offset
    global sug_quality
    global sug_crossing
    global sug_dim
    global sug_use_startnode
    global sug_use_endnodes
    global sug_use_grid
    global sug_leafs_down
    global sug_deterministic
    global sug_keep_edgepoints

    set adummy  {<Iter1>}
    set bdummy {:<Iter2>}
    set cdummy {:<xDis>}
    set ddummy {:<yDis>}
    set edummy {:<zDis>}
    set fdummy {:<Start>}
    set gdummy {:<End>}
    set hdummy {:<keep>}
    set idummy {:<same>}
    set jdummy {:<grid>}
    set kdummy {:<dummy0>}
    set ldummy {:<off0>}
    set mdummy {:<off1>}
    set ndummy {:<off2>}
    set odummy {:<dim>}
    set pdummy {:<leav>}
    set qdummy {:<det>}
    set rdummy {:}
    
    append dummy $adummy $sug_quality $bdummy "0" $cdummy $sug_xdistance $ddummy $sug_ydistance $edummy $sug_zdistance $fdummy $sug_use_startnode \
                 $gdummy $sug_use_endnodes $hdummy $sug_keep_edgepoints $idummy "0" $jdummy $sug_use_grid $kdummy $sug_edgepoint_offset \
                 $ldummy $sug_xoffset $mdummy $sug_yoffset $ndummy $sug_zoffset $odummy $sug_dim $pdummy $sug_leafs_down $qdummy $sug_deterministic $rdummy


    set typeArray(SUGILAYOUT) $dummy

}



proc sug_getValue {index} {

    global typeArray

    set  dummy $typeArray(SUGILAYOUT)

    set dummy_length [string length $dummy]
    set cut_index [string first $index $dummy]
    set offset [string length $index]
    set cut_position_left [expr $cut_index + $offset]

    # cut off -> "value:" at first position of string 

    set dummy [string range $dummy $cut_position_left $dummy_length]
    set cut_index [string first ":" $dummy]
    set dummy [string range $dummy 0 [expr $cut_index-1]]

    return $dummy

}

proc dyn_getValue {index} {

    global typeArray

    set  dummy $typeArray(DYNALAYOUT)

    set dummy_length [string length $dummy]
    set cut_index [string first $index $dummy]
    set offset [string length $index]
    set cut_position_left [expr $cut_index + $offset]

    # cut off -> "value:" at first position of string 

    set dummy [string range $dummy $cut_position_left $dummy_length]
    set cut_index [string first ":" $dummy]
    set dummy [string range $dummy 0 [expr $cut_index-1]]

    return $dummy

}

proc stdLayout:select_layout { selection } {
    global typeArray
    set typeArray(DEFLAYOUT) $selection
}

proc listNoteBook:none_raised {} {
    stdLayout:select_layout None
}

proc listNoteBook:sugi_raised {} {
    stdLayout:select_layout Sugiyama
}

proc listNoteBook:dyna_raised {} {
    stdLayout:select_layout DynamiteLayout
}

proc listNoteBook:spri_raised {} {
    stdLayout:select_layout Springembedder
}

return ok