###############################################################################
#
# setNode.tcl
# 
# 
# Erzeugung der Notebook-Seite fuer Nodes
#
# Die Inhalte der einzelnen Tabs werden in createPage... definiert
# Jede Definition steht zwecks Uebersichtlichkeit mit den dazugehoerigen 
# Prozeduren in einem eigene Skript.
#
# setAttributes.tcl
# setNodeType.tcl
# setNodeStyle.tcl
#
###############################################################################

proc createPage_Nodes { } {
    global typeList
    global actualType
    global main_window
    global win_path_for_tree
    global win_path_for_types
    global typeArray
    global h1
    global nodeDisplay
    global srcEdgeType
    global trgEdgeType
    global selectedType
    global applyPropagation

    set h1 "not yet"
    #--------------------------------------------------------------
    # Fenster des Tabs nodeType ermitteln
    #--------------------------------------------------------------
    set w [$main_window.nb subwidget nodes]

    #--------------------------------------------------------------
    # Container-Rahmen
    #--------------------------------------------------------------
    frame $w.top -border 1
    pack $w.top -side top -fill both -expand yes
#@    pack $w.top -side top -fill both -expand no

    #--------------------------------------------------------------
    # Rahmen fuer die linke Seite
    #--------------------------------------------------------------
    set left [frame $w.top.left]
    $left config -border 1 -relief ridge
#@    pack $left -side left  -expand no -fill both -padx 1
    pack $left -side left  -expand yes -fill both -padx 1
    set win_path_for_tree $left

    #--------------------------------------------------------------
    # Notebook fuer Klassen/Typen aufbauen
    #--------------------------------------------------------------
    createNoteBook_Types $left

    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
###    set right [frame $w.top.right]
###    $right config -border 1 -relief ridge
###    pack $right -side left  -expand yes -fill both -padx 1
#    set win_path_for_types $right

    #--------------------------------------------------------------
    # Notebook fuer Knoten aufbauen
    #--------------------------------------------------------------
###    createNoteBook_NodeSettings $right


    #--------------------------------------------------------------
    # Initialwert setzen
    #--------------------------------------------------------------

    if { [string compare  "" $selectedType] != 0 } {
	set hlist [$win_path_for_tree.typeTree subwidget hlist]
	$hlist selection set $selectedType
	set tmp $typeArray($actualType,DISPLAY)
	nodeDisplay:set $tmp
	set applyPropagation $typeArray($actualType,APPLYCHANGES)
	togglePropagation
    }
}

proc createNoteBook_Types {w} {
# Notebook fuer Typen und Klassen
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree

#### noteBook #####################################################
#                                                                 #
    set name [tixOptionName $w]
    option add *$name*TixControl*entry.width 10
    option add *$name*TixControl*label.width 18
    option add *$name*TixControl*label.anchor e

    tixNoteBook $w.nb -ipadx 6 -ipady 6

    $w.nb add nclasses  -label "NodeClasses"  -underline 4 -raisecmd nclasses_raise 
    $w.nb add ntypes    -label "NodeTypes"    -underline 0 -raisecmd ntypes_raise
    $w.nb add etypes    -label "EdgeTypes"    -underline 0 -raisecmd etypes_raise

#@    pack $w.nb -expand no -fill both -padx 0 -pady 0 -side top
    pack $w.nb -expand yes -fill both -padx 0 -pady 0 -side top
    
#                                                                 #
#### noteBook #####################################################

#### pages ########################################################
#                                                                 #

    #--------------------------------------------------------------
    # Create page NodeTypes                                       =
    #--------------------------------------------------------------
    createPage_NodeTypes $w

    #--------------------------------------------------------------
    # Create page NodeClasses                                     =
    #--------------------------------------------------------------
    createPage_NodeClasses $w

    #--------------------------------------------------------------
    # Create page EdgeTypes                                       =
    #--------------------------------------------------------------
    createPage_EdgeTypes $w

}

proc nclasses_raise {} {
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_nstyle
    global main_window
    global selectedType
    global typeArray
    global actualType
    global c1
    global h1
    global win_path_for_shape
    global applyPropagation
    global nodeDisplay

    set w [$main_window.nb subwidget nodes]
    set w $w.top.left
    set w [$w.nb subwidget nclasses]
    set win_path_for_tree $w.top.left
    set win_path_for_types $w.top.right

    set w [$win_path_for_types.nb subwidget nstyle]
    set win_path_for_nstyle $w.top.right
    set l $w.top.right.frStyles.frStyles

    set w [$win_path_for_types.nb subwidget nbShape]
    set win_path_for_shape $w

    set w [$win_path_for_types.nb subwidget attributes]
    set c1 $w.top.c
    set h1 [$c1 subwidget hlist]

    set w [$win_path_for_types.nb subwidget ntype]
    set win_path_for_types $w.top.right

###    puts "CLASS selectedType: $selectedType actualType: $actualType"

    if { [string compare  "" $selectedType] != 0 } {
	set hlist [$win_path_for_tree.classTree subwidget hlist]
	$hlist selection clear
#@	catch {$hlist selection set $selectedType ; return 0 } error_code
#@	if { $error_code != 0 } then { 
#@	    puts "nothing selected"
#@	}

	select_nodeType $selectedType
	togglePropagation
    }

    $win_path_for_tree.labelType config -text "Selection: $actualType"
    $win_path_for_nstyle.typeVisibility config -state disabled

    set win_path_for_estyle $l
    set preview $l.right.frame1.preview
    set l $preview.border.frame
    set win_path_for_layout $l.canvas1

    update

}

proc ntypes_raise {} {
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_estyle
    global win_path_for_nstyle
    global win_path_for_shape
    global main_window
    global selectedType
    global typeArray
    global actualType
    global c1
    global h1
    global typeList
    global applyPropagation


    set w [$main_window.nb subwidget nodes]
    set w $w.top.left

    set w [$w.nb subwidget ntypes] 
    set win_path_for_tree $w.top.left
    set win_path_for_types $w.top.right

    set w [$win_path_for_types.nb subwidget nstyle]
    set win_path_for_nstyle $w.top.right
#@    set l $w.top.right.frStyles.frStyles

    set w [$win_path_for_types.nb subwidget nbShape]
    set win_path_for_shape $w

    set l $w

    set w [$win_path_for_types.nb subwidget attributes]
    set c1 $w.top.c
    set h1 [$c1 subwidget hlist]

    set w [$win_path_for_types.nb subwidget ntype]
    set win_path_for_types $w.top.right

###    puts "NODE selectedType: $selectedType actualType: $actualType"

    if { [string compare  "" $selectedType] != 0 } {

	set hlist [$win_path_for_tree.typeTree subwidget hlist]
	$hlist selection clear
	catch {$hlist selection set $selectedType ; return 0 } error_code
	if { $error_code != 0 } then { 
###	    puts "nothing selected"
###  - holt erstes Element !!!
	    set type [lindex $typeList 0]
            set text [lindex [split $type \\] end]
	    set selectedType $type
	    catch {$hlist selection set $selectedType ; return 0 } error_code
	    if { $error_code == 0 } then { 
		set actualType $type
		select_nodeType $selectedType
	    }		
	}
	set tmp $typeArray($actualType,DISPLAY)

	nodeDisplay:set $tmp
	set applyPropagation $typeArray($actualType,APPLYCHANGES)
	togglePropagation
    }

    $win_path_for_tree.labelType config -text "Selection: $actualType"
    $win_path_for_nstyle.typeVisibility config -state normal

    set win_path_for_estyle $l
    set preview $l.right.frame1.preview
    set l $preview.border.frame
    set win_path_for_layout $l.canvas1

    update

}

proc etypes_raise {} {
    global win_path_for_estyle
    global main_window

    set w [$main_window.nb subwidget nodes]
    set w $w.top.left

    set e [$w.nb subwidget etypes] 
    set e [$e.top.right.nb subwidget eStyle]
    set win_path_for_estyle $e.top.right.frStyles
    set win_path_for_layout $win_path_for_estyle.right.frame1.preview.border.frame.canvas1
}

proc createPage_EdgeTypes {win} {
    #--------------------------------------------------------------
    # Create page EdgeStyle
    #--------------------------------------------------------------
    set w [$win.nb subwidget etypes]

    #create_edgeTree $w
    createPage_EdgeStyle $w

}

proc createPage_NodeTypes {main_window} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_nstyle
    global applyPropagation
    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w [$main_window.nb subwidget ntypes]
  
    #--------------------------------------------------------------
    # Container-Rahmen
    #--------------------------------------------------------------
    frame $w.top -border 1
#@    pack $w.top -side top -fill both -expand no
    pack $w.top -side top -fill both -expand yes

    #--------------------------------------------------------------
    # Rahmen fuer die linke Seite
    #--------------------------------------------------------------
    set left [frame $w.top.left]
    $left config -border 1 -relief ridge
#@    pack $left -side left  -expand no -fill both -padx 1
    pack $left -side left  -expand yes -fill both -padx 1
    set win_path_for_tree $left

    #--------------------------------------------------------------
    # Listbox mit Knotentypen
    #--------------------------------------------------------------
    create_typeTree $left

    checkbutton $left.propagate -text "Allow Propagation From Supertype" -anchor nw -selectcolor {gold}
    pack $left.propagate -side top -anchor nw -expand no -fill x -pady 0

    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.top.right]
    $right config -border 1 -relief ridge
#@    pack $right -side left  -expand no -fill both -padx 1
    pack $right -side left  -expand yes -fill both -padx 1

    #--------------------------------------------------------------
    # Notebook fuer Knoten aufbauen
    #--------------------------------------------------------------
    createNoteBook_NodeSettings $right

    $left.propagate config -variable applyPropagation -command {togglePropagation}
    set applyPropagation $typeArray($actualType,APPLYCHANGES)

}

proc togglePropagation {} {
    #--------------------------------------------------------------
    #--------------------------------------------------------------
    global typeArray
    global actualType
    global applyPropagation

    set typeArray($actualType,APPLYCHANGES) $applyPropagation

}

proc createPage_NodeClasses {w} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_nstyle

    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w [$w.nb subwidget nclasses]

    #--------------------------------------------------------------
    # Container-Rahmen
    #--------------------------------------------------------------
    frame $w.top -border 1
    pack $w.top -side top -fill both -expand yes

    #--------------------------------------------------------------
    # Rahmen fuer die linke Seite
    #--------------------------------------------------------------
    set left [frame $w.top.left]
    $left config -border 1 -relief ridge
    pack $left -side left  -expand yes -fill both -padx 1
###    set win_path_for_tree $left

    #--------------------------------------------------------------
    # Klassenbaum
    #--------------------------------------------------------------
    create_classTree $left

    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.top.right]
    $right config -border 1 -relief ridge
    pack $right -side left  -expand yes -fill both -padx 1
#    set win_path_for_types $right

    #--------------------------------------------------------------
    # Notebook fuer Knoten aufbauen
    #--------------------------------------------------------------
    createNoteBook_NodeSettings $right

}

proc createNoteBook_NodeSettings {w} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree

#### noteBook #####################################################
#                                                                 #
    set name [tixOptionName $w]
    option add *$name*TixControl*entry.width 10
    option add *$name*TixControl*label.width 18
    option add *$name*TixControl*label.anchor e

    tixNoteBook $w.nb -ipadx 6 -ipady 6
    #$w config -bg gray
    #$w.nb subwidget nbframe config -backpagecolor gray

    $w.nb add nstyle     -label "Appearance"        -underline 0
    $w.nb add attributes -label "Label"             -underline 0
    $w.nb add nbShape    -label "Shape"             -underline 0
    $w.nb add ntype      -label "Context"           -underline 0  -state disabled
    $w.nb add nbPreview  -label "Preview"           -underline 0  -state disabled
##    $w.nb pageconfigure -state disabled

#@    pack $w.nb -expand no -fill both -padx 0 -pady 0 -side top
    pack $w.nb -expand yes -fill both -padx 0 -pady 0 -side top
    
#                                                                 #
#### noteBook #####################################################

#### pages ########################################################
#                                                                 #

    #--------------------------------------------------------------
    # Create page Shape
    #--------------------------------------------------------------
    createPage_Shape $w

    #--------------------------------------------------------------
    # Create page Label
    #--------------------------------------------------------------
    createPage_Attributes $w

    #--------------------------------------------------------------
    # Create page Context                                        
    #--------------------------------------------------------------
    createPage_NodeType $w

    #--------------------------------------------------------------
    # Create page Appearence                                       
    #--------------------------------------------------------------
    createPage_NodeStyle $w

}

proc create_typeTree {w} {
    #--------------------------------------------------------------
    # Klassenbaum erzeugen
    #--------------------------------------------------------------
    global win_path_for_tree
    global typeArray
    global selectedType
    global typeList
    global actualType

#    set left $win_path_for_tree
    set left $w

    #--------------------------------------------------------------
    # Ueberschrift
    #--------------------------------------------------------------
    label $left.labelType -text "Selection:" -fg blue

    if { [winfo exists $left.typeTree] == 1  } { destroy $left.typeTree }
    tixTree $left.typeTree -options { separator "\\" }
 
    set tree $left.typeTree 
    set hlist [$left.typeTree subwidget hlist]

    $hlist config -selectmode single -browsecmd "typeTree:OpenDir $tree" -width 30
    
    #  Add the directories into the TixTree widget (using the
    #  hlist subwidget)

    set selectedType ""

    foreach type  $typeList  { 
	# nur sichtbare Knotentypen anzeigen
#	if { [string first "YES" $typeArray($type,VISI)] != -1 } { 
            set text [lindex [split $type \\] end]
	    $hlist add $type -itemtype imagetext \
	      -text $text -image [tix getimage file]
	    set selectedType $type
#	    }
    }

    set actualType $selectedType
    $tree autosetmode

    pack $left.labelType -side top -padx 2
    pack $left.typeTree -expand yes -fill both -padx 4 -pady 4 -side top -anchor w
    $left.labelType config -text "Selection: $actualType"
}

proc create_classTree {w} {
    #--------------------------------------------------------------
    # Klassenbaum erzeugen
    #--------------------------------------------------------------
    global win_path_for_tree
    global typeArray
    global selectedType
    global typeList
    global actualType
    global applyPropagation
    global classList

#    set left $win_path_for_tree
    set left $w

    #--------------------------------------------------------------
    # Ueberschrift
    #--------------------------------------------------------------
    label $left.labelType -text "Selection:" -fg blue

    if { [winfo exists $left.classTree] == 1  } { destroy $left.classTree }
    tixTree $left.classTree -options { separator "\\" }
 
    set tree $left.classTree 
    set hlist [$left.classTree subwidget hlist]
    $hlist config -selectmode single -browsecmd "classTree:OpenDir $tree" -width 30
    
    #  Add the directories into the TixTree widget (using the
    #  hlist subwidget)

###    set selectedType ""


#    puts "Start der Liste"
#    puts "==============="
#    puts "classList: $classList"
#    puts "Ende der Liste"
#    puts "=============="

    foreach type $classList {
	set text [lindex [split $type "\\"] end]

	if {[string last ".typ" $text] == -1} {
	    $hlist add $type -itemtype imagetext -text $text -image [tix getimage folder]
	} else {
	    set text [lindex [split $text "."] 0]
	    $hlist add $type -itemtype imagetext -text $text -image [tix getimage file]
###	    set selectedType $text
	}
    }

###    set actualType $selectedType
    $tree autosetmode

    global hideTypes
    set hideTypes 1

    checkbutton $left.hideTypes -text "Show Types" -anchor nw -selectcolor {gold} \
      -command {toggleHideTypes} -variable {hideTypes}

    checkbutton $left.propagate -text "Allow Propagation From Superclass" -anchor nw -selectcolor {gold}

    set applyPropagation $typeArray($actualType,APPLYCHANGES)

    pack $left.labelType -side top -padx 2
    pack $left.classTree -expand yes -fill both -padx 4 -pady 4 -side top -anchor w
    pack $left.hideTypes -side top -anchor nw -expand no -fill x -pady 0
    pack $left.propagate -side top -anchor nw -expand no -fill x -pady 0
    $left.propagate config -variable applyPropagation -command togglePropagation
    $left.labelType config -text "Selection: $actualType"

}

proc toggleHideTypes {} {
    #--------------------------------------------------------------
    # Toggeln der Anzeige der Knotentypen im Klassenbaum
    #--------------------------------------------------------------
    global main_window
### w besser gestalten !!! z.B. win_path_for_classes ...
    set w [$main_window.nb subwidget nodes]
    set w [$w.top.left.nb subwidget nclasses]
    set w $w.top.left

    global hideTypes
    global classList

    set hlist [$w.classTree subwidget hlist]

    if { $hideTypes == 1  } { 
	foreach type $classList {
	    if {[string last ".typ" $type] != -1} {
		$hlist show entry $type
	    }
	}
    } else {
	foreach type $classList {
	    if {[string last ".typ" $type] != -1} {
		$hlist hide entry $type
	    }
	}
    }
}

proc typeTree:OpenDir {tree dir} {
    global win_path_for_tree
    global selectedType

    #--------------------------------------------------------------
    # Typenbaum aufbauen
    #--------------------------------------------------------------

    set hlist [$tree subwidget hlist]
    set tmpListe [split $dir "\\"]
    set text [lindex $tmpListe end]

    set selectedType $text
    select_nodeType $text

    $win_path_for_tree.labelType config -text "Selection: $selectedType"
    update

}

proc selectTypeVisibility {} {
    global selectedType
    global typeArray
    global typeVisible
    global win_path_for_nstyle

    if { [string first "YES" $typeArray($selectedType,VISI)] != -1 } { 
	set typeVisible 1
	$win_path_for_nstyle.typeVisibility select
    } else {
	set typeVisible 0
	$win_path_for_nstyle.typeVisibility deselect
    }    
}

proc classTree:OpenDir {tree dir} {
    global win_path_for_tree
    global win_path_for_nstyle
    global selectedType
    #--------------------------------------------------------------
    # Klassenbaum aufbauen
    #--------------------------------------------------------------
    set hlist [$tree subwidget hlist]
    set tmpListe [split $dir "\\"]
    set text [lindex $tmpListe end]

    # in text steht der Name von Klasse/Typ
    # nutzbar fuer Ermittlung Unterklassen/-typen

    # Test, ob Klasse oder Typ, je nachdem wird Kontrolle TypeVisibility de-/aktiviert
    set i [string first ".typ" $text]
    if {$i != -1} {
	$win_path_for_nstyle.typeVisibility config -state normal
    } else {
	$win_path_for_nstyle.typeVisibility config -state disabled
    }
    # Knotentyp hat Endung '.typ' - Text splitten
    set text [lindex [split $text "."] 0]
    set selectedType $text
    select_nodeType $text

    # aktuelle Selektion anzeigen
    $win_path_for_tree.labelType config -text "Selection: $selectedType"
    update

}

proc select_nodeType {s} {
    # select node type
    global nodeStyle
    global nodeDisplay
    global applyChanges
    global applyPropagation
    global srcEdgeType
    global trgEdgeType
    global typeArray
    global actualType
    global h1
    global c1

    if {[string compare $s ""] != 0} {
	set actualType $s

#@	set nodeStyle $typeArray($s,STYLE)
	style:set $typeArray($s,STYLE)

#@	set nodeDisplay $typeArray($s,DISPLAY)
	nodeDisplay:init $typeArray($s,DISPLAY)

	set applyPropagation $typeArray($s,APPLYCHANGES)
	# Typsichtbarkeit anzeigen
	selectTypeVisibility
	
	if { [string compare $h1 "not_yet"] != 0 } {
	    $h1 del all
	    if { [string compare $typeArray($actualType,LISTATTR)  ""] != 0 } {
		set typeArray($actualType,LISTATTR) [lsort  $typeArray($actualType,LISTATTR)]
		foreach ent  $typeArray($actualType,LISTATTR)  {
		    set dispEnt [string trimright $ent "|YES"]
		    set dispEnt [string trimright $dispEnt "|NO"]
		    $h1 add $dispEnt  -itemtype imagetext -text $dispEnt
		    if { [string first "|YES" $ent] != -1 } { $c1 setstatus $dispEnt on } else { $c1 setstatus $dispEnt off }
		}
	    }
	}
    }
}

return ok
