###############################################################################
#
# setNodeStyle.tcl
# 
# 
# Erzeugung der Notebook-Seite fuer NodeStyle
#
#
###############################################################################
 
proc createPage_NodeStyle {win} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_nstyle
    global boxFont
### durch BorderThickness ersetzen !!!
    global nClassStrength 
    global typeVisible
    global allAttr

    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w [$win.nb subwidget nstyle]

    frame $w.top 
    pack $w.top -side top -fill both -expand yes -anchor nw

    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.top.right]
    $right config -border 1 -relief ridge
    pack $right -side top  -expand yes -fill both -padx 4

    # Container fuer Styles
    set win_path_for_nstyle $right


    #--------------------------------------------------------------
    # Rahmen fuer die Buttons
    #--------------------------------------------------------------
###    frame $right.frButtons 
###    pack $right.frButtons -side top  -expand no -fill x -padx 4



    #--------------------------------------------------------------
    # Visibility
    #--------------------------------------------------------------
    checkbutton $right.typeVisibility -text "TypeVisible" -anchor nw \
      -variable {typeVisible} -command {toggleTypeVisibility} -selectcolor {gold}
    pack $right.typeVisibility  -side top -anchor nw
    if { [string first "YES" $typeArray($actualType,VISI)] != -1 } { set $typeVisible "1" } else { set $typeVisible "0" }

    #--------------------------------------------------------------
    # Rahmen fuer Visibility
    #--------------------------------------------------------------
    frame $right.frVisibility
    pack $right.frVisibility -side top -expand no -fill x -padx 4
    set left  $right.frVisibility

    #--------------------------------------------------------------
    #build list of all attributes:
    #--------------------------------------------------------------
#@

    #--------------------------------------------------------------
    # Visibility Attribut
    #--------------------------------------------------------------
    tixComboBox $left.visiAttr -label "Visibility Attribute:" -dropdown true \
	-command visiAttr:select_attr -editable false  \
	-options { listbox.height 8  listbox.width 10  label.width 20   label.anchor w }
    foreach attr $allAttr { if {[string first NodeType $attr] == -1} {$left.visiAttr insert end $attr } }
    tixSetSilent $left.visiAttr $typeArray(VISIATTR);    
    $left.visiAttr subwidget listbox config -width 10
    
    #--------------------------------------------------------------
    # Visibility Wert
    #--------------------------------------------------------------
    tixLabelEntry $left.visiValue -label " Value:" \
	-options { entry.width 5    label.width 6    label.anchor e    entry.textVariable  visi_value } 
    set visi_value $typeArray(VISIATTRVALUE) 

    pack $left.visiAttr $left.visiValue -side left -anchor nw -expand no -pady 0

    #--------------------------------------------------------------
    # Node Representation
    #--------------------------------------------------------------
    tixOptionMenu $right.nodeDisplay -label "Representation:" \
	-options { label.width 20  label.anchor w   menubutton.width 15 }

    set tmp $typeArray($actualType,DISPLAY)
    $right.nodeDisplay add command $tmp -label $tmp
    foreach opt { NODE EDGE } {
	if { [string compare $tmp $opt] != 0 } { $right.nodeDisplay add command $opt -label $opt }
    }

    pack $right.nodeDisplay -side top -anchor nw -padx 4
    $right.nodeDisplay config	-variable nodeDisplay -command nodeDisplay:set

    createRepresentation_Node

}

proc createRepresentation_Node {} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_nstyle
    global win_path_for_shape
    global typeVisible
    global allAttr

    set right $win_path_for_nstyle

    if { [winfo exists $right.frStyles] == 1  } { destroy $right.frStyles }
    
    #--------------------------------------------------------------
    # Rahmen fuer die Styles
    #--------------------------------------------------------------
    frame $right.frStyles -border 1 -relief ridge
    pack $right.frStyles -side top  -expand no -fill x

    set right $right.frStyles
    #--------------------------------------------------------------
    # Rahmen fuer NodeShape
    #--------------------------------------------------------------
    frame $right.frShape -border 1 -relief raised
    pack $right.frShape -side top  -expand no -fill x
    set frShape  $right.frShape

    #--------------------------------------------------------------
    # Rahmen fuer die Buttons
    #--------------------------------------------------------------
    frame $right.frBottom
    pack $right.frBottom -side top  -expand no -fill x -padx 4

    set bottom  $right.frBottom
###    set right  $right.frButtons 



    #--------------------------------------------------------------
    # Shape-Optionen von Node auf Shape-Tab darstellen
    #--------------------------------------------------------------
    set s $win_path_for_shape.top

    # falls letzte Darstellung Edge-Shape: Rahmen loeschen
    if { [winfo exists $s.frEdgeShape] == 1  } { destroy $s.frEdgeShape }



    #--------------------------------------------------------------
    # Shape Attribut
    #--------------------------------------------------------------
    tixComboBox $frShape.shapeAttr -dropdown true -editable false  \
	-options { listbox.height 8  listbox.width 5 }	-state disabled

###	-command visiAttr:select_attr 

#@ da disabled    foreach attr $allAttr { if {[string first NodeType $attr] == -1} {$frShape.shapeAttr insert end $attr } }

###    tixSetSilent $frShape.shapeAttr $typeArray(VISIATTR);    

    #--------------------------------------------------------------
    # Option NodeStyle
    #--------------------------------------------------------------
    tixOptionMenu $frShape.nodeStyle -label "Shape:" \
	-variable nodeStyle -command style:set \
	-options { label.width 20   label.anchor w   menubutton.width 15 }
    set l [$frShape.nodeStyle subwidget label]
    $l config -fg blue

    set tmp $typeArray($actualType,STYLE)
    $frShape.nodeStyle add command $tmp -label $tmp
    foreach opt { LABEL BOX RBOX DBOX FBOX CIRCLE DOT PACKAGE CLASS } {
	if { [string compare $tmp $opt] != 0 } { $frShape.nodeStyle add command $opt -label $opt }
    }
    #Inititalisierung bei Fenster-Aufbau
    style:init $tmp

#@    pack $frShape.nodeStyle $frShape.shapeAttr -side left -anchor nw -expand no -pady 0
    pack $frShape.nodeStyle -side left -anchor nw -expand no -pady 0 -padx 4

}

proc createRepresentation_Edge { w } {
    global typeArray
    global applyChanges
    global stdEdgeIsDirected
    global selectedEType
    global current_etype
    global win_path_for_estyle
    global win_path_for_shape
    global edgeStyle
    global actualType
    global srcTraverse
    global trgTraverse


    if { [winfo exists $w.frStyles] == 1  } { 
	# Fenster existiert
	destroy $w.frStyles 
    }

    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.frStyles]
    $right config -border 1 -relief ridge
    pack $right -side left  -expand yes -fill both -padx 1
    
    #--------------------------------------------------------------
    # Rahmen fuer die Buttons
    #--------------------------------------------------------------
    frame $right.frButtons -border 1 -relief raised
    pack $right.frButtons -side top  -expand no -fill x
    #    pack $right.frButtons -side top  -expand no -fill x -padx 4
    
    #--------------------------------------------------------------
    # Rahmen fuer die Styles
    #--------------------------------------------------------------
    frame $right.frStyles -border 1 -relief raised
    pack $right.frStyles -side top  -expand no -fill both
    #    pack $right.frStyles -side top  -expand yes -fill both
    
    # Container fuer Styles
    #@    set win_path_for_estyle $right.frStyles
    

    #--------------------------------------------------------------
    # Kanten-Typen
    #--------------------------------------------------------------

#@    if { [winfo exists $right.frdisp] == 1  } { destroy $right.frdisp }
    
    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    frame $right.frdisp -relief raised -bd 1
    pack $right.frdisp -side top -fill both -expand yes -pady 0
    
    #--------------------------------------------------------------
    # Shape-Optionen von Edge auf Shape-Tab darstellen
    #--------------------------------------------------------------
    set s $win_path_for_shape.top
    
    # falls letzte Darstellung Node-Shape: Rahmen loeschen
    if { [winfo exists $s.frNodeShape] == 1  } { destroy $s.frNodeShape }
    
    #--------------------------------------------------------------
    # Rahmen fuer Edge-Shape
    #--------------------------------------------------------------
    if { [winfo exists $s.frEdgeShape] != 1  } { 
	frame $s.frEdgeShape -border 1 -relief ridge
	pack $s.frEdgeShape -side top  -expand no -fill x
    }
    set win_path_for_estyle $s.frEdgeShape
    
    
    #--------------------------------------------------------------
    # EdgeStyle
    #--------------------------------------------------------------
    set right  $right.frButtons 
    
    tixOptionMenu $right.edgeStyle -label "EdgeStyle:" \
	-variable edgeStyle \
	-command edgestyle:set \
	-options { label.width  20   label.anchor w   menubutton.width 15 }
    set l [$right.edgeStyle subwidget label]
    $l config -fg blue
    
    $right.edgeStyle add command DEFAULT -label DEFAULT
    $right.edgeStyle add command USER1 -label DARROW
    $right.edgeStyle add command USER2 -label SLINE
    $right.edgeStyle add command USER3 -label DLINE

    pack $right.edgeStyle -side top -anchor w -padx 2


    set right $w.frStyles.frdisp

    #--------------------------------------------------------------
    # SrcType
    #--------------------------------------------------------------
    frame $right.frSrcType
    pack $right.frSrcType -side top  -expand no -fill x
    set w $right.frSrcType
    #--------------------------------------------------------------
    # EdgeType Comboboxes
    #--------------------------------------------------------------
    create_etype_combo_box2 $w.srcEdge "Type of Source Edge:" "srcEdgeType:set" srcEdgeType $typeArray($actualType,SRCEDGETYPE)
    #--------------------------------------------------------------
    # Traversierung der Kanten
    #--------------------------------------------------------------
    checkbutton $w.srcTraverse -text "Backwards" -anchor nw \
	-variable {srcTraverse} -command {toggleSrcTraverse} -selectcolor {gold}

    pack $w.srcEdge $w.srcTraverse  -side left -anchor nw
    if { [string first "BACKWARDS" $typeArray($actualType,SRCTRAVFORWARD)] != -1 } { set srcTraverse 1 } else { set srcTraverse 0 }

    #--------------------------------------------------------------
    # SrcType
    #--------------------------------------------------------------
    frame $right.frTrgType
    pack $right.frTrgType -side top  -expand no -fill x
    set w $right.frTrgType
    #--------------------------------------------------------------
    # EdgeType Comboboxes
    #--------------------------------------------------------------
    create_etype_combo_box2 $w.trgEdge "Type of Target Edge:" "trgEdgeType:set" trgEdgeType $typeArray($actualType,TRGEDGETYPE)
    #--------------------------------------------------------------
    # Traversierung der Kanten
    #--------------------------------------------------------------
    checkbutton $w.trgTraverse -text "Backwards" -anchor nw \
	-variable {trgTraverse} -command {toggleTrgTraverse} -selectcolor {gold}

    pack $w.trgEdge $w.trgTraverse  -side left -anchor nw
    if { [string first "BACKWARDS" $typeArray($actualType,TRGTRAVFORWARD)] != -1 } { set trgTraverse 1 } else { set trgTraverse 0 }
}


proc toggleSrcTraverse {} {
    #--------------------------------------------------------------
    #--------------------------------------------------------------
    global typeArray
    global actualType
    global srcTraverse

    if {[string compare $srcTraverse "1"] == 0} {
	set typeArray($actualType,SRCTRAVFORWARD) "BACKWARDS"
    } else {
	set typeArray($actualType,SRCTRAVFORWARD) "FORWARD"
    }
}

proc toggleTrgTraverse {} {
    #--------------------------------------------------------------
    #--------------------------------------------------------------
    global typeArray
    global actualType
    global trgTraverse

    if {[string compare $trgTraverse "1"] == 0} {
	set typeArray($actualType,TRGTRAVFORWARD) "BACKWARDS"
    } else {
	set typeArray($actualType,TRGTRAVFORWARD) "FORWARD"
    }
}

proc toggleTypeVisibility {} {
    #--------------------------------------------------------------
    #--------------------------------------------------------------
    global typeArray
    global actualType
    global typeVisible
    global c2
    global h2
    global typeList

    if {[string compare $typeVisible "1"] == 0} {
	set typeArray($actualType,VISI) "YES"
    } else {
	set typeArray($actualType,VISI) "NO"
    }

    $h2 delete all
    foreach ent  $typeList {
	$h2 add $ent  -itemtype imagetext -text $ent
	if { [string first "YES" $typeArray($ent,VISI)] != -1 } { $c2 setstatus $ent on } else { $c2 setstatus $ent off }
    }
    update

}

proc createPage_Shape {win} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_shape
    global boxFont
### durch BorderThickness ersetzen !!!
    global nClassStrength 

    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w [$win.nb subwidget nbShape]

    frame $w.top 
    pack $w.top -side top -fill both -expand yes

    # Container fuer Styles
    set win_path_for_shape $w

    create_node_shape


}

proc create_node_shape {} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_shape
    global boxFont
### durch BorderThickness ersetzen !!!
    global nClassStrength 


    set w $win_path_for_shape

    #--------------------------------------------------------------
    # Rahmen fuer Node-Shape
    #--------------------------------------------------------------
    frame $w.top.frNodeShape -border 0 -relief raised
    pack $w.top.frNodeShape -side top  -expand no -fill x

    set w $w.top.frNodeShape


    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    set right [frame $w.right]
###    $right config -border 1 -relief ridge
    pack $right -side top  -expand yes -fill both -padx 4

    #--------------------------------------------------------------
    # Rahmen fuer die allgemeinen Optionen
    #--------------------------------------------------------------
    frame $right.frGeneral -border 1 -relief ridge
    pack $right.frGeneral -side top  -expand yes -fill both

    #--------------------------------------------------------------
    # Rahmen fuer die Styles
    #--------------------------------------------------------------
    frame $right.frStyles -border 1 -relief ridge
    pack $right.frStyles -side top  -expand yes -fill both

    #--------------------------------------------------------------
    # Ueberschrift
    #--------------------------------------------------------------
    label $right.frGeneral.lblGeneral -text "General Options" -fg blue
    pack $right.frGeneral.lblGeneral -side top -padx 2

    set bottom  $right.frGeneral

    #--------------------------------------------------------------
    # Rahmen fuer SelectColor
    #--------------------------------------------------------------
    frame $bottom.frSelColor
    pack $bottom.frSelColor -side top  -expand yes -fill x
    set frSelColor  $bottom.frSelColor
    
    #--------------------------------------------------------------
    # Option SelectColor
    #--------------------------------------------------------------
    tixOptionMenu $frSelColor.selColor -label "SelectColor:" \
	-variable selColor \
	-options { label.width 16   label.anchor w   menubutton.width 12 }
###    pack $frColor.selColor -side top -padx 2 -anchor w
    fillColorBox $frSelColor.selColor
    $frSelColor.selColor config -state disabled

    #--------------------------------------------------------------
    # SelectColor Attribut
    #--------------------------------------------------------------
    tixComboBox $frSelColor.selColorAttr -dropdown true -editable false  \
	-options { listbox.height 8  listbox.width 12 }
###	-command visiAttr:select_attr 

#@    foreach attr $allAttr { if {[string first NodeType $attr] == -1} {$frColor.colorAttr insert end $attr } }
###    tixSetSilent $frColor.selColorAttr $typeArray(VISIATTR);    
    $frSelColor.selColorAttr config -state disabled

    pack $frSelColor.selColor $frSelColor.selColorAttr -side left -anchor nw -expand no -pady 0

    #--------------------------------------------------------------
    # Rahmen fuer UnselectColor
    #--------------------------------------------------------------
    frame $bottom.frUnselColor
    pack $bottom.frUnselColor -side top  -expand yes -fill x
    set frUnselColor  $bottom.frUnselColor
    
    #--------------------------------------------------------------
    # Option UnSelectColor
    #--------------------------------------------------------------
    tixOptionMenu $frUnselColor.unselColor -label "UnselectColor:" \
	-variable unselColor \
	-options { label.width 16   label.anchor w   menubutton.width 12 }
###    pack $frColor.unselColor -side top -padx 2 -anchor w
    fillColorBox $frUnselColor.unselColor
    $frUnselColor.unselColor config -state disabled

    #--------------------------------------------------------------
    # UnSelectColor Attribut
    #--------------------------------------------------------------
    tixComboBox $frUnselColor.unselColorAttr -dropdown true -editable false  \
	-options { listbox.height 8  listbox.width 12 }
###	-command visiAttr:select_attr 

#@    foreach attr $allAttr { if {[string first NodeType $attr] == -1} {$frColor.colorAttr insert end $attr } }
###    tixSetSilent $frColor.unselColorAttr $typeArray(VISIATTR);    
    $frUnselColor.unselColorAttr config -state disabled

    pack $frUnselColor.unselColor $frUnselColor.unselColorAttr -side left -anchor nw -expand no -pady 0

    #--------------------------------------------------------------
    # Rahmen fuer BorderStyle
    #--------------------------------------------------------------
    frame $bottom.frBorder
    pack $bottom.frBorder -side top -expand yes -fill x
    set frBorder  $bottom.frBorder
    #--------------------------------------------------------------
    # Option BorderStyle
    #--------------------------------------------------------------
    tixOptionMenu $frBorder.borderStyle -label "BorderStyle:" \
	-variable borderStyle \
	-options { label.width 16   label.anchor w   menubutton.width 12 }
    set tmp SOLID
    $frBorder.borderStyle add command $tmp -label $tmp
    foreach opt { SOLID DOTTED DASHED ATTRDEFINED} {
	if { [string compare $tmp $opt] != 0 } { $frBorder.borderStyle add command $opt -label $opt }
    }
    $frBorder.borderStyle config -state disabled
###    pack $bottom.borderStyle -side top -padx 2 -anchor w
    #--------------------------------------------------------------
    # BorderStyle Attribut
    #--------------------------------------------------------------
    tixComboBox $frBorder.borderAttr -dropdown true -editable false  \
	-options { listbox.height 8  listbox.width 12 }
###	-command visiAttr:select_attr 

#@    foreach attr $allAttr { if {[string first NodeType $attr] == -1} {$frBorder.borderAttr insert end $attr } }
###    tixSetSilent $frBorder.borderAttr $typeArray(VISIATTR);    
    $frBorder.borderAttr config -state disabled

    pack $frBorder.borderStyle $frBorder.borderAttr -side left -anchor nw -expand no -pady 0
 
    #--------------------------------------------------------------
    # Option BorderThickness
    #--------------------------------------------------------------
    set nClassStrength $typeArray(CLASSSTRENGTH)
    tixControl $bottom.borderThickness -label "BorderThickness: " -integer true \
	-variable nClassStrength -min 1 -max 5\
	-command borderThickness:Set \
	-options { entry.width 12 label.width 16 label.anchor w	}
    #$bottom.borderThickness subwidget entry config -state disabled
    pack $bottom.borderThickness -side top -padx 2 -anchor w
   

    #--------------------------------------------------------------
    # Anzeige Textfont und Select Button
    #--------------------------------------------------------------
    # Rahmen
    frame $bottom.frame1
    pack $bottom.frame1 -side top -fill both -expand no
    set frame1 $bottom.frame1
    # Font Dialog
    tixLabelEntry $frame1.label1 -label "TextFont: "
    $frame1.label1 subwidget label configure -width 16 -anchor w -foreground {darkgrey}
    $frame1.label1 subwidget entry configure -width 30 -textvariable boxFont -state disabled
    set win_path_for_font boxFont
    # hier demnaechst Wert einlesen
    set boxFont "*"
    button $frame1.selectButton -text " Select " -command selectBoxFont -padx 0 -pady 0 -state disabled
    pack $frame1.label1 $frame1.selectButton -side left -padx 2 -anchor w

    #--------------------------------------------------------------
    # Justification - Rahmen fuer Bitmaps
    #--------------------------------------------------------------
    frame $bottom.frame4
    set frame4 $bottom.frame4
    tixSelect $frame4.font -allowzero true  -radio false \
	-label "TextJustification: "\
	-options { label.width 16 label.anchor w } -state disabled
    tixSelect $frame4.just -allowzero true  -radio true -state disabled
    pack $bottom.frame4 -side top -fill both -expand no -pady 2
    pack $frame4.font $frame4.just -side left -padx 1 -pady 1

    #--------------------------------------------------------------
    # Bitmaps
    #--------------------------------------------------------------
    global scriptpath
    $frame4.just add left      -bitmap @$scriptpath/bitmaps/leftj.xbm
    $frame4.just add center    -bitmap @$scriptpath/bitmaps/centerj.xbm
    $frame4.just add right     -bitmap @$scriptpath/bitmaps/rightj.xbm
### anpassen:    $frame4.just config -variable sel_just -command "MainTextFont $frame3" 
}

proc borderThickness:Set {sel} {
    #--------------------------------------------------------------
    # Speichern der Einstellung fuer borderThickness - anpassen !!!
    #--------------------------------------------------------------
    global typeArray
    global nClassStrength
    set typeArray(CLASSSTRENGTH) $nClassStrength
}

proc nodeDisplay:set {sel} {
    #--------------------------------------------------------------
    # entsprechend ausgewaehltem DisplayStyle evtl. weitere
    # Optionen anbieten (aehnlich der Style-Optionen)
    #--------------------------------------------------------------
    global typeArray
    global actualType
    global current_etype
    global win_path_for_nstyle
    global win_path_for_shape
    global main_window
    global selectedType
    global nodeStyle

    if { [string compare $sel $typeArray($actualType,DISPLAY)] != 0 } {
	set typeArray($actualType,DISPLAY) $sel
	set typeArray($actualType,DISPLAYCHANGED) YES
	
	if { [string compare $sel NODE] == 0 } { 
#@	    create_node_display 
	    createRepresentation_Node
	    
	    # Shape enablen
	    set w [$main_window.nb subwidget nodes]
	    set w $w.top.left.nb
	    set c [$w subwidget nclasses]
	    set c $c.top.right.nb
	    $c pageconfigure nbShape -state normal
	    set c [$w subwidget ntypes]
	    set c $c.top.right.nb
	    $c pageconfigure nbShape -state normal
	    
	}
	if { [string compare $sel EDGE] == 0 } { 
#@	    create_edge_display $sel
	    createRepresentation_Edge $win_path_for_nstyle

	}
    } else {	
	if { [string compare $sel NODE] == 0 } { 
	    if { [string compare $nodeStyle $typeArray($actualType,STYLE)] != 0 } {
		style:init $typeArray($actualType,STYLE)
	    }
	}
	if { [string compare $sel EDGE] == 0 } { 
#@	    edgestyle:set $typeArray($current_etype,STYLE)
#@	    create_edge_display $sel
	    createRepresentation_Edge $win_path_for_nstyle
	}

    }

}

proc nodeDisplay:init {sel} {
    #--------------------------------------------------------------
    # entsprechend ausgewaehltem DisplayStyle evtl. weitere
    # Optionen anbieten (aehnlich der Style-Optionen)
    #--------------------------------------------------------------
    global typeArray
    global actualType
    global win_path_for_nstyle
    global win_path_for_shape
    global main_window
    global selectedType
    global nodeStyle
    global nodeDisplay

    set typeArray($actualType,DISPLAY) $sel
    set typeArray($actualType,DISPLAYCHANGED) YES
    set nodeDisplay $sel
    
    if { [string compare $sel NODE] == 0 } { 
#@	create_node_display 
	createRepresentation_Node
    }
    if { [string compare $sel EDGE] == 0 } { 
#@	create_edge_display $sel
	createRepresentation_Edge $win_path_for_nstyle

    }
### in Vorbereitung
###    if { [string compare $sel HIERARCHY] == 0 } { create_edge_display $sel}

}

proc visiAttr:select_attr { selection } {
    #--------------------------------------------------------------
    # Visibility-Attribut speichern
    #--------------------------------------------------------------
    global typeArray
    set typeArray(VISIATTR) $selection
}

proc style:set {s} {
    #--------------------------------------------------------------
    # entsprechend ausgewaehltem Style Optionen anbieten (s.dort)
    #--------------------------------------------------------------
    global nodeStyle
    global typeArray
    global actualType
    global main_window
    global win_path_for_nstyle
    global win_path_for_shape

    if { [string compare $s $typeArray($actualType,STYLE)] != 0 } {
	set typeArray($actualType,STYLE) $s
	
	if { [string compare $main_window ".settings"] == 0 || [string compare $main_window ".nodeSettings"] == 0} {
	    
	    #--------------------------------------------------------------
	    # Shape-Optionen von Node auf Shape-Tab darstellen
	    #--------------------------------------------------------------
	    set w $win_path_for_shape.top
	    
	    # falls letzte Darstellung Edge-Shape: Rahmen erstellen
	    if { [winfo exists $w.frNodeShape] != 1  } { 
		create_node_shape
	    }
	    
	    if { [string compare $s BOX] == 0 } { create_box_style }
	    if { [string compare $s RBOX] == 0 } { create_box_style }
	    if { [string compare $s DBOX] == 0 } { create_box_style }
	    if { [string compare $s FBOX] == 0 } { create_box_style }
	    if { [string compare $s LABEL] == 0 } { create_box_style }
	    if { [string compare $s CIRCLE] == 0 } { create_circle_style }
	    if { [string compare $s DOT] == 0 } { create_dot_style }
	    if { [string compare $s PACKAGE] == 0 } { create_package_style }
	    if { [string compare $s CLASS] == 0 } { create_class_style }
# 	    if { [string compare $s ATTRDEFINED] == 0 } {  
# 		$w.shapeAttr config -state normal
# 	    } else { 
# 		$w.shapeAttr config -state disabled 
# 	    }
	}
    } else {
#	puts "style:set  style not set $s"
    }
}

proc style:init {s} {
    #--------------------------------------------------------------
    # entsprechend ausgewaehltem Style Optionen anbieten (s.dort)
    #--------------------------------------------------------------
    global nodeStyle
    global typeArray
    global actualType
    global main_window
    global win_path_for_nstyle
    global win_path_for_shape

    set typeArray($actualType,STYLE) $s
    set nodeStyle $s
    
    if { [string compare $main_window ".settings"] == 0 || [string compare $main_window ".nodeSettings"] == 0} {
	
	#--------------------------------------------------------------
	# Shape-Optionen von Node auf Shape-Tab darstellen
	#--------------------------------------------------------------
	set w $win_path_for_shape.top
	
	# falls letzte Darstellung Edge-Shape: Rahmen erstellen
	if { [winfo exists $w.frNodeShape] != 1  } { 
	    create_node_shape
	}
	
	if { [string compare $s BOX] == 0 } { create_box_style }
	if { [string compare $s RBOX] == 0 } { create_box_style }
	if { [string compare $s DBOX] == 0 } { create_box_style }
	if { [string compare $s FBOX] == 0 } { create_box_style }
	if { [string compare $s LABEL] == 0 } { create_box_style }
	if { [string compare $s CIRCLE] == 0 } { create_circle_style }
	if { [string compare $s DOT] == 0 } { create_dot_style }
	if { [string compare $s PACKAGE] == 0 } { create_package_style }
	if { [string compare $s CLASS] == 0 } { create_class_style }
	# 	    if { [string compare $s ATTRDEFINED] == 0 } {  
	# 		$w.shapeAttr config -state normal
	# 	    } else { 
	# 		$w.shapeAttr config -state disabled 
	# 	    }
    }
}

proc callFontDialog {} {
    #--------------------------------------------------------------
    # allg. Routine um Fontdialog aufzurufen (s. setFontDialog.tcl)
    #--------------------------------------------------------------
    global win_path_for_font
    global tmpFont
    global ${win_path_for_font}

    setBusy
    set tmpFont [expr $$win_path_for_font]

    fontDialog
    tkwait window .fontReq

    set ${win_path_for_font} $tmpFont
    puts [expr $$win_path_for_font]
    
}

# folgende Routinen zusammenfassen
proc selectClassFont {} {
    global win_path_for_font
    global tmpFont
    global classfont
    set win_path_for_font classFont
    callFontDialog
}

proc selectBoxFont {} {
    global win_path_for_font
    global tmpFont
    global boxfont
    set win_path_for_font boxFont
    callFontDialog
}

proc selectPackageFont {} {
    global win_path_for_font
    global tmpFont
    global packagefont
    set win_path_for_font packageFont
    callFontDialog
}
# bis hierher zusammenfassen


proc fillColorBox {c} {
    #--------------------------------------------------------------
    # Farbauswahl
    #--------------------------------------------------------------
    $c add command BLACK     -label BLACK
    $c add command BLUE      -label BLUE
    $c add command SEAGREEN  -label SEAGREEN
    $c add command RED       -label RED
    $c add command YELLOW    -label YELLOW
}


return ok
