###############################################################################
#
# setNodeStylePackage.tcl
# 
# 
# Erzeugung des Rahmens fuer NodeStyle Package
#
#
###############################################################################

proc create_package_style { } {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_shape
    global packageFont
    global allAttr

    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w $win_path_for_shape.top.frNodeShape.right.frStyles

    if { [winfo exists $w.right] == 1  } { destroy $w.right }
    
    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    frame $w.right
    pack $w.right -side top -fill both -expand yes

    set right $w.right

    #--------------------------------------------------------------
    # Ueberschrift
    #--------------------------------------------------------------
    label $right.label1 -text "Shape Specific Options" -fg blue
    pack $right.label1 -side top -padx 2

    #--------------------------------------------------------------
    # Option NameAttribute
    #--------------------------------------------------------------
    tixComboBox $right.nameAttr -label "Name Attribute:" -dropdown true \
	-command nameAttr:select_attr -editable false  \
	-options { listbox.height 8   label.width 16   label.anchor w }
    pack $right.nameAttr    -side top -anchor w

    foreach attr $allAttr { $right.nameAttr insert end $attr }
    tixSetSilent $right.nameAttr $typeArray(NAMEATTR);

}

proc nameAttr:select_attr { selection } {
    #--------------------------------------------------------------
    # NameAttribute speichern
    #--------------------------------------------------------------
    global typeArray
    set typeArray(NAMEATTR) $selection
}

return ok