###############################################################################
#
# setVisibilities.tcl
# 
# 
# Erzeugung der Notebook-Seite fuer Visibilities
#
#
###############################################################################

proc createPage_Visibilities {} {
    global typeArray
    global typeList
    global edgeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree

    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w [$main_window.nb subwidget visinodes]

    #--------------------------------------------------------------
    # Container-Rahmen fuer gesamtes Tab
    #--------------------------------------------------------------
    frame $w.tabFrame -border 1
    pack $w.tabFrame -side top -fill both -expand yes

    #--------------------------------------------------------------
    # oberer Rahmen
    #--------------------------------------------------------------
    set top [frame $w.tabFrame.top]
    pack $top -side top  -fill both -padx 1
    label $top.label1 -text "Nodes" -fg blue
    label $top.label2 -text "Edges" -fg blue
    pack $top.label1 -side left -padx 8
    pack $top.label2 -side right -ipadx 4

    #--------------------------------------------------------------
    # unterer Rahmen
    #--------------------------------------------------------------
    set bottom [frame $w.tabFrame.bottom]
    pack $bottom -side bottom  -expand yes -fill both -padx 4

    #--------------------------------------------------------------
    # linker Rahmen fuer NodeTypes
    #--------------------------------------------------------------
    set left [frame $bottom.left]
    $left config -border 1 -relief ridge
    pack $left -side left  -expand yes -fill both -padx 4

    #--------------------------------------------------------------
    # Checkliste fuer NodeTypes
    #--------------------------------------------------------------
    set c2 [tixCheckList $left.c -scrollbar auto -browsecmd visi:update -command visi:update ]
    pack $c2 -expand yes -fill both -padx 4 -pady 1
    set h2 [$c2 subwidget hlist]
    foreach ent  $typeList {
	$h2 add $ent  -itemtype imagetext -text $ent
	if { [string first "YES" $typeArray($ent,VISI)] != -1 } { $c2 setstatus $ent on } else { $c2 setstatus $ent off }
    }

    bind $h2 <Enter> "focus $h2"
    bind $h2 <Meta-u> {
	foreach ent  $typeList {
	    $c2 setstatus $ent off 
	    set typeArray($ent,VISI) NO
	}
###	create_type_combo_box 
    }
    bind $h2 <Meta-s> {
	foreach ent  $typeList {
	    $c2 setstatus $ent on
	    set typeArray($ent,VISI) YES
	}
###	create_type_combo_box 
    }


    #--------------------------------------------------------------
    # rechter Rahmen fuer EdgeTypes
    #--------------------------------------------------------------
    set right [frame $bottom.right]
    $right config -border 1 -relief ridge
    #set right [frame $w.tabFrame.right]
    pack $right -side right -expand yes -fill both -padx 4

    #--------------------------------------------------------------
    # Checkliste fuer EdgeTypes
    #--------------------------------------------------------------
    set c3 [tixCheckList $right.c -scrollbar auto -browsecmd visiedges:update -command visiedges:update ]
    pack $c3 -expand yes -fill both -padx 4 -pady 1
    set h3 [$c3 subwidget hlist]

    set edgeList [lsort $edgeList]
    foreach ent  $edgeList {
	$h3 add $ent  -itemtype imagetext -text $ent
	if { [string first "YES" $typeArray($ent,VISI)] != -1 } { $c3 setstatus $ent on } else { $c3 setstatus $ent off }
    }

    
#     tixButtonBox $w.tabFrame.box -orientation vertical -padx 2 -pady 2
#     $w.tabFrame.box add ok -text all -height 2 -command {puts ok}  -padx 2 -pady 2
#     $w.tabFrame.box add cancel -text none  -command "puts cancel" 
#     pack $w.tabFrame.box -side right

}


proc potvisi:set { sel } {
    #global typeArray
    #set typeArray(POTVISI) $sel
}

proc visi:update { dummy } {
    #--------------------------------------------------------------
    # Visibilities fuer NodeTypes speichern
    #--------------------------------------------------------------
    global typeArray
    global actualType
    global c2

    set selection [$c2 getselection on] 
    foreach ent $selection { set typeArray($ent,VISI) YES }
    set selection [$c2 getselection off] 
    foreach ent $selection { set typeArray($ent,VISI) NO }

    selectTypeVisibility
}

proc visiedges:update { dummy } {
    #--------------------------------------------------------------
    # Visibilities fuer EdgeTypes speichern
    #--------------------------------------------------------------
    global typeArray
    global c3

    set selection [$c3 getselection on] 
    foreach ent $selection { set typeArray($ent,VISI) YES }
    set selection [$c3 getselection off] 
    foreach ent $selection { set typeArray($ent,VISI) NO }
}

return ok