###############################################################################
#
# stdGraph.tcl
# 
# Setzen globaler Variablen
# Einbinden der Skripte mit Prozeduren fuer das Haupt-TCL-Fenster
#
###############################################################################

global typeArray
global classList
global scriptpath
set scriptpath $env(TCL_PATH)
set scriptpath $scriptpath/tcl  

# end source
proc EndSrc {} {
#  wm protocol . WM_DELETE_WINDOW { recall deleteWindow;}
    wm protocol . WM_DELETE_WINDOW { recall modPress q;}
}

# initialize global variables
proc InitGlobals {} {
  global {splineFlag}
  set {splineFlag} {0}
  global {draging}
  set {draging} {0}
  global dragBoxX
  set dragBoxX 0
  global dragBoxY
  set dragBoxY 0
  global aktuCommand
  set aktuCommand recall
  global aktuCanvas
  set aktuCanvas .frame0.canvas2
  global oldAktuCanvas
  set oldAktuCanvas {}
  global workingMode
  set workingMode Create
  global {showLabelsFlag}
  set {showLabelsFlag} {1}
  global {showNodesFlag}
  set {showNodesFlag} {1}
  global {showEdgesFlag}
  set {showEdgesFlag} {1}

  global {isDirected}
  set isDirected(.frame0.canvas2) 1
  global {mousePressed}
  set {mousePressed} {0}
  global {Inspector}
  set {Inspector} {0}
  global {draging}
  set {draging} {0}
  global {xoff}
  set {xoff} {15}
  global {yoff}
  set {yoff} {15}
  global {symbolicName}
  set {symbolicName(graphView)} {.frame0.canvas2}
}

# initialize global variables
# JK: InitGlobals ist nicht von uns sondern von ffGraph !
InitGlobals
#
# Ende vom ffGraph Part
#

#
# Hier beginnen die Modifikationen fuer ECU:
# Wir haben es hier mit dem "haupt"- interpreter zu tun
# Wenn Initialisierungen nur EINMAL durchgefuehrt werden sollen, oder
# Zusaetzliche fenster erzeugt werden sollen, dann gehoeren die aufrufe dazu hierhin !
#

catch { source "$scriptpath/bind-advise.tcl" } error_code
on_error_message $error_code bind-advise.tcl
catch { source "$scriptpath/graph_win/window.tcl" } error_code
on_error_message $error_code window.tcl
catch { source "$scriptpath/graph_win/canvas.tcl" } error_code
on_error_message $error_code canvas.tcl
catch { source "$scriptpath/graph_win/edge.tcl" } error_code
on_error_message $error_code edge.tcl
catch { source "$scriptpath/graph_win/node.tcl" } error_code
on_error_message $error_code node.tcl
catch { source "$scriptpath/graph_win/changeToIcon.tcl" } error_code
on_error_message $error_code changeToIcon.tcl
catch { source "$scriptpath/graph_win/changeToCircle.tcl" } error_code
on_error_message $error_code changeToCircle.tcl
catch { source "$scriptpath/graph_win/changeToBox.tcl" } error_code
on_error_message $error_code changeToBox.tcl
catch { source "$scriptpath/graph_win/changeToFrameBox.tcl" } error_code
on_error_message $error_code changeToFrameBox.tcl
catch { source "$scriptpath/graph_win/changeToDot.tcl" } error_code
on_error_message $error_code changeToDot.tcl
catch { source "$scriptpath/graph_win/changeToPackage.tcl" } error_code
on_error_message $error_code changeToPackage.tcl
catch { source "$scriptpath/graph_win/changeToClass.tcl" } error_code
on_error_message $error_code changeToClass.tcl


catch { source "$scriptpath/docManWin.tcl" } error_code
on_error_message $error_code docManWin.tcl

catch { source "$scriptpath/execList.tcl" } error_code
on_error_message $error_code execList.tcl

set scriptpath $env(TCL_PATH)
set scriptpath $scriptpath/tcl

# setzen Icon-Pfad - Environmentvariable kann leider nicht in einer Prozedur erfragt werden
global IconPath
set IconPath "@"
catch { set IconPath $env(EDGE_ICON_PATH) ; return 0 } error_code
if { $error_code != 0 } then { 
    puts stdout "\nWarning: environment variable EDGE_ICON_PATH not set - unable to display icons\n"
}

# setzen TXT-Pfad - Environmentvariable kann leider nicht in einer Prozedur erfragt werden
global txtPath
set txtPath $env(TCL_PATH)
set txtPath $txtPath/text


if { [isProto] == 1 } {
    catch { source "$scriptpath/globVarWin.tcl" } error_code
    on_error_message $error_code globVarWin.tcl
}

#Interpreter in ECU-Datenstruktur speichern
Tcl_getMainInterp

EndSrc
