#################################################################################
#
# procedures for showing graph as text
#
#################################################################################

proc TextGraphCreateWindow {} {
    global textgraphlines 
    toplevel .textwindow
    wm iconname .textwindow "Graph as text"
    wm title .textwindow "Graph as text"

    frame .textwindow.bottom
    button .textwindow.bottom.ok -text " OK " -command "update; destroy .textwindow; set textgraphlines 0"
    button .textwindow.bottom.file -text " Write to file " -command "TextGraphWriteFile"
    pack .textwindow.bottom.ok .textwindow.bottom.file -side left -expand 1 -padx 30

    scrollbar .textwindow.yscroll -command ".textwindow.text yview"
    text .textwindow.text -relief raised -bd 2 -yscroll ".textwindow.yscroll set"
    
    pack .textwindow.bottom -side bottom -padx 10 -pady 10
    pack .textwindow.text -side left -fill y 
    pack .textwindow.yscroll -side left -fill y 
    
    set textgraphlines 0
}

proc TextGraphAddTextline {newline} {
    global textgraphlines
    .textwindow.text insert end $newline
    .textwindow.text insert end "\n"
    incr textgraphlines
}

proc TextGraphShowAttr {} {
    global attr attrname noofattr
    for {set i 1} {$i<$noofattr} {incr i} {
	set tempStr $attr($i);
	if {[string first "\"" $tempStr] == 0} {
	    set index   [string last "\"" $tempStr];
	    set repStr  [string range $tempStr 1 [expr $index-1]];
	    set tempStr [stringReplace "\"" "'" $repStr];
	    set tempStr "\"$tempStr\"";
	} else {
	    set tempStr [stringReplace "\"" "'" $tempStr];
	}
	set tempStr [stringReplace "\n" "\\n" $tempStr];
	TextGraphAddTextline "          $attrname($i): $tempStr";
    }
}

proc TextGraphWriteFile {} {
    global textgraphlines selectedfile

    TextGraphSelectFile
    if {[string length $selectedfile] != 0} {
	set file [open $selectedfile w+]
	# check whether file is open or not.
	if {[string first "couldn't open" $file]==-1} {
	    for {set i 1} {$i<=$textgraphlines} {incr i} {
		puts $file [.textwindow.text get $i.0linestart $i.0lineend]
	    }
	    close $file
	}
    } 
}

proc TextGraphSelectFile {} {
    global selectedfile
    set dialog [tix filedialog tixExFileSelectDialog]
    $dialog config -command TextGraphStoreFilename
    $dialog subwidget fsbox config -filetypes {
	{{*.graph} {*.graph  Text graphs}}
	{{*}       {*     -- All files}}
    }
    $dialog popup
    tkwait variable selectedfile
}

proc TextGraphStoreFilename {file} {
    global selectedfile
    set selectedfile $file
}



################################################################################
#
# Global Variables
#
################################################################################
set noofattr 0

return ok
