
#################################################################################
#
# Procs for edges  
#
#################################################################################

proc CreateEdge {path source target {label ""}} {
    set sourceId [GetNodeId $path $source]
    set targetId [GetNodeId $path $target]
    set e [$path.c create edge -10 -10 -20 -20 -from $sourceId -to $targetId -arrow last -tags "from$source to$target edge"]
    $path.c graph add $e
    if {$label!=""} {
	$path.c itemconfigure $e -label $label
    }
}

proc DeleteEdge {path source target} {
    set edgeid [GetEdgeId $path $source $target]
    if {$edgeid!=""} {
	$path.c graph remove $edgeid
	update
	$path.c delete $edgeid 
    }
}


proc GetEdgeId {path source target} {
    set from [$path.c find withtag from$source]
    set to [$path.c find withtag to$target]
    set id ""
    foreach edge $from {
	if {[lsearch $to $edge]>-1} {
	    set id $edge
	    break
	} 
    }
    return $id
}

return ok