# dirk broens, 04-98
#
# top.b listbox    contains ALL transactions
# tob.a listbox    contains only selected transactions and their parameters


# procs in viewManWin.tcl:

#  viewManWin is notebook with x tabs and button-bar and calls to:

#  chP             :  assign or change paramteters -> concerns transactions in listbox $w.top.a
#  add             :  add transaction -> copy selected transactions from listbox $w.top.b to listbox $w.top.a
#  exeL            :  execute all transactions in listbox $w.top.a
#  readSettings    :  read selected transactions (scheme) from file (file -> top.a listbox)
#  writeSettings   :  write selected transactions (scheme) to file  (top.a listbox -> listbox)


# --------------------------------------------------------------------------------------------------------------------------------------------------------

proc viewManWin {settings} {

# global NumberOfParameter

global db

set db .$settings

toplevel $db

frame $db.top -border 1 -relief raised

    if {$settings == "create"} { 
        }


    # subwidget.
    tixNoteBook $db.nb -ipadx 6 -ipady 6
    $db config -bg gray
    $db.nb subwidget nbframe config -backpagecolor gray
 
    $db.nb add operations -label "Operations" -underline 0
#   $db.nb add xxx        -label "---"        -underline 0
    pack $db.nb -expand yes -fill both -padx 5 -pady 5 -side top
    
    #----------------------------------------
    # Create the first page
    #----------------------------------------
    set f [$db.nb subwidget operations]


########################################################################
# Get Transactions From File "menu.clean"

global GENDIR
global w
global transactions
global selection

######################################################################## cutted and pasted !!! 90% 
# read transactions from file: menu.clean in $GENDIR

set menusymbol MENU
set menusymbollength [string length $menusymbol]

set menufile [open "$GENDIR/menu.clean" r]

set line ""
set transactions ""

# get rid of "Undo, Undo All, Redo"
	    gets $menufile line    
	    gets $menufile line 
	    gets $menufile line 


while { [gets $menufile line] != -1 } {
    if {[string first $menusymbol  $line] != -1} {
	set menuname [string trimleft  $line $menusymbol]
	set menuname [string trimright $menuname "\{"]
	set menuname [string trim $menuname]
	set menu_id  [string tolower $menuname]

	gets $menufile line 
	while {[string first "\}" $line] != 0} {
	    set line "$line "
	    set command [string range $line 0 [string first " " $line]]
	    set command [string trim  $command]
	    set commandname [string range $line [string first " " $line] end]
	    set commandname [string trim  $commandname]
	    if { [string compare $commandname ""] == 0} {
		set commandname $command
	    }
	    ### 
	    # transactions = transactions + "Transaction (acutally read from file)"

            set transactions "$transactions $command"      

	    gets $menufile line 
            
	}
    }
}

########################################################################
    
    set w $f

    frame $w.top -relief raised -bd 1


    tixScrolledListBox $w.top.a -scrollbar auto
    tixScrolledListBox $w.top.b -scrollbar auto

    tixButtonBox $w.box -orientation horizontal

    $w.box add ok      -text "Ok"             -underline 0 -command {writeSettings $settings ; destroy $db}                        -width 9
    $w.box add add     -text "Add"            -underline 0 -command {add}                                -width 9
    $w.box add rem     -text "Remove"         -underline 0 -command {rem}                                -width 9
    $w.box add chp     -text "Parameter"      -underline 0 -command {chP}                                -width 9
#   $w.box add exeL    -text "Execute List"   -underline 0 -command {exeL}                               -width 9

    pack $w.box -side bottom -fill x
    pack $w.top -side top -fill both -expand yes

    pack $w.top.b -expand yes -fill both -padx 20 -pady 20 -side left
    pack $w.top.a -expand yes -fill both -padx 20 -pady 20 -side left


    $w.top.a subwidget listbox insert 0 \

    $w.top.a subwidget listbox config  -cursor left_ptr 
    raise [$w.top.a subwidget listbox]


foreach transaction $transactions {$w.top.b subwidget listbox insert end $transaction}  

# read settings

readSettings $settings



    
    #----------------------------------------
    # Create the second page	
    #----------------------------------------
#    set f [$db.nb subwidget xxxxxxxx]


}


# --------------------------------------------------------------------------------------------------------------------------------------------------------
# add transaction -> copy selected transactions from listbox $w.top.b to listbox $w.top.a


proc add {}  {
    
global w

set index [$w.top.b subwidget listbox curselection]
$w.top.a subwidget listbox insert end "[$w.top.b subwidget listbox get $index $index]()"

chPa
}

# --------------------------------------------------------------------------------------------------------------------------------------------------------


proc rem {}  {
    
global w

# remove selected transaction from listbox $w.top.a

set index [$w.top.a subwidget listbox curselection]   
set dummy [$w.top.a subwidget listbox get $index $index]
$w.top.a subwidget listbox delete $index

}

# --------------------------------------------------------------------------------------------------------------------------------------------------------

proc exeL {}  {

global w
global NumberOfParameter

# get complete exelist (transactions + parameters)
set exeList [$w.top.a subwidget listbox get 0 end]

# check ..........

# unparse parameters from exelist
foreach dummy $exeList {

# split into transaction and ( )

set parameter ""
set transaction ""

    regexp {(\()(.*)(\))} $dummy x1 x2 parameter
    regexp {(.*)\(.*\)} $dummy dummy transaction

# get rid of one whitespace at the end of the string 
    set transaction [string trim $transaction]

# all used parameters and their correspondig TCL-variables must be globals =>
# global $"transactionname+0,1,2,.....#ofParameters" -> see wrapper.tcl (generated from PROGRES)

getNumberOfParameter $transaction
set i 0
while {$i < $NumberOfParameter} {
global $transaction$i
set i [expr $i+1]   
}

# execute transaction + parameter
if {$NumberOfParameter != 0} then {

# replace all "," in $parameter with " "
regsub -all "," $parameter " " parameter

# fill the corresponding variables "transactionname+0,1,2,.....#ofParameters"
 
set i 0
foreach entry $parameter {
    set $transaction$i $entry 
    set i [expr $i+1]
}

}

pdialog dotransaction $transaction $transaction


}  

}

# --------------------------------------------------------------------------------------------------------------------------------------------------------
# assign or change paramteters -> concerns transactions in listbox $w.top.a


proc chP {}  {

global w
global NumberOfParameter

# get currently selected transaction ($w.top.a) from selected transactions to assign or change parameters
set index [$w.top.a subwidget listbox curselection]   
set dummy [$w.top.a subwidget listbox get $index $index]

# split into transactions and (possibly already existing) parameters
set parameter ""
set transaction ""

regexp {\(.*\)}     $dummy parameter
regexp {(.*)\(.*\)} $dummy dummy transaction


# now we need to know the Number of parameters of the transaction -> TCL_AppInit:GetNumberOfParameter -> to globale TCL_Variable "NumberOfParameter"
getNumberOfParameter $transaction

if {$NumberOfParameter == 0} then {return OK}

# all used parameters and their correspondig TCL-variables must be globals =>
# global $"transactionname+0,1,2,.....#ofParameters" -> see wrapper.tcl (generated from PROGRES)

set i 0
while {$i < $NumberOfParameter} {
  global $transaction$i
  set i [expr $i+1]   
}

# call parameterdialog
pdialog dodialogprops $transaction $transaction
# parameters are returned in global variables:  $"transactionname+0,1,2,.....#ofParameters"

# REMOVE transaction and ADD transaction with new parameters (REMOVE + ADD = UPDATE)
$w.top.a subwidget listbox delete $index

set dummy    "("
set bc       ")"
set i 0

# we want to show the name of the transaction and its parameters
# first we built the parameter-string
# little example: set a b, set b 1, puts [expr $$a] 
# --> 1

while {$i < [expr $NumberOfParameter-1]} {
    set dummy "$dummy[expr $$transaction$i], "
    set i [expr $i+1]
}
# we don't want a ending "," , so .....
set dummy "$dummy[expr $$transaction$i]"

# finally: insert parameter-string into listbox
$w.top.a subwidget listbox insert $index "$transaction $dummy$bc"

}

# --------------------------------------------------------------------------------------------------------------------------------------------------------
# assign paramteters to added transaction -> concerns transactions in listbox $w.top.a

proc chPa {}  {

global w
global NumberOfParameter

# get currently selected transaction ($w.top.a) from selected transactions to assign or change parameters

set dummy [$w.top.a subwidget listbox get end]

# split into transactions and (possibly already existing) parameters
set parameter ""
set transaction ""

regexp {\(.*\)}     $dummy parameter
regexp {(.*)\(.*\)} $dummy dummy transaction


# now we need to know the Number of parameters of the transaction -> TCL_AppInit:GetNumberOfParameter -> to globale TCL_Variable "NumberOfParameter"
getNumberOfParameter $transaction

if {$NumberOfParameter == 0} then {return OK}

# all used parameters and their correspondig TCL-variables must be globals =>
# global $"transactionname+0,1,2,.....#ofParameters" -> see wrapper.tcl (generated from PROGRES)

set i 0
while {$i < $NumberOfParameter} {
  global $transaction$i
  set i [expr $i+1]   
}

# call parameterdialog
pdialog dodialogprops $transaction $transaction
# parameters are returned in global variables:  $"transactionname+0,1,2,.....#ofParameters"

# REMOVE transaction and ADD with parameters
$w.top.a subwidget listbox delete end

set dummy    "("
set bc       ")"
set i 0

# we want to show the name of the transaction and its parameters
# first we built the parameter-string
# little example: set a b, set b 1, puts [expr $$a] 
# --> 1

while {$i < [expr $NumberOfParameter-1]} {
    set dummy "$dummy[expr $$transaction$i], "
    set i [expr $i+1]
}
# we don't want a ending "," , so .....
set dummy "$dummy[expr $$transaction$i]"

# finally: insert parameter-string into listbox
$w.top.a subwidget listbox insert end "$transaction $dummy$bc"

}

# --------------------------------------------------------------------------------------------------------------------------------------------------------


proc readSettings {filename}  {

# read transactions+parameters from $GENDIR/$filename.set

global w
global GENDIR
cd $GENDIR

if {[file exists $filename\.set] == 1} {

set fileId [open "$GENDIR/$filename.set" r]
gets $fileId dummy
gets $fileId dummy
gets $fileId dummy


gets $fileId i
while {$i != "EOF"} {
  $w.top.a subwidget listbox insert end $i
  gets $fileId i
}

close $fileId
}
}

# --------------------------------------------------------------------------------------------------------------------------------------------------------

proc writeSettings {filename}  {

# write transactions+parameters to $GENDIR/$filename.set

global w
global GENDIR
cd $GENDIR

set fileId [open "$GENDIR/$filename.set" w+]
puts $fileId "......"
puts $fileId "......"
puts $fileId "......"
set exeList [$w.top.a subwidget listbox get 0 end]

foreach entry $exeList {
puts $fileId $entry
}

puts $fileId "EOF"
close $fileId



}

# --------------------------------------------------------------------------------------------------------------------------------------------------------


return ok
