spec FOCS

   declares

      section GlobalScheme

         declares

            function alwaysVisible : -> integer =
               0
            end;

            function isVisible : -> integer =
               1
            end;

            node_class UNIT
               intrinsic
                  index name : string := "";
                  (* @CC_LG
                  3010XC2
                  -120,0 @*)
                  visible : integer [0:n] := isVisible;
                  (* @CC_LG
                  3010XC2
                  120,0 @*)
               derived
                  label = self.name;
                  (* @CC_LG
                  3012XC2
                  0,55 @*)
            end;
            (* @CC_LG 6007(448,243)(97,29) @*)

            node_class COMPONENT is_a UNIT (* @CC_LG 3005C @*)
               intrinsic
                  author : string := "";
                  (* @CC_LG
                  3010XC2
                  96,1 @*)
                  www : string
                        (* @CC_LG 4005LC,TC(0,12)(36,12) @*)
                        (* @CC_LG 4005LC,TC(0,12)(36,12) @*) := "";
                  (* @CC_LG
                  3010XC2
                  -120,0 @*)
            end;
            (* @CC_LG 6007(448,159)(97,29) @*)

            node_class FEATURE is_a UNIT (* @CC_LG 3005C @*) end;
            (* @CC_LG 6007(160,166)(97,29) @*)

            node_class INDEX is_a UNIT (* @CC_LG 3005C @*) end;
            (* @CC_LG 6007(760,159)(97,29) @*)

            node_type Key : INDEX
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(684,78)(97,29) @*)

            node_type Synonym : INDEX
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(840,78)(97,29) @*)

            node_type View : FEATURE
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(76,76)(97,29) @*)

            node_type Class : FEATURE
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(244,76)(97,29) @*)

            edge_type like : Synonym -> Key [1:1];
            (* @CC_LG 3004C @*)

            edge_type of : Key -> COMPONENT;
            (* @CC_LG 3004C @*)

            edge_type sub : Class -> FEATURE;
            (* @CC_LG
            3004C3
            244,166 @*)

            node_type Documentation : COMPONENT
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(376,76)(97,29) @*)

            node_type Code : COMPONENT
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(544,76)(97,29) @*)

            edge_type describes : Documentation -> Code;
            (* @CC_LG 3004C @*)

            edge_type uses : Code -> Code;
            (* @CC_LG
            3004M5
            575,40
            615,40
            615,74 @*)

            edge_type has (* @CC_LG 1002C,TC(0,10)(18,10) @*) : View -> FEATURE;
            (* @CC_LG
            3004C3
            76,166 @*)

            edge_type satisfies (* @CC_LG 1002C,RC(27,-14)(54,10) @*) : Class -> Class;
            (* @CC_LG
            3004M5
            172,72
            172,38
            212,38 @*)

            edge_type ref (* @CC_LG 1002C,TC(0,10)(18,10) @*) : Class -> COMPONENT;
            (* @CC_LG 3004C @*)

      end;
      (* @CC_LG 7013(36,30)(901,317) @*)
      (* @CC_LC
      PersonScheme AB0
      QueryScheme AB0 @*)

      section QueryScheme

         declares

            node_class QUERY is_a UNIT
               derived
                  result : COMPONENT [0:n];
                  (* @CC_LG
                  3012XC2
                  0,56 @*)
               redef_derived
                  label = self.name & " hits:" & string ( card ( self.result ) );
            end;
            (* @CC_LG 6007(244,194)(97,29) @*)

            node_type ClassQuery : QUERY (* @CC_LG
                                         3005C3
                                         -34,56 @*)
               intrinsic
                  inClass (* @CC_LG 1002TC(0,6)(42,10) @*) : Class;
                  (* @CC_LG
                  3010XC2
                  0,42 @*)
               redef_derived
                  result = self.inClass.referenced;
            end;
            (* @CC_LG 6013(412,110)(97,29) @*)

            path referenced : FEATURE -> COMPONENT =
                  [ instance_of Class ::     -sub->
                                         or
                                            <-satisfies-
                                            (* @CC_LT VertWithIndent @*)
                  | instance_of View ::
                       -has->
                       (* @CC_LT VertWithIndent @*) ]                    *
               &  instance_of Class
               &  -ref->
            end;

            node_type KeyQuery : QUERY (* @CC_LG
                                       3005C3
                                       48,56 @*)
               intrinsic
                  withKey : Key;
                  (* @CC_LG
                  3010XC2
                  0,42 @*)
               redef_derived
                  result = self.withKey.indexed;
            end;
            (* @CC_LG 6013(76,110)(97,29) @*)

            path indexed : INDEX -> COMPONENT =
                  [ instance_of Synonym :: -like->
                  | instance_of Key ]
               &  -of->
            end;

            node_class SET_OP is_a QUERY (* @CC_LG 3005C @*) end;
            (* @CC_LG 6007(244,110)(97,29) @*)

            node_type And : SET_OP
               (<OptAttDeclList>)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               redef_derived
                  result = self.arg1.result and self.arg2.result;
            end;
            (* @CC_LG 6013(172,54)(97,29) @*)

            node_type Or : SET_OP
               (<OptAttDeclList>)
               (* @CC_LG 3005C @*)
               (* @CC_LG 3005C @*)
               redef_derived
                  result = self.arg1.result or self.arg2.result;
            end;
            (* @CC_LG 6013(316,54)(97,29) @*)

            edge_type arg1 (* @CC_LG 1002C,BC(-22,-12)(36,22) @*) : SET_OP -> QUERY [1:1];
            (* @CC_LG
            3004C4
            172,110
            172,138 @*)

            edge_type arg2 (* @CC_LG 1002C,LC(14,-24)(24,22) @*) : SET_OP -> QUERY [1:1];
            (* @CC_LG
            3004C4
            316,110
            316,138 @*)

      end;
      (* @CC_LG 7013(20,403)(473,284) @*)
      (* @CC_LC
      PersonScheme LF0
      PersonScheme TA0
      GlobalScheme BE0 @*)

      section GenericOps

         declares

            path dependent : UNIT -> UNIT =
               [ instance_of View :: -has->
               | instance_of Class ::     -sub->
                                      or  -ref->
                                      or  <-inClass-
               | instance_of Key ::     <-like-
                                    or  -of->
                                    or  <-withKey-
               | instance_of Code :: <-describes-
               | instance_of QUERY ::     <-arg1-
                                      or  <-arg2- ]
            end;

            path hideAlso( VFlag : integer) : UNIT -> UNIT =
               (    dependent
                 &  valid (VFlag in self.visible) ) *
            end;

            transformation DelObject ( Type : type_in UNIT ; Id : Type) =

               begin
                  obl_node `1 = Id;
                  (* @CC_LG 6007(41,28)(59,21) @*)
                  => `1 : not with dependent;
                  (* @CC_LG
                  3011XC2
                  199,66 @*)
               end
               (* @CC_LG 7008(8,8)(327,87) @*)
               ::=
               (<OptRightSideList>)
               (* @CC_LG 7009(8,8)(12,14) @*)
            end;

            transformation Rename ( Name : string ; Id : UNIT) =

               begin
                  obl_node `1 = Id;
                  (* @CC_LG 6007(36,28)(59,21) @*)
               end
               (* @CC_LG 7008(8,8)(75,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,28)(59,21) @*)
               end
               (* @CC_LG 7009(8,8)(75,47) @*)
               transfer 1'.name := Name;
            end;

            transformation Hide ( Id : UNIT) =

               HideLocal ( Id, isVisible )
               & for_all p := elem ( Id.hideAlso ( isVisible ) )
                 do
                    HideLocal ( p, isVisible )
                 end
            end;

            transformation HideForPerson ( Id : UNIT ; PersonId : PERSON) =

               use VFlag := PersonId.id
               do
                  HideLocal ( Id, VFlag )
                  & for_all p := elem ( Id.hideAlso ( VFlag ) )
                    do
                       HideLocal ( p, VFlag )
                    end
               end
            end;

            transformation HideLocal ( Id : UNIT ; VFlag : integer) =

               begin
                  obl_node `1 = Id;
                  (* @CC_LG 6007(36,28)(59,21) @*)
               end
               (* @CC_LG 7008(8,8)(75,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,28)(59,21) @*)
               end
               (* @CC_LG 7009(8,8)(75,47) @*)
               transfer 1'.visible := `1.visible but_not VFlag;
            end;

            path showAlso( VFlag : integer) : UNIT -> UNIT =
                  dependent
               &  not valid (VFlag in self.visible)
            end;

            transformation Show ( Id : UNIT) =

               ShowLocal ( Id, isVisible )
               & for_all p := elem ( Id.showAlso ( isVisible ) )
                 do
                    ShowLocal ( p, isVisible )
                 end
            end;

            transformation ShowForPerson ( Id : UNIT ; PersonId : PERSON) =

               use VFlag := PersonId.id
               do
                  ShowLocal ( Id, VFlag )
                  & for_all p := elem ( Id.showAlso ( VFlag ) )
                    do
                       ShowLocal ( p, VFlag )
                    end
               end
            end;

            transformation ShowLocal ( Id : UNIT ; VFlag : integer) =

               begin
                  obl_node `1 = Id;
                  (* @CC_LG 6007(36,28)(59,21) @*)
               end
               (* @CC_LG 7008(8,8)(75,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,28)(59,21) @*)
               end
               (* @CC_LG 7009(8,8)(75,47) @*)
               transfer 1'.visible := `1.visible or VFlag;
            end;

      end;
      (* @CC_LG 7013(936,403)(128,42) @*)
      (* @CC_LC
      QueryOps HC0
      PersonScheme TA0
      QueryOps AB0
      QueryOps LA0 @*)

      section ClassifierOps

         declares

            transformation InitFOCS ( Name : string ; out ViewId : View) =

               begin
                  not_node `1 : FEATURE;
                  (* @CC_LG 6013(96,56)(97,29) @*)
               end
               (* @CC_LG 7008(8,8)(157,91) @*)
               ::=
               begin
                  1' : View;
                  (* @CC_LG 6012(96,56)(97,29) @*)
               end
               (* @CC_LG 7009(8,8)(157,91) @*)
               transfer 1'.name := Name;
                        1'.visible := alwaysVisible;
               return ViewId := 1';
            end;

            transformation AddSubclass ( Name : string ; ClassIds : Class [1:n]
                                                         (* @CC_LT HoriWithIndent @*) ; Type (* @CC_LT VertWithSpace @*) : type_in FEATURE (* @CC_LT HoriWithIndent @*)
                                                                                                                                           (* @CC_LT HoriWithIndent @*)
                                          ; out SubclassId :    Type (* @CC_LT VertWithIndent @*)
                                                                     (* @CC_LT VertWithIndent @*))
               =

               begin
                  obl_set `1 = ClassIds;
                  (* @CC_LG 6011(96,56)(97,29) @*)
               end
               (* @CC_LG 7008(8,8)(162,91) @*)
               ::=
               begin
                  2' : Type;
                  (* @CC_LG 6012(96,56)(97,29) @*)
                  obl_set 1' = `1;
                  (* @CC_LG 6011(96,158)(97,29) @*)
                  1' -> 2' : sub;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(162,193) @*)
               transfer 2'.name := Name;
               return SubclassId := 2';
            end;

            transformation AddFacet ( Name : string ; ViewId : View ; Type : type_in FEATURE (* @CC_LT HoriWithSpace @*)
                                                                                             (* @CC_LT HoriWithSpace @*)
                                       ; out FacetId :    Type (* @CC_LT VertWithIndent @*))
               =

               begin
                  obl_node `1 = ViewId;
                  (* @CC_LG 6007(48,28)(83,21) @*)
               end
               (* @CC_LG 7008(8,8)(99,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(101,150)(59,21) @*)
                  2' : Type;
                  (* @CC_LG 6012(96,56)(97,29) @*)
                  1' -> 2' : has;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(157,181) @*)
               transfer 2'.name := Name;
               return FacetId := 2';
            end;

            transformation DelFeature ( FeatureId : FEATURE) =

               DelObject ( FeatureId.type, FeatureId )
            end;

            transformation AddSatisfies ( FromId, ToId : Class) =

               begin
                  obl_node `1 = FromId;
                  (* @CC_LG 6007(216,28)(83,21) @*)
                  obl_node `2 = ToId;
                  (* @CC_LG 6007(48,28)(71,21) @*)
                  `2 #> `1 : satisfies *;
                  (* @CC_LG 3007C @*)
               end
               (* @CC_LG 7008(8,8)(267,61) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(204,28)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(36,28)(59,21) @*)
                  1' -> 2' : satisfies (* @CC_LG 1002C,BC(0,-10)(54,10) @*);
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(243,47) @*)
            end;

            transformation DelSatisfies ( FromId, ToId : Class) =

               begin
                  obl_node `1 = FromId;
                  (* @CC_LG 6007(216,28)(83,21) @*)
                  obl_node `2 = ToId;
                  (* @CC_LG 6007(48,28)(71,21) @*)
                  `1 -> `2 : satisfies;
                  (* @CC_LG 3004 @*)
               end
               (* @CC_LG 7008(8,8)(267,61) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(204,28)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(36,28)(59,21) @*)
               end
               (* @CC_LG 7009(8,8)(243,47) @*)
            end;

      end;
      (* @CC_LG 7013(553,697)(146,42) @*)
      (* @CC_LC
      PersonScheme LA0
      ComponentOps TA0
      PersonScheme BE0 @*)

      section ComponentOps

         declares

            transformation AddCode ( Name : string ; Author : string ; WebAddr :    string
                                                                                    (* @CC_LT VertWithIndent @*) ;
                                      ClassIds : Class [1:n]
                                      (* @CC_LT VertWithIndent @*) ; out CodeId :    Code (* @CC_LT VertWithIndent @*))
               =

               begin
                  obl_set `1 = ClassIds;
                  (* @CC_LG 6011(96,56)(97,29) @*)
               end
               (* @CC_LG 7008(8,8)(162,91) @*)
               ::=
               begin
                  obl_set 1' = `1;
                  (* @CC_LG 6011(96,158)(97,29) @*)
                  2' : Code;
                  (* @CC_LG 6012(96,56)(97,29) @*)
                  1' -> 2' : ref;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(162,193) @*)
               transfer 2'.name := Name;
                        2'.author := Author;
                        2'.www := WebAddr;
               return CodeId := 2';
            end;

            transformation AddUse ( From, To : Code) =

               begin
                  obl_node `1 = From;
                  (* @CC_LG 6007(48,28)(71,21) @*)
                  obl_node `2 = To;
                  (* @CC_LG 6007(192,28)(59,21) @*)
                  `2 #> `1 : uses +;
                  (* @CC_LG 3007 @*)
               end
               (* @CC_LG 7008(8,8)(231,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,28)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(180,28)(59,21) @*)
                  1' -> 2' : uses;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(219,47) @*)
            end;

            transformation DelUse ( From, To : Code) =

               begin
                  obl_node `1 = From;
                  (* @CC_LG 6007(48,28)(71,21) @*)
                  obl_node `2 = To;
                  (* @CC_LG 6007(192,28)(59,21) @*)
                  `1 -> `2 : uses;
                  (* @CC_LG 3004 @*)
               end
               (* @CC_LG 7008(8,8)(231,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,28)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(180,28)(59,21) @*)
               end
               (* @CC_LG 7009(8,8)(219,47) @*)
            end;

            transformation AddDocu ( Name : string ; Author : string ; WebAddr :    string
                                                                                    (* @CC_LT VertWithIndent @*) ; CodeId :    Code (* @CC_LT VertWithIndent @*)
                                      ; ClassIds : Class [0:n] ; out DocuId :    Documentation (* @CC_LT VertWithIndent @*))
               =

               begin
                  opt_set `1 = ClassIds;
                  (* @CC_LG 6010(144,56)(97,21) @*)
                  obl_node `2 = CodeId;
                  (* @CC_LG 6007(89,28)(83,21) @*)
               end
               (* @CC_LG 7008(8,8)(243,91) @*)
               ::=
               begin
                  opt_set 1' = `1;
                  (* @CC_LG 6010(72,224)(97,29) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(72,28)(59,21) @*)
                  3' : Documentation;
                  (* @CC_LG 6012(72,122)(97,29) @*)
                  1' -> 3' : ref (* @CC_LG 1002C,LC(10,0)(18,10) @*);
                  (* @CC_LG 3004C @*)
                  3' -> 2' : describes (* @CC_LG 1002C,RC(-10,0)(54,10) @*);
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(219,259) @*)
               transfer 3'.name := Name;
                        3'.author := Author;
                        3'.www := WebAddr;
               return DocuId := 3';
            end;

            transformation DelComponent ( ComponentId : COMPONENT) =

               DelObject ( ComponentId.type, ComponentId )
            end;

            transformation AddRef ( From : COMPONENT ; To : Class) =

               begin
                  obl_node `1 = From;
                  (* @CC_LG 6007(48,84)(71,21) @*)
                  obl_node `2 = To;
                  (* @CC_LG 6007(48,28)(59,21) @*)
               end
               (* @CC_LG 7008(8,8)(99,103) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,84)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(36,28)(59,21) @*)
                  2' -> 1' : ref (* @CC_LG 1002C,BC(0,-10)(18,10) @*);
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(75,103) @*)
            end;

            transformation DelRef ( From : COMPONENT ; To : Class) =

               begin
                  obl_node `1 = From;
                  (* @CC_LG 6007(48,84)(71,21) @*)
                  obl_node `2 = To;
                  (* @CC_LG 6007(48,28)(59,21) @*)
                  `2 -> `1 : ref;
                  (* @CC_LG 3004 @*)
               end
               (* @CC_LG 7008(8,8)(99,103) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,84)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(36,28)(59,21) @*)
               end
               (* @CC_LG 7009(8,8)(75,103) @*)
            end;

            path superClass : Class -> Class =
               <-sub- *
            end;

            path requiredClass : Class -> Class =
                  (     <-has-
                    or  <-sub- ) *
               &  { instance_of View :: -has-> }
               &  instance_of Class
            end;

            path missingClass : Code -> Class =
                        (    <-ref-
                          &  requiredClass )
               but_not  (    <-ref-
                          &  superClass )
            end;

            transformation IncompleteClassified ( out CodeId : Code [1:n]) =

               begin
                  obl_set `1 : Code;
                  (* @CC_LG 6011(60,28)(97,21) @*)
                  => `1 : with missingClass;
                  (* @CC_LG
                  3011XC2
                  182,77 @*)
               end
               (* @CC_LG 7008(8,8)(306,100) @*)
               ::=
               begin
                  obl_set 1' = `1;
                  (* @CC_LG 6011(96,56)(97,29) @*)
               end
               (* @CC_LG 7009(8,8)(162,91) @*)
               transfer 1'.visible := isVisible;
               return CodeId := `1;
            end;

            transformation MissingClasses ( CodeId : Code ; out ClassIds : Class [1:n]) =

               begin
                  obl_node `1 = CodeId;
                  (* @CC_LG 6007(84,150)(83,21) @*)
                  obl_set `2 : Class;
                  (* @CC_LG 6011(84,56)(97,29) @*)
                  `1 => `2 : missingClass;
                  (* @CC_LG 3008C @*)
               end
               (* @CC_LG 7008(8,8)(162,181) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(96,28)(59,21) @*)
                  obl_set 2' = `2;
                  (* @CC_LG 6011(96,70)(97,29) @*)
               end
               (* @CC_LG 7009(8,8)(162,103) @*)
               transfer 2'.visible := isVisible;
               return ClassIds := 2';
            end;

      end;
      (* @CC_LG 7013(754,697)(140,42) @*)
      (* @CC_LG 7013(696,392)(140,42) @*)
      (* @CC_LC
      PersonScheme RA0
      ClassifierOps TA0
      PersonOps BA0
      PersonScheme BE0 @*)

      section IndexOps

         declares

            transformation AddTerm ( Name : string ; out TermId : Key) =

               begin
                  not_node `2 : INDEX;
                  (* @CC_LG 6013(60,28)(97,21) @*)
                  => `2 : valid (self.name = Name)
                                (* @CC_LG 4005LC,RC(-3,24)(144,12) @*)
                          (* @CC_LG 4005LC,RC(-3,24)(144,12) @*)      ;
                  (* @CC_LG
                  3011XC2
                  182,78 @*)
               end
               (* @CC_LG 7008(8,8)(351,105) @*)
               ::=
               begin
                  1' : Key;
                  (* @CC_LG 6012(96,56)(97,29) @*)
               end
               (* @CC_LG 7009(8,8)(157,91) @*)
               transfer 1'.name := Name;
               return TermId := 1';
            end;

            transformation AddSynonym ( Name : string ; TermId : Key ; out SynonymId :    Synonym (* @CC_LT VertWithIndent @*))
               =

               begin
                  obl_node `1 = TermId;
                  (* @CC_LG 6007(197,28)(83,21) @*)
                  not_node `2 : INDEX;
                  (* @CC_LG 6013(60,28)(97,21) @*)
                  => `2 : valid (self.name = Name)
                                (* @CC_LG 4005LC,RC(-3,24)(144,12) @*)
                          (* @CC_LG 4005LC,RC(-3,24)(144,12) @*)      ;
                  (* @CC_LG
                  3011XC2
                  182,78 @*)
               end
               (* @CC_LG 7008(8,8)(347,105) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(72,28)(59,21) @*)
                  2' : Synonym;
                  (* @CC_LG 6012(72,122)(97,29) @*)
                  2' -> 1' : like;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(157,157) @*)
               transfer 2'.name := Name;
               return SynonymId := 2';
            end;

            query FindWithKey( Name : string ; out KeyId : Key) =
               begin
                  obl_node `1 : Key;
                  (* @CC_LG 6007(48,28)(71,21) @*)
               end
               (* @CC_LG 7008(8,8)(99,47) @*)
               condition `1.name = Name;
               return KeyId := `1;
            end;

            query FindWithSynonym( Name : string ; out KeyId : Key) =
               begin
                  obl_node `1 : Key;
                  (* @CC_LG 6007(47,27)(71,21) @*)
                  obl_node `2 : Synonym;
                  (* @CC_LG 6007(168,28)(89,21) @*)
                  `2 -> `1 : like;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7008(8,8)(231,47) @*)
               condition `2.name = Name;
               return KeyId := `1;
            end;

            transformation Find ( Index : string ; out KeyId : Key) =

               use v : Key
               do
                  begin
                        FindWithKey ( Index, out v )
                     or FindWithSynonym
                           ( Index, out v )
                           (* @CC_LT VertWithIndent @*)
                  end
                  (* @CC_LT Vertical @*)
                  & Show ( v )
                  & KeyId := v
               end
            end;

            transformation AddKey ( ComponentId : COMPONENT ; KeyId : Key) =

               begin
                  obl_node `1 = ComponentId;
                  (* @CC_LG 6007(72,28)(113,21) @*)
                  obl_node `2 = KeyId;
                  (* @CC_LG 6007(72,84)(83,21) @*)
               end
               (* @CC_LG 7008(8,8)(135,103) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,28)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(36,84)(59,21) @*)
                  2' -> 1' : of (* @CC_LG 1002C,BC(0,-10)(18,10) @*);
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(75,103) @*)
            end;

            transformation DeleteKey ( ComponentId : COMPONENT ; KeyId : Key) =

               begin
                  obl_node `1 = ComponentId;
                  (* @CC_LG 6007(72,28)(113,21) @*)
                  obl_node `2 = KeyId;
                  (* @CC_LG 6007(72,84)(83,21) @*)
                  `2 -> `1 : of;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7008(8,8)(135,103) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(36,28)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(36,84)(59,21) @*)
               end
               (* @CC_LG 7009(8,8)(75,103) @*)
            end;

      end;
      (* @CC_LG 7013(942,599)(116,42) @*)
      (* @CC_LC
      QueryOps LA0
      PersonOps AB0
      QueryOps BE0
      PersonOps LA0 @*)

      section QueryOps

         declares

            transformation QueryKey ( KeyId : Key ; out QueryId : KeyQuery) =

               begin
                  obl_node `1 = KeyId;
                  (* @CC_LG 6007(48,28)(83,21) @*)
               end
               (* @CC_LG 7008(8,8)(99,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(72,28)(59,21) @*)
                  2' : KeyQuery;
                  (* @CC_LG 6012(72,122)(97,29) @*)
                  2' -> 1' : withKey;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(157,157) @*)
               transfer 2'.visible := isVisible;
               return QueryId := 2';
            end;

            transformation QueryClass ( ClassId : Class ; out QueryId : ClassQuery) =

               begin
                  obl_node `1 = ClassId;
                  (* @CC_LG 6007(60,28)(89,21) @*)
               end
               (* @CC_LG 7008(8,8)(111,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(72,28)(59,21) @*)
                  2' : ClassQuery;
                  (* @CC_LG 6012(72,122)(97,29) @*)
                  2' -> 1' : inClass;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(157,157) @*)
               transfer 2'.visible := isVisible;
               return QueryId := 2';
            end;

            transformation QuerySetOp ( OpType : type_in SET_OP ; Arg1Id, Arg2Id :    QUERY (* @CC_LT VertWithIndent @*)
                                         ; out QueryId :    OpType (* @CC_LT VertWithIndent @*))
               =

               begin
                  obl_node `1 = Arg1Id;
                  (* @CC_LG 6007(48,28)(83,21) @*)
                  obl_node `2 = Arg2Id;
                  (* @CC_LG 6007(180,28)(83,21) @*)
               end
               (* @CC_LG 7008(8,8)(231,47) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(65,28)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(161,28)(59,21) @*)
                  3' : OpType;
                  (* @CC_LG 6012(132,122)(97,21) @*)
                  3' -> 1' : arg1 (* @CC_LG 1002C,RC(-10,0)(24,10) @*);
                  (* @CC_LG 3004C @*)
                  3' -> 2' : arg2 (* @CC_LG 1002C,LC(10,0)(24,10) @*);
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(210,157) @*)
               transfer 3'.visible := isVisible;
               return QueryId := 3';
            end;

            transformation DelQuery ( QueryId : QUERY) =

               DelObject ( QueryId.type, QueryId )
            end;

            transformation EvalQuery ( QueryId : QUERY ;
                                        out ComponentIds : COMPONENT [0:n]
                                        (* @CC_LT VertWithIndent @*)      ) =

               begin
                  obl_node `1 = QueryId;
                  (* @CC_LG 6007(96,154)(89,21) @*)
                  opt_set `2 : COMPONENT;
                  (* @CC_LG 6010(96,56)(97,29) @*)
                  `1 => `2 : result;
                  (* @CC_LG 3008C @*)
               end
               (* @CC_LG 7008(8,8)(162,181) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(96,84)(59,21) @*)
                  opt_set 2' = `2;
                  (* @CC_LG 6010(96,28)(97,29) @*)
               end
               (* @CC_LG 7009(8,8)(162,103) @*)
               transfer 2'.visible := isVisible;
               return ComponentIds := 2';
            end;

      end;
      (* @CC_LG 7013(942,501)(116,42) @*)
      (* @CC_LC
      IndexOps LA0
      IndexOps AB0
      GenericOps BE0
      PersonScheme RF0
      GenericOps LA0
      GenericOps HC0 @*)

      section PersonScheme

         declares

            node_class PERSON is_a UNIT
               derived
                  id : integer = value ( string ( self ), integer );
                  (* @CC_LG
                  3012XC2
                  96,0 @*)
               intrinsic
                  password : string;
                  (* @CC_LG
                  3010XC2
                  0,56 @*)
            end;
            (* @CC_LG 6007(172,138)(97,29) @*)

            node_type Administrator : PERSON
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(280,54)(97,29) @*)

            node_type Librarian : PERSON
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(172,54)(97,29) @*)

            node_type User : PERSON
               (<OptMethodList>)
               (* @CC_LG 3005C @*)
            end;
            (* @CC_LG 6013(64,54)(97,29) @*)

      end;
      (* @CC_LG 7013(553,403)(341,228) @*)
      (* @CC_LC
      QueryOps LF0
      GenericOps TA0
      QueryScheme TA0
      ClassifierOps AB0
      GlobalScheme BE0
      ComponentOps AB0
      ComponentOps RA0
      ClassifierOps LA0
      QueryScheme RF0 @*)

      section PersonOps

         declares

            transformation CreatePerson ( Type : type_in PERSON ; Name, Password : string ; out PersonId : Type)
               =

               begin
                  not_node `1 : Type;
                  (* @CC_LG 6013(60,28)(97,21) @*)
                  => `1 : valid (self.name = Name)
                                (* @CC_LG 4005LC,RC(-2,-24)(144,12) @*)
                          (* @CC_LG 4005LC,RC(-2,-24)(144,12) @*)      ;
                  (* @CC_LG
                  3011XC2
                  182,78 @*)
               end
               (* @CC_LG 7008(8,8)(351,131) @*)
               ::=
               begin
                  1' : Type;
                  (* @CC_LG 6012(60,28)(97,21) @*)
               end
               (* @CC_LG 7009(8,8)(123,61) @*)
               transfer 1'.name := Name;
                        1'.password := Password;
               return PersonId := 1';
            end;

            transformation DelPerson ( PersonId : PERSON) =

               DelObject ( PersonId.type, PersonId )
            end;

            query Login( Type : type_in PERSON ; Name, Password : string ; out PersonId : Type ; out VFlags : integer [0:n])
            =
               begin
                  obl_node `1 : Type;
                  (* @CC_LG 6007(48,28)(71,21) @*)
               end
               (* @CC_LG 7008(8,8)(99,55) @*)
               condition `1.name = Name;
                         `1.password = Password;
               return PersonId := `1;
                      VFlags := alwaysVisible or isVisible or `1.id;
            end;

            query Logout( PersonId : PERSON ; VFlags : integer [0:n] ; out NewFlags : integer [0:n])
            =
               begin
                  obl_node `1 = PersonId;
                  (* @CC_LG 6007(60,28)(95,21) @*)
               end
               (* @CC_LG 7008(8,8)(123,47) @*)
               condition `1.id in VFlags;
               return NewFlags := nil;
            end;

      end;
      (* @CC_LG 7013(942,697)(122,42) @*)
      (* @CC_LC
      IndexOps LA0
      ComponentOps BA0
      IndexOps BE0 @*)

      transformation MAIN =

         use RootId : View;
             DomainId, KindId, LicenceId, UIBuilderId, LayoutId, WindowManagerId, ToolkitId, ToolId,
                CommercialId, PublicDomainId, ScriptsId, UIScriptsId
                : Class                                                                             ;
             XWindowId, GraphEDId, TclTkId, TkLayoutId, PerlId : Code;
             CodeId : Code;
             CodeIds : Code [0:n];
             ClassIds : Class [0:n];
             BookId : Documentation;
             tcltkId, KeyId : Key;
             tktclId : Synonym;
             Query1Id : KeyQuery;
             Query2Id : ClassQuery;
             QueryId : And;
             ComponentIds : COMPONENT [0:n];
             AdminId : Administrator;
             LibId : Librarian;
             UserId : User;
             VFlags : integer [0:n]
         do
            CreatePerson ( Administrator, "Albert", "hugo", out AdminId )
            & Login ( Administrator, "Albert", "hugo", out AdminId, out VFlags )
            & InitFOCS ( "UITools", out RootId )
            & CreatePerson ( Librarian, "Andreas", "sommer", out LibId )
            & CreatePerson ( User, "Kai", "tkwuerg", out UserId )
            & AddFacet ( "Domain", RootId, Class, out DomainId )
            & AddFacet ( "Kind", RootId, Class, out KindId )
            & AddFacet ( "Licence", RootId, Class, out LicenceId )
            & AddSubclass ( "UIBuilder", DomainId, Class, out UIBuilderId )
            & AddSubclass (* @CC_LT Horizontal @*) ( "Scripts", DomainId, Class, out ScriptsId )
                                                   (* @CC_LT HoriWithIndent @*)
            & AddSubclass ( "Layout", DomainId, Class, out LayoutId )
            & AddSubclass ( "WindowManager", DomainId, Class, out WindowManagerId )
            & AddSubclass ( "Toolkit", KindId, Class, out ToolkitId )
            & AddSubclass ( "Tool", KindId, Class, out ToolId )
            & AddSubclass ( "Commercial", LicenceId, Class, out CommercialId )
            & AddSubclass ( "Public Domain", LicenceId, Class, out PublicDomainId )
            & AddSubclass ( "UIScripts", UIBuilderId or ScriptsId, Class, out UIScriptsId )
            & AddSatisfies ( CommercialId, PublicDomainId )
            & Hide ( LicenceId )
            & AddCode ( "XWindow", "MIT", "www", WindowManagerId or ToolkitId or PublicDomainId, out XWindowId
                      )
            & AddCode ( "GraphED", "Uni Passau", "www", ToolId or LayoutId or PublicDomainId, out GraphEDId
                      )
            & AddCode ( "Tcl/Tk", "Do not know", "www", ToolkitId or UIScriptsId or PublicDomainId, out TclTkId
                      )
            & AddCode ( "TkLayout", "TU Berlin", "www", ToolkitId or LayoutId or UIScriptsId, out TkLayoutId
                      )
            & AddUse ( TkLayoutId, TclTkId )
            & AddUse ( TclTkId, XWindowId )
            & AddDocu ( "Tcl/Tk Book", "Do not know", "www", TclTkId, ToolkitId, out BookId )
            & AddRef ( BookId, UIScriptsId )
            & AddCode ( "Perl", "Do not know", "www", ScriptsId, out PerlId )
            & IncompleteClassified ( out CodeIds )
            & CodeId := elem ( CodeIds )
            & MissingClasses ( CodeId, out ClassIds )
            & AddTerm ( "tcl/tk", out tcltkId )
            & AddSynonym ( "tk/tcl", tcltkId, out tktclId )
            & AddKey ( TkLayoutId, tcltkId )
            & AddKey ( TclTkId, tcltkId )
            & Find ( "tk/tcl", out KeyId )
            & QueryKey ( KeyId, out Query1Id )
            & Rename ( "tk/tcl?", Query1Id )
            & QueryClass ( LayoutId, out Query2Id )
            & Rename ( "Layout?", Query2Id )
            & QuerySetOp ( And, Query1Id, Query2Id, out QueryId )
            & Rename ( "tk/tcl and layout?", QueryId )
            & EvalQuery ( QueryId, out ComponentIds )
            & Hide ( KeyId )
            & Show ( KeyId )
            & Hide ( RootId )
         end
      end;

end.
(* @CC_LG 7012(8,8)(1094,769) @*)
