spec R (* Creates simple resistor networks using a *)
       (* context-free graph grammar. Will be      *)
       (* completed with rules for parsing/analy-  *)
       (* zing (arbitrary) resistor networks.      *)

   declares

      node_class B end;

      edge_type w : B -> B;

      node_class R is_a B
         intrinsic
            rv : integer;
      end;

      node_type r : R end;

      node_class C is_a B end;

      node_type c : C end;

      node_class U is_a B
         intrinsic
            uv : integer;
      end;

      node_type u : U end;

      transformation Create =
         (<OptPrecondDecl>)
         (* @CC_LG 7008(8,8)(305,20) @*)

         (<OptLeftSideList>)
         (* @CC_LG 7008C(39,33) @*)
         ::=
         begin
            1' : u;
            (* @CC_LG 6012(180,224)(97,21) @*)
            2' : c;
            (* @CC_LG 6012(180,126)(97,21) @*)
            3' : r;
            (* @CC_LG 6012(156,28)(97,21) @*)
            4' : c;
            (* @CC_LG 6012(156,322)(97,21) @*)
            1' -> 2' : w;
            (* @CC_LG 3004C @*)
            2' -> 3' : w;
            (* @CC_LG
            3004C3
            156,84 @*)
            3' -> 4' : w;
            (* @CC_LG
            3004C7
            132,84
            108,112
            108,224
            132,252
            132,280 @*)
            4' -> 1' : w;
            (* @CC_LG
            3004C3
            156,280 @*)
         end
         (* @CC_LG 7009(8,8)(305,357) @*)
         transfer 1'.uv := 240;
                  3'.rv := 360;
      end;

      transformation Parallel =

         begin
            obl_node `1 : r;
            (* @CC_LG 6007(73,152)(51,25) @*)
            opt_set `2 : c;
            (* @CC_LG 6010(72,252)(97,29) @*)
            `2 -> `1 : w;
            (* @CC_LG 3004C @*)
            opt_set `3 : c;
            (* @CC_LG 6010(96,56)(97,29) @*)
            `1 -> `3 : w;
            (* @CC_LG 3004C @*)
         end
         (* @CC_LG 7008(8,8)(305,287) @*)
         ::=
         begin
            opt_set 2' = `2;
            (* @CC_LG 6010(144,452)(97,29) @*)
            opt_set 3' = `3;
            (* @CC_LG 6010(144,56)(97,29) @*)
            5' : r;
            (* @CC_LG 6012(72,252)(97,29) @*)
            4' : r;
            (* @CC_LG 6012(216,252)(97,29) @*)
            7' : c;
            (* @CC_LG 6012(144,350)(97,29) @*)
            6' : c;
            (* @CC_LG 6012(144,154)(97,29) @*)
            2' -> 7' : w;
            (* @CC_LG 3004C @*)
            7' -> 5' : w;
            (* @CC_LG 3004C @*)
            5' -> 6' : w;
            (* @CC_LG 3004C @*)
            6' -> 3' : w;
            (* @CC_LG 3004C @*)
            7' -> 4' : w;
            (* @CC_LG 3004C @*)
            4' -> 6' : w;
            (* @CC_LG 3004C @*)
         end
         (* @CC_LG 7009(8,8)(305,487) @*)
         transfer 4'.rv := 512;
                  5'.rv := 512;
      end;

      transformation Sequence =

         begin
            obl_node `1 : r;
            (* @CC_LG 6007(73,152)(51,25) @*)
            opt_set `2 : c;
            (* @CC_LG 6010(72,252)(97,29) @*)
            `2 -> `1 : w;
            (* @CC_LG 3004C @*)
            opt_set `3 : c;
            (* @CC_LG 6010(72,56)(97,29) @*)
            `1 -> `3 : w;
            (* @CC_LG 3004C @*)
         end
         (* @CC_LG 7008(8,8)(305,287) @*)
         ::=
         begin
            opt_set 2' = `2;
            (* @CC_LG 6010(96,452)(97,29) @*)
            opt_set 3' = `3;
            (* @CC_LG 6010(96,56)(97,29) @*)
            5' : r;
            (* @CC_LG 6012(96,350)(97,29) @*)
            4' : r;
            (* @CC_LG 6012(96,154)(97,29) @*)
            2' -> 5' : w;
            (* @CC_LG 3004C @*)
            4' -> 3' : w;
            (* @CC_LG 3004C @*)
            1' : c;
            (* @CC_LG 6012(96,252)(97,29) @*)
            5' -> 1' : w;
            (* @CC_LG 3004C @*)
            1' -> 4' : w;
            (* @CC_LG 3004C @*)
         end
         (* @CC_LG 7009(8,8)(305,487) @*)
         transfer 4'.rv := 128;
                  5'.rv := 128;
      end;

      transformation Grammar_MAIN =

         Create
         & loop
                 Parallel
              or Sequence
           end
      end;

      transformation MAIN =

         Create
         & Parallel
         & Sequence
      end;

end.
