spec TBTrees

   declares

      section Schema

         declares

            node_class Node
               intrinsic
                  Value : integer;
            end;

            node_type AnchorNode : Node end;

            node_type TreeNode : Node end;

            edge_type Root : Node [0:1] -> Node [0:1];

            edge_type l : Node [0:1] -> Node [0:1];

            edge_type r : Node [0:1] -> Node [0:1];

            edge_type n : Node [0:1] -> Node [0:1];

            path Find( NewVal : integer) : Node -> Node [0:1] =
                  -Root->
               &  {    valid (NewVal < self.Value)
                    &  -l->
                  |    valid (NewVal > self.Value)
                    &  -r->                        }
            end;

      end;

      section Operations

         declares

            transformation Create ( out Anchor : Node) =
               (<OptPrecondDecl>)
               (* @CC_LG 7008(8,8)(24,31) @*)

               (<OptLeftSideList>)
               (* @CC_LG 7008C(39,33) @*)
               ::=
               begin
                  1' : AnchorNode;
                  (* @CC_LG 6012(72,42)(113,21) @*)
               end
               (* @CC_LG 7009(8,8)(150,66) @*)
               return Anchor := 1';
            end;

            transformation InsertInEmptyTree ( Anchor : Node ; NewVal : integer) =

               begin
                  obl_node `1 = Anchor;
                  (* @CC_LG 6007(65,33)(89,21) @*)
                  => `1 : not with -Root->;
                  (* @CC_LG
                  3011XC2
                  231,94 @*)
               end
               (* @CC_LG 7008(8,8)(351,117) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(80,146)(65,21) @*)
                  2' : TreeNode;
                  (* @CC_LG 6012(98,56)(101,21) @*)
                  1' -> 2' : Root;
                  (* @CC_LG
                  3004C3
                  72,112 @*)
                  1' -> 2' : n;
                  (* @CC_LG
                  3004C3
                  48,98 @*)
                  2' -> 1' : n;
                  (* @CC_LG
                  3004C3
                  144,98 @*)
               end
               (* @CC_LG 7009(8,8)(180,177) @*)
               transfer 2'.Value := NewVal;
            end;

            transformation InsertFirst ( Anchor : Node ; NewVal : integer) =

               begin
                  obl_node `2 : TreeNode;
                  (* @CC_LG 6007(260,80)(95,21) @*)
                  obl_node `1 = Anchor;
                  (* @CC_LG 6007(64,80)(103,21) @*)
                  `1 => `2 : Find ( NewVal (* @CC_LT Horizontal @*) );
                  (* @CC_LG 3006C @*)
                  => `2 : not with -l->;
                  (* @CC_LG
                  3009XC2
                  240,36 @*)
                  `1 -> `2 : n (* @CC_LG 1002C,BC(30,5)(6,10) @*);
                  (* @CC_LG
                  3004C3
                  162,120 @*)
               end
               (* @CC_LG 7008(8,8)(316,130) @*)
               ::=
               begin
                  obl_node 2' = `2;
                  (* @CC_LG 6007(216,24)(59,21) @*)
                  obl_node 1' = `1;
                  (* @CC_LG 6007(44,24)(59,21) @*)
                  3' (* @CC_LG 1002C,RB(-21,5)(12,10) @*) : TreeNode;
                  (* @CC_LG 6011(129,98)(97,23) @*)
                  2' -> 3' : l;
                  (* @CC_LG 3004C @*)
                  1' -> 3' : n;
                  (* @CC_LG 3004C @*)
                  3' -> 2' : n (* @CC_LG 1002(71,-33)(6,10) @*);
                  (* @CC_LG
                  3004C3
                  189,82 @*)
               end
               (* @CC_LG 7009(8,8)(264,122) @*)
               condition NewVal < `2.Value;
               transfer 3'.Value := NewVal;
            end;

            transformation InsertLast ( Anchor : Node ; NewVal : integer) =

               begin
                  obl_node `1 = Anchor;
                  (* @CC_LG 6007(348,46)(83,21) @*)
                  obl_node `2 : TreeNode;
                  (* @CC_LG 6007(144,46)(95,21) @*)
                  `1 => `2 : Find ( NewVal (* @CC_LT Horizontal @*) );
                  (* @CC_LG 3006C @*)
                  => `2 : not with -r->;
                  (* @CC_LG
                  3009XC2
                  92,14 @*)
                  `2 -> `1 : n;
                  (* @CC_LG
                  3004C3
                  252,106 @*)
               end
               (* @CC_LG 7008(8,8)(396,116) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(288,18)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(46,18)(59,21) @*)
                  3' : TreeNode;
                  (* @CC_LG 6011(164,84)(95,21) @*)
                  3' -> 1' : n;
                  (* @CC_LG 3004C @*)
                  2' -> 3' : r;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(324,108) @*)
               condition `2.Value < NewVal;
               transfer 3'.Value := NewVal;
            end;

            transformation InsertLeftSon ( Anchor : Node ; NewVal : integer) =

               begin
                  obl_node `2 : TreeNode;
                  (* @CC_LG 6007(222,39)(95,21) @*)
                  obl_node `1 = Anchor;
                  (* @CC_LG 6007(412,39)(83,21) @*)
                  obl_node `3 : TreeNode;
                  (* @CC_LG 6007(62,39)(95,21) @*)
                  `1 => `2 : Find ( NewVal (* @CC_LT Horizontal @*) );
                  (* @CC_LG 3008C @*)
                  `3 -> `2 : n;
                  (* @CC_LG 3004C @*)
                  => `2 : not with -l->;
                  (* @CC_LG
                  3011XC2
                  218,80 @*)
               end
               (* @CC_LG 7008(8,8)(474,118) @*)
               ::=
               begin
                  obl_node 1' = `1;
                  (* @CC_LG 6007(324,25)(59,21) @*)
                  obl_node 3' = `3;
                  (* @CC_LG 6007(52,25)(59,21) @*)
                  4' : TreeNode;
                  (* @CC_LG 6012(108,56)(97,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(180,25)(59,21) @*)
                  3' -> 4' : n;
                  (* @CC_LG 3004C @*)
                  4' -> 2' : n;
                  (* @CC_LG
                  3004C3
                  180,81 @*)
                  2' -> 4' : l;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(366,104) @*)
               condition (`3.Value < NewVal) and (NewVal < `2.Value);
               transfer 4'.Value := NewVal;
            end;

            transformation InsertRightSon ( Anchor : Node ; NewVal : integer) =

               begin
                  obl_node `3 : TreeNode;
                  (* @CC_LG 6007(420,66)(95,21) @*)
                  obl_node `1 = Anchor;
                  (* @CC_LG 6007(48,66)(83,21) @*)
                  obl_node `2 : TreeNode;
                  (* @CC_LG 6007(252,66)(95,21) @*)
                  `1 => `2 : Find ( NewVal (* @CC_LT Horizontal @*) );
                  (* @CC_LG 3006C @*)
                  => `2 : not with -r->
                                   (* @CC_LG 4005LC,RC(96,-2)(72,12) @*);
                  (* @CC_LG
                  3009XC2
                  168,28 @*)
                  `2 -> `3 : n;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7008(8,8)(480,88) @*)
               ::=
               begin
                  obl_node 3' = `3;
                  (* @CC_LG 6007(340,24)(59,21) @*)
                  obl_node 1' = `1;
                  (* @CC_LG 6007(48,24)(59,21) @*)
                  obl_node 2' = `2;
                  (* @CC_LG 6007(144,24)(59,21) @*)
                  4' : TreeNode;
                  (* @CC_LG 6012(108,56)(97,21) @*)
                  2' -> 4' : r;
                  (* @CC_LG 3004C @*)
                  2' -> 4' : n;
                  (* @CC_LG
                  3004C3
                  144,66 @*)
                  4' -> 3' : n;
                  (* @CC_LG 3004C @*)
               end
               (* @CC_LG 7009(8,8)(384,80) @*)
               condition (`2.Value <= NewVal) and (NewVal <= `3.Value);
               transfer 4'.Value := NewVal;
            end;

            transformation InsertSon ( Anchor : Node ; NewVal : integer) =

                  InsertLeftSon ( Anchor, NewVal )
               or InsertRightSon ( Anchor, NewVal )
               or InsertLast ( Anchor, NewVal )
               or InsertFirst ( Anchor, NewVal )
               or InsertInEmptyTree ( Anchor, NewVal )
            end;

      end;

      section Main

         declares

            transformation MAIN =

               use Anchor : Node
               do
                  Create ( out Anchor )
                  & InsertSon ( Anchor, 7 )
                  & InsertSon ( Anchor, 4 )
                  & InsertSon ( Anchor, 10 )
                  & InsertSon ( Anchor, 2 )
                  & InsertSon ( Anchor, 5 )
                  & InsertSon ( Anchor, 11 )
               end
            end;

      end;

end.
