/****************************/
/* Source_Transformations.c */
/****************************/

/**************************************************/
/* implementation of imported types and functions */
/**************************************************/

/***************************************************************************/
/*                                                                         */
/*  ATTENTION: please SET environment Variable "IMPORTLIB" according       */
/*             to the library containing the object code of the            */
/*             imported types and functions.                               */
/*                                                                         */
/***************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>


#include "Source_Transformations.h"
#include "pathes.h"

#define MAX_ARRAY 1024


/*****************************************************/
/* implementation of user-defined imported functions */
/*****************************************************/


void Transform_Source (BOOLEAN *outvalue, PGCMString *file,
                       int *start, int *end, PGCMString *prg )
{
  FILE *f;

  char *cmd;
  
  *outvalue = 1;

  f = fopen( "/home/private/staff/katja/project/readi/test/out_data" , "w+");
  if ( f == NULL ) 
    {
      fprintf( stderr, "Datei kann nicht geoeffnet werden");
    }
  else
    {
    fprintf(f, "Start: %i\n", *start);
    fprintf(f, "Ende: %i\n", *end); 
    fprintf(f, "File: %s\n", file);
    fprintf(f, "Prg: %s\n", prg);

    copy_file( file );

    cut_out( file, *start, *end );

    cmd = compose_cmd( file, prg);
    fprintf(f, "Kommando: %s\n", cmd);

    system(cmd);

    compose_parts( file );

    fclose(f);
    
    }

 
}
char* compose_cmd( char *cbl_prg, char *txl_prg )
{
char *cmd;

cmd = malloc(MAX_ARRAY*sizeof(*cmd));

strcat(cmd, TXL_PATH);
strcat(cmd, "txl");
strcat(cmd, " ");
strcat(cmd, COBOL_PATH);
strcat(cmd, cbl_prg);
strcat(cmd, "_cut");
strcat(cmd, " ");
strcat(cmd, TXL_PRG_PATH);
strcat(cmd, txl_prg); 
strcat(cmd, " > ");
strcat(cmd, COBOL_PATH);
strcat(cmd, cbl_prg);
strcat(cmd, "_out");

return cmd;
}

/*******************************************************/
/* cut_out zerlegt eine <>_tmp Datei in drei Dateien:  */
/*                                                     */
/*    - Bereich vor dem zu transformierenden Inkrement */
/*        -> <>_head                                   */
/*                                                     */
/*    - zu transformierendes Inkrement                 */
/*        -> <>_cut                                    */
/*                                                     */
/*    - Bereich nach dem zu transformierenden Inkr.    */
/*        -> <>_tail                                   */
/*                                                     */
/*******************************************************/

void cut_out( char *cbl_file, int start, int end )
{
FILE *f_source, *f_head, *f_cut, *f_tail;

char source[MAX_ARRAY] ="";
char head[MAX_ARRAY]="";
char cut[MAX_ARRAY]="";
char tail[MAX_ARRAY]="";


int i=1; 
char *line;
line = malloc(MAX_ARRAY*sizeof(*line));

/* Zusammenstellung der Pfade */
strcat(source, COBOL_PATH);
strcat(source, cbl_file);
strcat(source, "_tmp");

printf("Source_Datei %s\n", source);

strcat(head, COBOL_PATH);
strcat(head, cbl_file);
strcat(head, "_head");

strcat(cut, COBOL_PATH);
strcat(cut, cbl_file);
strcat(cut, "_cut");

strcat(tail, COBOL_PATH);
strcat(tail, cbl_file);
strcat(tail, "_tail");


/* Oeffnen der DAteien */
f_source = fopen( source , "r");
if ( f_source == NULL ) 
  {
    fprintf( stderr, "Cobol-Source-Datei kann in CUT_OUT nicht geoeffnet werden");
  }

f_head = fopen( head , "w+");
if ( f_head == NULL ) 
  {
    fprintf( stderr, "Head-Datei kann in CUT_OUT nicht geoeffnet werden");
  }


f_cut = fopen( cut , "w+");
if ( f_cut == NULL ) 
  {
    fprintf( stderr, "Cut-Datei kann in CUT_OUT nicht geoeffnet werden");
  }

f_tail = fopen( tail , "w+");
if ( f_tail == NULL ) 
  {
    fprintf( stderr, "Tail-Datei kann in CUT_OUT nicht geoeffnet werden");
  }

/* Aufteilen in die drei unterschiedlichen Dateien */

while ( fgets(line, 1024, f_source) != NULL )
  {
  if ( get_line_number(line) < start ) fprintf(f_head, "%s", line);

  else if ( get_line_number(line) >= start && get_line_number(line) <= end ) 
    fprintf(f_cut, "%s", line);

  else fprintf(f_tail, "%s", line);

  }

/* Schliessen der Dateien */

fclose(f_source);
fclose(f_head);
fclose(f_cut);
fclose(f_tail);
}


void copy_file( char *cbl_file )
{
FILE *f_source, *f_des;

char source[MAX_ARRAY] ="";
char destination[MAX_ARRAY]="";

char *line;
line = malloc(MAX_ARRAY*sizeof(*line));

/* Zusammenstellung der Pfade */
strcat(source, COBOL_PATH);
strcat(source, cbl_file);

strcat(destination, COBOL_PATH);
strcat(destination, cbl_file);
strcat(destination, "_tmp");

f_source = fopen( source , "r");
if ( f_source == NULL ) 
  {
    fprintf( stderr, "Cobol-Source-Datei kann in COPY_FILE nicht geoeffnet werden");
  }

f_des = fopen( destination , "w+");
if ( f_des == NULL ) 
  {
    fprintf( stderr, "Tmp-Datei kann in COPY-FILE nicht geoeffnet werden");
  }


while ( fgets(line, 1024, f_source) != NULL )
  {
  fprintf(f_des, "%s", line);
  }

fclose(f_source);
fclose(f_des);

}


void compose_parts( char *cbl_file )
{
FILE *f_des, *f_head, *f_out, *f_tail;

char destination[MAX_ARRAY] ="";
char head[MAX_ARRAY]="";
char out[MAX_ARRAY]="";
char tail[MAX_ARRAY]="";


char *line;
line = malloc(MAX_ARRAY*sizeof(*line));

/* Zusammenstellung der Pfade */
strcat(destination, COBOL_PATH);
strcat(destination, cbl_file);
strcat(destination, "_tmp");

strcat(head, COBOL_PATH);
strcat(head, cbl_file);
strcat(head, "_head");

strcat(out, COBOL_PATH);
strcat(out, cbl_file);
strcat(out, "_out");

strcat(tail, COBOL_PATH);
strcat(tail, cbl_file);
strcat(tail, "_tail");


/* Oeffnen der Dateien */
f_des = fopen( destination , "w+");
if ( f_des == NULL ) 
  {
    fprintf( stderr, "Cobol-Destination-Datei kann in COMPOSE_PARTS nicht geoeffnet werden");
  }

f_head = fopen( head , "r");
if ( f_head == NULL ) 
  {
    fprintf( stderr, "Head-Datei kann in COMPOSE_PARTS nicht geoeffnet werden");
  }


f_out = fopen( out , "r");
if ( f_out == NULL ) 
  {
    fprintf( stderr, "Out-Datei kann in COMPOSE_PARTS nicht geoeffnet werden");
  }

f_tail = fopen( tail , "r");
if ( f_tail == NULL ) 
  {
    fprintf( stderr, "Tail-Datei kann in COMPOSE_PARTS nicht geoeffnet werden");
  }
while ( fgets(line, 1024, f_head) != NULL )
  {
  fprintf(f_des, "%s", line);
  }

while ( fgets(line, 1024, f_out) != NULL )
  {
  fprintf(f_des, "%s", line);
  }

while ( fgets(line, 1024, f_tail) != NULL )
  {
  fprintf(f_des, "%s", line);
  }

fclose(f_des);
fclose(f_head);
fclose(f_out);
fclose(f_tail);

}

int get_line_number(char *line)
{

int i;
char number[5];

printf("%s\n", line);

while ( (*line) == ' ') 
  {
    printf("Leerzeichen gelesen\n");
    line++;
      }

for (i=0; i<5; i++)
  {
   
   printf("gelesenes Zeichen: %c\n", *line);
   number[i] = *line;
   line++;  
  }
printf("Number: %s\n", number);

i = atoi(number);

printf("Number als int %d\n", i);

return i; 


}



void main()
{

BOOLEAN ptr; 
int i=5; 
int j=10; 
char c[20]="test"; 
char p[10]="dummy.Txl"; 

Transform_Source(&ptr, c, &i, &j, p);

}























