/* Headerdatei fuer GenericSets. */
/* Automatisch generiert */
/* Typedeklarationen stehen in C_Global.h in Abschnitt GenericSets */
#include <m3_aox.h>

#if !defined (C_GenericSets_h_)
#define C_GenericSets_h_

#ifdef __cplusplus
extern "C" {
#endif

#include <ansi.h>
#include <string.h>
#include <stdio.h>
#include <rgglobal.h>
#include <CTypesForM3.h>
#include <C_Local.h>

/**************************************************************************
 *                                                                        *
 *  PROGRES environment: an integrated set of tools for PROgramming       *
 *                       with Graph REwriting Systems.                    *
 *                                                                        *
 *  Copyright (C) 1987-1992  Lehrstuhl Informatik III, RWTH Aachen        *
 *                                                                        *
 *  This library is free software; you can redistribute it and/or         *
 *  modify it under the terms of the GNU Library General Public           *
 *  License as published by the Free Software Foundation; either          *
 *  version 2 of the License, or (at your option) any later version.      *
 *                                                                        *
 *  This library is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *  Library General Public License for more details.                      *
 *                                                                        *
 *  You should have received a copy of the GNU Library General Public     *
 *  License along with this library; if not, write to the Free            *
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    *
 *                                                                        *
 *  Contact Adresses:                                                     *
 *                                                                        *
 *      Dr. Andy Sch"urr (or Cornelia Weigmann),                          *
 *      Lehrstuhl f"ur Informatik III,                                    *
 *      University of Technology Aachen (RWTH Aachen),                    *
 *      Ahornstr. 55,                                                     *
 *      D-5100 Aachen                                                     *
 *                                                                        *
 *  Email to                                                              *
 *                                                                        *
 *      andy@rwthi3.informatik.rwth-aachen.de                             *
 *      cornelia@rwthi3.informatik.rwth-aachen.de (for technical support) *
 *                                                                        *
 **************************************************************************/

 
 
 
 
 /************************************************************************
 *                                                                      *
 *                     Organisatorische Operationen                     *
 *                                                                      *
 ************************************************************************/

void
SetCreate(Set_Type *Set, CARDINAL DataBytes);

void
SetSetUndefined(Set_Type *Set);

BOOLEAN
SetIsDefined(Set_Type Set);

void
SetKill(Set_Type *Set);

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 /************************************************************************
 *                                                                      *
 *                        Informationsprozeduren                        *
 *                                                                      *
 ************************************************************************/

CARDINAL
GetCard(Set_Type Set);

BOOLEAN
IsSetEmpty(Set_Type Set);

CARDINAL
GetElementSize(Set_Type Set);

 
 /**********************************************************************
 * Ermittle die Groesse eines Elements der Menge Set.                 *
 **********************************************************************/

SetCompareProcType
GetCompareProc(Set_Type Set);

 /************************************************************************
 *                                                                      *
 *                          Loeschoperationen                           *
 *                                                                      *
 ************************************************************************/

void
SetRemoveElement(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar);

void
SetDeleteElement(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar, BOOLEAN *Found);

 
 /************************************************************************
 * Einfuege- und Veraenderungsoperationen *
 ************************************************************************/

void
SetInsert(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar);

 /************************************************************************
 * Anfrageoperationen *
 ************************************************************************/

void
SetExtractAnyElement(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar, BOOLEAN *Found);

void
SetExtractRndElement(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar, BOOLEAN *Found);

 
 /************************************************************************
 Mathematische Mengenoperationen *
 ************************************************************************/

BOOLEAN
IsElementOf(Set_Type Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar);

void
SetUnion(Set_Type *FirstSet, Set_Type SecondSet);

void
SetIntersection(Set_Type *FirstSet, Set_Type SecondSet);

void
SetDifference(Set_Type *FirstSet, Set_Type SecondSet);

 
 
 
 /************************************************************************
  Sonstige Prozeduren *
 ************************************************************************/

void
SetCompact(Set_Type *Set);

void
SetCopy(Set_Type Source, Set_Type *Target);

void
SetLoop(Set_Type *Set);

void
SetGet(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar, BOOLEAN *Found);

 
 
 
 /************************************************************************
  Spezielle Operationen *
 ************************************************************************/

void
SetCreateForN(Set_Type *Set, CARDINAL DataBytes, CARDINAL N);

void
SetInsertUptoN(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar);
#ifdef __cplusplus
}
#endif

#endif /* C_GenericSets_h_ */
