/* Headerdatei fuer PGC. */
/* Automatisch generiert */
/* Typedeklarationen stehen in C_Global.h in Abschnitt PGC */


#include <m3_aox.h>
#if !defined (C_PGC_h_)
#define C_PGC_h_
#ifdef __cplusplus
extern "C" {
#endif
#include <ansi.h>
#include <string.h>
#include <stdio.h>
#include <rgglobal.h>
#include <CTypesForM3.h>
#include <C_Local.h>
#include <C_DynamicLinkHandler.h>

void PGCInitRuntime(int argc, char** argv, char** envp);


/**************************************************************************
 *                                                                        *
 *  PROGRES environment: an integrated set of tools for PROgramming       *
 *                       with Graph REwriting Systems.                    *
 *                                                                        *
 *  Copyright (C) 1987-1992  Lehrstuhl Informatik III, RWTH Aachen        *
 *                                                                        *
 *  This library is free software; you can redistribute it and/or         *
 *  modify it under the terms of the GNU Library General Public           *
 *  License as published by the Free Software Foundation; either          *
 *  version 2 of the License, or (at your option) any later version.      *
 *                                                                        *
 *  This library is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *  Library General Public License for more details.                      *
 *                                                                        *
 *  You should have received a copy of the GNU Library General Public     *
 *  License along with this library; if not, write to the Free            *
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    *
 *                                                                        *
 *  Contact Adresses:                                                     *
 *                                                                        *
 *      Dr. Andy Sch"urr (or Cornelia Weigmann OR Albert Zuendorf)        *
 *      Lehrstuhl f"ur Informatik III,                                    *
 *      University of Technology Aachen (RWTH Aachen),                    *
 *      Ahornstr. 55,                                                     *
 *      D-5100 Aachen                                                     *
 *                                                                        *
 *  Email to                                                              *
 *                                                                        *
 *      albert@rwthi3.informatik.rwth-aachen.de                           *
 *      andy@rwthi3.informatik.rwth-aachen.de                             *
 *      cornelia@rwthi3.informatik.rwth-aachen.de (for technical support) *
 *                                                                        *
 **************************************************************************/

void
PGCDeclareScheme ( Surrogate*  Scheme , GraphNumber WorkGraph , PGCMString Name );


void
PGCCommitScheme ( GraphNumber WorkGraph , Surrogate Scheme );



 
 
 
 /*****************************************************************************
 *                                                                           *
 *  Procedures for managing node classes                                     *
 *                                                                           *
 *****************************************************************************/

void
PGCDeclareNodeClass ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString Name , TypeNumber NodeClass );


void
PGCAppendNodeClass ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString Class , PGCMString SuperClass );



 
 /*****************************************************************************
 *                                                                           *
 * Procedures for managing node types                                        *
 *                                                                           *
 *****************************************************************************/

void
PGCDeclareNodeType ( GraphNumber WorkGraph , Surrogate Scheme , BOOLEAN UseMembership , PGCMString Name , TypeNumber NodeType );


void
PGCAppendNodeType ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString Type , PGCMString Class );



 
 /*****************************************************************************
 *                                                                           *
 * Procedures for managing edge types                                        *
 *                                                                           *
 *****************************************************************************/

void
PGCDeclareEdgeType ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString Name , PGCMString Source , Cardinality SourceCard , PGCMString Target , Cardinality TargetCard , TypeNumber Edge );



 /*****************************************************************************
 *                                                                           *
 * Procedures for managing attributes                                        *
 *                                                                           *
 *****************************************************************************/

void
PGCDeclareMetaAttribute ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString DeclFor , PGCMString Name , IndexProperties Props , ValueTypeNumber ValueType , Cardinality ValueCardinality , BOOLEAN ConstLen , CARDINAL L , AttributeNumber Attr );


void
PGCDeclareIntrinsicAttribute ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString DeclFor , PGCMString Name , IndexProperties Props , ValueTypeNumber ValueType , Cardinality ValueCardinality , BOOLEAN ConstLen , CARDINAL L , AttributeNumber Attr );


void
PGCDeclareDerivedAttribute ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString DeclFor , PGCMString Name , IndexProperties Props , ValueTypeNumber ValueType , Cardinality ValueCardinality , BOOLEAN ConstLen , CARDINAL L , AttributeNumber Attr );


void
PGCDeclareConstraintAttribute ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString DeclFor , PGCMString Name , AttributeNumber Attr );


void
PGCDeclareDummyAttribute ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString DeclFor , PGCMString Name , AttributeNumber Attr );


void
PGCDeclareAttrType ( GraphNumber HostGraph , Surrogate Scheme , PGCMString ModuleName , PGCMString TypeName , TypeNumber AttrType );


void
PGCGetStdImpTypeSize ( GraphNumber Graph , TypeNumber Type , CARDINAL*  Size );


void
PGCSetEvalFunction ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString SetForAttr , PGCMString SetForCT , PGCMString Name );


void
PGCGetAttributeNumber ( GraphNumber HostGraph , PGCMString AttrName , AttributeNumber*  AttrNo , BOOLEAN*  Existent );


void
PGCGetAttributeName ( GraphNumber HostGraph , AttributeNumber AttrNo , PGCMString*  AttrName , BOOLEAN*  Existent );


void
PGCAttributeValueToStringSet ( GraphNumber HostGraph , NodeNumber Node , AttributeNumber AttNo , Set_Type*  StringSet , BOOLEAN*  Existent );


void
PGCStringSetToAttributeValue ( GraphNumber HostGraph , NodeNumber Node , AttributeNumber AttNo , Set_Type StringSet , BOOLEAN*  Existent );


void
PGCGetAttributeProperties ( GraphNumber HostGraph , AttributeNumber AttNo , AttributeKind*  Kind , IndexProperties*  Props , PGCMString*  Name , ValueTypeNumber*  ValueType , Cardinality*  AttCard , BOOLEAN*  ConstSize , CARDINAL*  ValueSize , BOOLEAN*  IsNodeType , BOOLEAN*  Existent );


BOOLEAN
PGCIsElemTypeOfGSet ( GraphNumber HostGraph , ValueTypeNumber ValueType );


void
PGCDeclareDirectDependency ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString DeclFor , PGCMString Dep , PGCMString DepOn );


void
PGCDeclareInDependency ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString DeclFor , PGCMString Dep , PGCMString DepOn , PGCMString EdgeName );


void
PGCDeclareOutDependency ( GraphNumber WorkGraph , Surrogate Scheme , PGCMString DeclFor , PGCMString Dep , PGCMString DepOn , PGCMString EdgeName );



 
 
 
 
 
 
 
 
 
 
 
 
 
 
 /********************************************************************
 * Graph-Befehle                                                    *
 ********************************************************************/

void
PGCCreateTypedGraph ( GraphNumber*  Graph , ExternNumber*  ExtNumber , BacktrackInfo*  ChoiceInfo , PGCMString SpecName , PGCMString Version , PGCMString Pool , PGCMString Name , GraphType Type , BOOLEAN UndoRedoPoss );


void
PGCOpenGraphPool ( PGCMString Pool , GraphPoolMode Mode , TStatus*  Stat );


void
PGCCloseGraphPool ( PGCMString Pool );


void
PGCLogin (const  ApplicationName Name );


void
PGCLogout (void);


void
PGCVerifyGraphScheme ( GraphNumber Graph , BacktrackInfo ChoiceInfo , PGCMString SpecName , PGCMString Version , BOOLEAN*  Ok );


void
PGCOpenGraph ( GraphNumber*  Graph , BacktrackInfo*  ChoiceInfo , BOOLEAN*  NotOkay , PGCMString Pool , PGCMString Name , BOOLEAN UndoRedoPoss );


void
PGCCloseGraph ( GraphNumber Graph , BacktrackInfo ChoiceInfo , BOOLEAN Save );


void
PGCGraphExists ( PGCMString PoolName , PGCMString GraphName , BOOLEAN*  Exist );


void
PGCSetChoiceSelectionMode ( BOOLEAN Random );


void
PGCGetChoiceSelectionMode ( BOOLEAN*  Random );


void
PGCSetUniqueIDsOnOff ( GraphNumber Graph , BOOLEAN On );


void
PGCCreateNode ( NodeNumber*  NewNode , GraphNumber Graph , NodeNumber Environment , TypeNumber NodeType );


void
PGCCreateEdge ( GraphNumber Graph , NodeNumber SourceNode , NodeNumber TargetNode , TypeNumber EdgeType );


void
PGCCreateEdgeBundle ( GraphNumber Graph , SetDescription Source , SetDescription Target , TypeNumber EdgeType );


void
PGCDeleteEdge ( GraphNumber Graph , NodeNumber SourceNode , NodeNumber TargetNode , TypeNumber EdgeType );


void
PGCDeleteEdgeBundle ( GraphNumber Graph , SetDescription Source , SetDescription Target , TypeNumber EdgeType );


void
PGCDeleteNodeAndEdges ( GraphNumber Graph , NodeNumber Node );


void
PGCDeleteNodeSetAndEdges ( GraphNumber Graph , SetDescription NodeSet );


void
PGCGetUniqueIDOfNode ( GraphNumber Graph , NodeNumber CurrNode , UniqueID*  GrasId , BOOLEAN*  Exists );


void
PGCGetNodeWithUniqueID ( GraphNumber Graph , UniqueID GrasId , NodeNumber*  CurrNode , BOOLEAN*  Exists );


void
PGCGetAllNodeClasses ( GraphNumber Graph , SetDescription*  NodeClassSet );


void
PGCGetAllEdgeTypes ( GraphNumber Graph , SetDescription*  EdgeTypeSet );


void
PGCGetAllNodesOfGraph ( SetDescription*  Target , GraphNumber Graph );


void
PGCGetAllNodesOfType ( SetDescription*  Target , GraphNumber Graph , TypeNumber NodeType );


void
PGCGetAllNodesOfClass ( SetDescription*  Target , GraphNumber Graph , TypeNumber NodeClass );


void
PGCGetAllNodesOfTypeSet ( SetDescription*  Target , GraphNumber Graph , SetDescription TypeSet );


void
PGCWriteAttribute ( BYTE_ARRAY Source , CARDINAL HighSource, GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo , CARDINAL Len );


void
PGCWriteSetAttribute ( SetDescription Source , GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo );


void
PGCWriteGSetAttribute ( Set_Type Source , GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo );


void
PGCReadAttribute ( BYTE_ARRAY Target , CARDINAL HighTarget, GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo , CARDINAL Len );


void
PGCReadAttributeValid ( BYTE_ARRAY Target , CARDINAL HighTarget, GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo , CARDINAL Len , BOOLEAN*  Valid );


void
PGCReadSuperAttribute ( BYTE_ARRAY Target , CARDINAL HighTarget, GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo , TypeNumber NClass , CARDINAL Len );


void
PGCReadSuperSetAttribute ( SetDescription*  Target , GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo , TypeNumber NClass );


void
PGCReadSuperGSetAttribute ( Set_Type*  Target , GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo , TypeNumber NClass );


void
PGCGetByIndex ( SetDescription*  Target , GraphNumber Graph , AttributeNumber AttNo , BYTE_ARRAY Value , CARDINAL HighValue);


void
PGCReadGSetAttribute ( Set_Type*  Target , GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo );


void
PGCReadGSetAttributeValid ( Set_Type*  Target , GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo , BOOLEAN*  Valid );


void
PGCReadSetAttribute ( SetDescription*  Target , GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo );


void
PGCReadSetAttributeValid ( SetDescription*  Target , GraphNumber Graph , NodeNumber Node , BOOLEAN IsMeta , AttributeNumber AttNo , BOOLEAN*  Valid );


void
PGCUpdateAttrIndex ( GraphNumber Graph , AttributeNumber AttNo );


void
PGCEvalConstrAttribute ( GraphNumber Graph , AttributeNumber AttNo );


void
PGCStartGraphModification ( GraphNumber Graph );


void
PGCEndGraphModification ( GraphNumber Graph );


void
PGCDelayActionExecution ( GraphNumber Graph );


void
PGCReleaseActionExecution ( GraphNumber Graph );


void
PGCActivateDaemon ( GraphNumber Graph , GraphEvent Event , ActionPriority Priority , ActionProc Action );


void
PGCKillDaemon ( GraphNumber Graph , GraphEvent Event , ActionProc Action );


void
PGCRaiseEvent ( GraphNumber Graph , Surrogate p1 , Surrogate p2 , Surrogate p3 );


void
PGCBeginTransaction ( GraphNumber HostGraph , BOOLEAN DisebleBrowserUpdat , BacktrackInfo*  ChoiceInfo );


void
PGCEndTransaction ( GraphNumber HostGraph , BOOLEAN EnableBrowserUpdate , BacktrackInfo ChoiceInfo );


void
PGCEnableBrowserUpdate ( GraphNumber HostGraph );


void
PGCDisableBrowserUpdate ( GraphNumber HostGraph );


void
PGCPendingTransactions ( GraphNumber HostGraph , CARDINAL*  Depth );


void
PGCSetUserCheckpoint ( GraphNumber HostGraph , BacktrackInfo ChoiceInfo );


void
PGCUserUndo ( GraphNumber HostGraph , BacktrackInfo ChoiceInfo , CARDINAL*  N );


void
PGCUserRedo ( GraphNumber HostGraph , BacktrackInfo ChoiceInfo , CARDINAL*  N );



 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 /********************************************************************
 * Mengen-Befehle                                                   *
 ********************************************************************/

void
PGCAssignGenSet ( Set_Type*  Target , Set_Type Source );

SetDescription 
PGCEmptySet ( GraphNumber Graph );


Set_Type
PGCGEmptySet ( CARDINAL TypeLength );


Set_Type
PGCGInitSetOfNSurrogates ( Set_Type Set , Surrogate SurrVal );


INTEGER
PGCCard ( SetDescription Set );


INTEGER
PGCGCard ( Set_Type Set );


BOOLEAN
PGCDef ( SetDescription Set );


BOOLEAN
PGCGDef ( Set_Type Set );


Set_Type
PGCGPlus ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGPlusWithRightAll ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGPlusWithLeftAll ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGMinus ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGMinusWithLeftAll ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGMinusWithRightAll ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGTimes ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGTimesWithRightAll ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGTimesWithLeftAll ( Set_Type Set1 , Set_Type Set2 );

PGCMString 
PGCConcat ( PGCMString Str1 , PGCMString Str2 );


void
PGCCConcat ( PGCMString Str1 , PGCMString Str2 , PGCMString*  ResultStr );


Set_Type
PGCGConcat ( Set_Type Set1 , Set_Type Set2 );


INTEGER
PGCStrPos ( PGCMString Str1 , PGCMString Str2 );


Set_Type
PGCGStrPos ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGDiv ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGDivWithRightAll ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGDivWithLeftAll ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGMod ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGModWithRightAll ( Set_Type Set1 , Set_Type Set2 );


Set_Type
PGCGModWithLeftAll ( Set_Type Set1 , Set_Type Set2 );

SetDescription 
PGCElemToSet ( Surrogate Element , GraphNumber Graph );


Set_Type
PGCGElemToSet ( BYTE_ARRAY Element , CARDINAL HighElement);

SetDescription 
PGCAddElemToSet ( SetDescription Set , NodeNumber Elem );

SetDescription 
PGCDeleteElemFromSet ( SetDescription Set , NodeNumber Elem );


NodeNumber
PGCGetAnyElemOfSet ( SetDescription Set );


BOOLEAN
PGCElemIsInSet ( NodeNumber Elem , SetDescription Set );


BOOLEAN
PGCGElemIsInSet ( BYTE_ARRAY Elem , CARDINAL HighElem, Set_Type Set );


Surrogate
PGCSetToElem ( SetDescription Set );


void
PGCGSetToElem ( BYTE_ARRAY Elem , CARDINAL HighElem, Set_Type Set );

SetDescription 
PGCUnion ( SetDescription Set1 , SetDescription Set2 );


Set_Type
PGCGUnion ( Set_Type Set1 , Set_Type Set2 );

SetDescription 
PGCIntersection ( SetDescription Set1 , SetDescription Set2 );


Set_Type
PGCGIntersection ( Set_Type Set1 , Set_Type Set2 );

SetDescription 
PGCDifference ( SetDescription Set1 , SetDescription Set2 );


Set_Type
PGCGDifference ( Set_Type Set1 , Set_Type Set2 );


INTEGER
PGCSize ( SetDescription Set );


BOOLEAN
PGCIsEmpty ( SetDescription Set );


BOOLEAN
PGCGIsEmpty ( Set_Type Set );


BOOLEAN
PGCIsNotEmpty ( SetDescription Set );


BOOLEAN
PGCGIsNotEmpty ( Set_Type Set );


BOOLEAN
PGCSetEqual ( SetDescription Set1 , SetDescription Set2 );


BOOLEAN
PGCGSetEqual ( Set_Type Set1 , Set_Type Set2 );


BOOLEAN
PGCSetInclusion ( SetDescription Set1 , SetDescription Set2 );


BOOLEAN
PGCGSetInclusion ( Set_Type Set1 , Set_Type Set2 );


void
PGCInitSetDesc ( SetDescription*  Set );


void
PGCInitGenSet ( Set_Type*  Set );


void
PGCKillGenSet ( Set_Type*  Set );


void
PGCAssignSetDesc ( SetDescription*  Target , SetDescription Source );


void
PGCKillSetDesc ( SetDescription*  Set );


BOOLEAN
PGCSelectEl ( SetDescription*  NewLoopSet , NodeNumber*  Elem , SetDescription LoopSet );


BOOLEAN
PGCGSelectEl ( Set_Type*  NewLoopSet , BYTE_ARRAY Elem , CARDINAL HighElem, Set_Type LoopSet );

SetDescription 
PGCTypeCheck ( SetDescription SetVal1 , TypeNumber NodeTypeOrClass , Cardinality Crdlnty , BOOLEAN IsNodeSet , GraphNumber GraphVal );


Set_Type
PGCTypeCheckStandard ( Set_Type GSetVal1 , Cardinality Crdnlty );


/********************************************************************
 * Pfad-Befehle                                                     *
 ********************************************************************/
SetDescription 
PGCNone ( SetDescription Source );

SetDescription 
PGCSelf ( SetDescription Source );


BOOLEAN
PGCTestElemOutToTarget ( GraphNumber Graph , NodeNumber Source , TypeNumber EdgeType );


BOOLEAN
PGCTestElemInFromSource ( GraphNumber Graph , NodeNumber Source , TypeNumber EdgeType );

SetDescription 
PGCSetOutToTarget ( SetDescription Source , TypeNumber EdgeType );


NodeNumber
PGCElemOutToTarget ( GraphNumber Graph , NodeNumber Source , TypeNumber EdgeType );

SetDescription 
PGCSetInFromSource ( SetDescription Source , TypeNumber EdgeType );


NodeNumber
PGCElemInFromSource ( GraphNumber Graph , NodeNumber Source , TypeNumber EdgeType );

SetDescription 
PGCTypeOf ( SetDescription SetVal );


TypeNumber
PGCElemTypeOf ( NodeNumber NodeVal1 , GraphNumber GraphVal1 );

SetDescription 
PGCGetTypesOfClass ( GraphNumber Graph , TypeNumber NodeClass );


BOOLEAN
PGCNodeIsInstanceOf ( GraphNumber Graph , TypeNumber NodeTypeOrClass , NodeNumber Node );


void
PGCShowNodeClassName ( GraphNumber Graph , TypeNumber NodeClass , PGCMString*  Name , BOOLEAN*  Ok );


void
PGCShowNodeTypeName ( GraphNumber Graph , TypeNumber NodeType , PGCMString*  Name , BOOLEAN*  Ok );


void
PGCShowEdgeTypeName ( GraphNumber Graph , TypeNumber EdgeType , PGCMString*  Name , BOOLEAN*  Ok );


void
PGCShowAllNodeTypes ( GraphNumber Graph , TypeNumber NodeClass , SetDescription*  NodeTypeSet );


void
PGCShowDirectSubtypes ( GraphNumber Graph , TypeNumber NodeClass , SetDescription*  NodeTypeSet );


void
PGCShowDirectSubclasses ( GraphNumber Graph , TypeNumber NodeClass , SetDescription*  SetOfClasses );


void
PGCShowDirectSuperclasses ( GraphNumber Graph , TypeNumber NodeClass , SetDescription*  SetOfClasses );


void
PGCShowEdgeTypeProps ( GraphNumber Graph , TypeNumber EdgeType , TypeNumber*  SoupeeNodeClassOrTy , Cardinality*  SourceCardinality , TypeNumber*  TarpetNodeClassOrTy , Cardinality*  TargetCardinality , BOOLEAN*  Existent );


void
PGCTestAndShowEdgeTypeNumber ( GraphNumber Graph , PGCMString Name , TypeNumber*  EdgeType , BOOLEAN*  Existent );


void
PGCTestAndShowNodeClassNumber ( GraphNumber Graph , PGCMString Name , TypeNumber*  NodeClass , BOOLEAN*  Existent );


void
PGCTestAndShowNodeTypeNumber ( GraphNumber Graph , PGCMString Name , TypeNumber*  NodeType , BOOLEAN*  Existent );

SetDescription 
PGCInstanceOfClause ( SetDescription Source , TypeNumber NodeTypeOrClass );

SetDescription 
PGCIsOfClass ( SetDescription Source , TypeNumber NodeClass );

SetDescription 
PGCTypeIsOfClass ( SetDescription Source , TypeNumber NodeClass );

SetDescription 
PGCIsOfTypeSet ( SetDescription Source , SetDescription TypeSet );


BOOLEAN
PGCNodeIsOfClass ( GraphNumber Graph , NodeNumber Source , TypeNumber NodeType );


BOOLEAN
PGCAllInSetIsOfClass ( SetDescription Source , TypeNumber NodeType );


BOOLEAN
PGCNodeIsOfType ( GraphNumber Graph , NodeNumber Source , TypeNumber NodeType );


void
PGCGetOutContextOfNode ( GraphNumber Graph , NodeNumber Source , RelDescription*  Rel );


void
PGCGetInContextOfNode ( GraphNumber Graph , NodeNumber Target , RelDescription*  Rel );


BOOLEAN
PGCAllInSetIsOfType ( SetDescription Source , NodeNumber Node );



 
 /********************************************************************
 * Attributkontroll-Befehle                                         *
 ********************************************************************/

void
PGCDownloadEvalProc ( GraphNumber Graph , EvalFunction ProcPtr , PGCMString ProcName );

PGCMString 
PGCReadEvalFunc ( GraphNumber Graph , TypeNumber NodeType , PGCMString MethStr );


void
PGCReadEvalProcAddr ( GraphNumber Graph , PGCMString ProcName , EvalFunction*  ProcPtr , BOOLEAN*  Exist );


/********************************************************************
 * Nichtdeterministische Befehle                                    *
 ********************************************************************/

void
PGCNDChooseStat ( BacktrackInfo*  BtInfo , SetDescription*  Set , BYTE_ARRAY Elem , CARDINAL HighElem, GraphNumber Graph );


void
PGCGNDChooseStat ( BacktrackInfo*  BtInfo , Set_Type*  Set , BYTE_ARRAY Elem , CARDINAL HighElem, GraphNumber Graph );


void
PGCNDIsoChooseStat ( BacktrackInfo*  BtInfo , SetDescription*  Set , NodeNumber*  Elem , SetDescription*  IsoSet , SetDescription*  NotSet , GraphNumber Graph );


void
PGCNDHomoChooseStat ( BacktrackInfo*  BtInfo , SetDescription*  Set , NodeNumber*  Elem , SetDescription*  IsoSet , SetDescription*  HomoSet , SetDescription*  NotSet , GraphNumber Graph );


void
PGCNDIsoOptChooseStat ( BacktrackInfo*  BtInfo , SetDescription*  CandSet , SetDescription*  ChosenElem , SetDescription*  IsoSet , SetDescription*  ImagesOfSets , SetDescription*  NotSet , GraphNumber Graph );


void
PGCNDHomoOptChooseStat ( BacktrackInfo*  BtInfo , SetDescription*  CandSet , SetDescription*  ChosenElem , SetDescription*  IsoSet , SetDescription*  ImagesOfSets , SetDescription*  HomoSet , SetDescription*  NotSet , GraphNumber Graph );


void
PGCIsoChooseAllStat ( SetDescription*  CandSet , SetDescription*  ImagesOfSets , SetDescription ImagesOfNodes , BacktrackInfo BtInfo , GraphNumber Graph );


void
PGCHomoChooseAllStat ( SetDescription*  CandSet , SetDescription*  HomoSet , SetDescription*  ImagesOfSets , SetDescription ImagesOfNodes , BacktrackInfo BtInfo , GraphNumber Graph );


void
PGCNDConcStat ( BacktrackInfo*  BtInfo , BacktrackInfo*  SubBtInfo , Surrogate*  ChosenElem , GraphNumber Graph , Surrogate MaxNumber );


void
PGCConstrConcStat ( Surrogate NoOfBranches , BacktrackInfo*  BtInfo , BacktrackInfo*  SecBtInfo , Surrogate*  ChosenElem );


/********************************************************************
 * 'Backtracking'-Befehle                                           *
 ********************************************************************/

void
PGCChoose ( NodeNumber*  Element , SetDescription*  NewSet , SetDescription OldSet );


void
PGCFail (void);


void
PGCTrueOnFailFalse ( BOOLEAN*  FirstCall , SHORTCARD ChoiceId );


void
PGCHalt (void);


void
PGCError (void);


void
PGCConstraintIsHurt (void);


void
PGCAttrConstrHurt (void);


void
PGCGraphPathError (void);


void
PGCDefSetCheckpoint ( BacktrackInfo*  InBtInfo , GraphNumber Graph );


void
PGCDefUndo ( GraphNumber Graph , BacktrackInfo InBtInfo );


void
PGCEvalAndStat ( BacktrackInfo*  OutBtInfo , BacktrackInfo*  OutSubBtInfo , Set_Type*  OutAndListSet , Set_Type*  OutStillPossible , Surrogate*  OutChosenElem , GraphNumber Graph , BacktrackInfo InBtInfo , BacktrackInfo InSubBtInfo , Set_Type InAndListSet , Set_Type InStillPossible , Surrogate InChosenElem );


void
PGCEvalBranchStat ( BacktrackInfo*  OutBtInfo , BacktrackInfo*  OutSubBtInfo , BOOLEAN*  OutGuard , Surrogate*  OutChosenElem , GraphNumber Graph , BacktrackInfo InBtInfo , BacktrackInfo InSubBtInfo , Surrogate InMaxNumber , BOOLEAN InGuard , Surrogate InChosenElem );


void
PGCEvalStat ( BacktrackInfo*  OutBtInfo , NodeNumber*  OutNode , SetDescription*  OutSet , BacktrackInfo*  OutSubBtInfo , SetDescription*  OutSetOfNodes , GraphNumber Graph , BOOLEAN InnermostFlag , BacktrackInfo InBtInfo , NodeNumber InNode , SetDescription InSet , BacktrackInfo InSubBtInfo , SetDescription InSetOfNodes );


void
PGCEvalForAllStat ( BacktrackInfo*  OutBtInfo , BYTE_ARRAY OutElem , CARDINAL HighOutElem, SetDescription*  OutSet , BacktrackInfo*  OutSubBtInfo , INTEGER*  OutNumNDVars , GraphNumber Graph , BacktrackInfo InBtInfo , BYTE_ARRAY InElem , CARDINAL HighInElem, SetDescription InSet , BacktrackInfo InSubBtInfo , INTEGER InNumNDVars );


void
PGCEvalGForAllStat ( BacktrackInfo*  OutBtInfo , BYTE_ARRAY OutElem , CARDINAL HighOutElem, Set_Type*  OutSet , BacktrackInfo*  OutSubBtInfo , INTEGER*  OutNumNDVars , GraphNumber Graph , BacktrackInfo InBtInfo , BYTE_ARRAY InElem , CARDINAL HighInElem, Set_Type InSet , BacktrackInfo InSubBtInfo , INTEGER InNumNDVars );


void
PGCEvalExprStat ( BacktrackInfo*  OutBtInfo , BYTE_ARRAY OutElemPtr , CARDINAL HighOutElemPtr, SetDescription*  OutSet , GraphNumber Graph , BacktrackInfo InBtInfo , BYTE_ARRAY InElemPtr , CARDINAL HighInElemPtr, SetDescription InSet );


void
PGCEvalGExprStat ( BacktrackInfo*  OutBtInfo , BYTE_ARRAY OutElemPtr , CARDINAL HighOutElemPtr, Set_Type*  OutSet , GraphNumber Graph , BacktrackInfo InBtInfo , BYTE_ARRAY InElemPtr , CARDINAL HighInElemPtr, Set_Type InSet );


void
PGCEvalLoopStat ( BacktrackInfo*  OutBtInfo , BacktrackInfo*  OutSubBtInfo , BOOLEAN*  OutGuard , Surrogate*  OutChosenElem , GraphNumber Graph , BacktrackInfo InBtInfo , BacktrackInfo InSubBtInfo , Surrogate InMaxNumber , BOOLEAN InGuard , Surrogate InChosenElem );


void
PGCTAssign ( BacktrackInfo*  OutBtInfo , BYTE_ARRAY OutElemPtr , CARDINAL HighOutElemPtr, BacktrackInfo InBtInfo , BYTE_ARRAY InElemPtr , CARDINAL HighInElemPtr);


void
PGCTAssignSet ( SetDescription*  OutSet , BacktrackInfo*  OutBtInfo , BacktrackInfo InBtInfo , SetDescription InSet );


void
PGCTAssignElemSet ( NodeNumber*  OutElem , SetDescription*  OutSet , BacktrackInfo*  OutBtInfo , NodeNumber InElem , SetDescription InSet , BacktrackInfo InBtInfo );


void
PGCTAssignGSet ( Set_Type*  OutSet , BacktrackInfo*  OutBtInfo , BacktrackInfo InBtInfo , Set_Type InSet );


void
PGCOnContinueOldFail ( BacktrackInfo*  OutBtInfo , GraphNumber Graph , BacktrackInfo InBtInfo );


void
PGCOnContinueOldUndo ( GraphNumber Graph , BacktrackInfo InBtInfo );


void
PGCOnSuccessSetCheckpoint ( BacktrackInfo*  InBtInfo , GraphNumber Graph );


void
PGCHandleCheckpoint ( BacktrackInfo*  BtInfo , GraphNumber Graph );


void
PGCInitNull ( BYTE_ARRAY OutElemPtr , CARDINAL HighOutElemPtr);


void
PGCInitBtInfo ( BacktrackInfo*  OutBtInfo , GraphNumber Graph );


void
PGCInitChoiceVars ( NodeNumber*  InNode , SetDescription*  InSet , BacktrackInfo*  InSubBtI , BacktrackInfo InBtI , GraphNumber Graph );


void
PGCInitLoopAndVars ( Surrogate*  InNo , Set_Type*  InSet1 , Set_Type*  InSet2 , BacktrackInfo*  InSubBtI , BacktrackInfo InBtI );


void
PGCInitLoopBranchVars ( Surrogate*  InNo , BOOLEAN*  Guard , BacktrackInfo*  InSubBtI , BacktrackInfo InBtI );


void
PGCInitConcVars ( Surrogate*  InNo , BacktrackInfo*  InSubBtI , BacktrackInfo InBtI );


void
PGCInitGLoopExprVars ( Set_Type*  Set , BYTE_ARRAY Elem , CARDINAL HighElem, GraphNumber Graph );


void
PGCInitLoopExprVars ( SetDescription*  Set , BYTE_ARRAY Elem , CARDINAL HighElem, GraphNumber Graph );


void
PGCInitOrVars ( Surrogate*  InNo , Surrogate*  InNo2 , Set_Type*  InSet , BacktrackInfo*  InSubBtI , BacktrackInfo InBtI );


void
PGCInitLoopStatVars ( Surrogate*  InNo , BOOLEAN*  Guard , BacktrackInfo*  InSubBtI , BacktrackInfo InBtI );


void
PGCInitSubBtInfo ( BacktrackInfo*  InSubBtI , BacktrackInfo InBtI );

BacktrackInfo 
PGCCheckAndSetBtInfo ( BacktrackInfo InBtInfo , BOOLEAN Backtrack , BOOLEAN IsPar , BOOLEAN IsNonDet );

BacktrackInfo 
PGCNegateBtInfo ( BacktrackInfo InBtInfo );

BacktrackInfo 
PGCSetBtInfo ( BOOLEAN Flag , BacktrackInfo InBtInfo );

BacktrackInfo 
PGCSetBtInfoTestSuccess ( BacktrackInfo InBtInfo );

BacktrackInfo 
PGCSetBtInfoChooseNext ( BacktrackInfo InBtInfo );

BacktrackInfo 
PGCSetBtInfoChooseLast ( BacktrackInfo InBtInfo );

BacktrackInfo 
PGCSetBtInfoFailed ( BacktrackInfo InBtInfo );

BacktrackInfo 
PGCSetBtInfoInitial ( BacktrackInfo InBtInfo );


BOOLEAN
PGCStatIsSuccess ( BacktrackInfo InBtInfo );

BacktrackInfo 
PGCSetBtInfoContinueOld ( BacktrackInfo InBtInfo , Surrogate No );


BOOLEAN
PGCStatIsContinueOld ( BacktrackInfo InBtInfo );


BOOLEAN
PGCStatIsFailed ( BacktrackInfo InBtInfo );


BOOLEAN
PGCStatIsTestSuccess ( BacktrackInfo InBtInfo );


/*******************************************************************
 * Tests                                                           *
 *******************************************************************/

void
PGCTestEdge ( BOOLEAN*  Exist , GraphNumber Graph , NodeNumber SourceNode , NodeNumber TargetNode , TypeNumber EdgeType );


/*****************************************************************
  Importierte Daten *
 *****************************************************************/

BOOLEAN
PGCImpDataEqual ( APtr Ptr1 , APtr Ptr2 );


/******************************************************************
 * Stringbefehle                                                  *
 ******************************************************************/

BOOLEAN
PGCStrEqual ( PGCMString Str1 , PGCMString Str2 );


INTEGER
PGCLength ( PGCMString PGCMStringVal1 );


Set_Type
PGCGLength ( Set_Type GSetVal1 );

PGCMString 
PGCChar ( INTEGER IntVar1 );


Set_Type
PGCGChar ( Set_Type GSetVal1 );


INTEGER
PGCOrd ( PGCMString PGCMStringVal1 );


Set_Type
PGCGOrd ( Set_Type GSetVal1 );


void
PGCCSubstr ( PGCMString PGCMStringVal1 , INTEGER IntVal1 , INTEGER IntVal2 , PGCMString*  ResultStr );

PGCMString 
PGCSubstr ( PGCMString PGCMStringVal1 , INTEGER IntVal1 , INTEGER IntVal2 );


Set_Type
PGCGSubstr ( Set_Type GSetVal1 , Set_Type GSetVal2 , Set_Type GSetVal3 );


void
PGCStringToValue ( GraphNumber Graph , CARDINAL ValueSize , Set_Type PGCMStringVal , ValueTypeNumber ValueType , Cardinality Crdnlty , BOOLEAN IsNodeType , SetDescription*  RetSet );


void
PGCConvertStringToSCN ( GraphNumber Graph , PGCMString InString , SchemeComponentNumber*  OutSCN );


void
PGCValueToString ( GraphNumber Graph , ValueTypeNumber ValueType , SetDescription Data , BOOLEAN IsNodeType , Set_Type*  ResultStr );


void
PGCStringToGValue ( GraphNumber Graph , CARDINAL ValueSize , Set_Type PGCMStringVal , ValueTypeNumber ValueType , Cardinality Crdnlty , BOOLEAN IsNodeType , Set_Type*  RetSet );


void
PGCGValueToString ( GraphNumber Graph , ValueTypeNumber ValueType , Set_Type Data , BOOLEAN IsNodeType , Set_Type*  ResultStr );



 
 /********************************************************************
  Hilfsprozeduren fuer das Mengenhandling *
 ********************************************************************/
PGCSetType 
PGCSetDescToPGCSet ( SetDescription Source );

PGCSetType 
PGCGSetToPGCSet ( Set_Type Source );

SetDescription 
PGCSetToSetDesc ( PGCSetType Source );


Set_Type
PGCSetToGSet ( PGCSetType Source );

SetDescription 
PGCCopySetDesc ( SetDescription Source );


Set_Type
PGCCopyGSet ( Set_Type Source );


BOOLEAN
PGCSetDescIsNotEmpty ( SetDescription Set );


Surrogate
PGCSetToElement ( SetDescription Set );



 
 /******************************************************************
 * Durchgeschleifte Attributbefehle                               *
 ******************************************************************/

void
PGCGetAllAttributesOfNode ( GraphNumber Graph , NodeNumber Node , SetDescription*  Attributes );


void
PGCShowAllAttributesOfNodeTypeOrClass ( GraphNumber Graph , TypeNumber NodeTypeOrClass , SetDescription*  AttributeSet );


void
PGCTestAndShowAttributeNumber ( GraphNumber Graph , PGCMString Name , AttributeNumber*  AttNo , BOOLEAN*  Existent );



 
 
 /********************************************************************
 * Hilfsprozeduren fuer die Anbindung IPSEN <--> PROGRES            *
 ********************************************************************/

void
PGCNoteOpenGraphs ( GraphNumber Hosphraph , GraphNumber ChoiceGra );


void
PGCNoteClosedGraphs ( GraphNumber Hosphraph , GraphNumber ChoiceGra );


void
PGCShowAllMethodsOfNodeTypeOrClass ( GraphNumber Graph , TypeNumber NodeTypeOrClass , Set_Type*  MethNameSet );


/******************************************************************
 * Durchgeschleifte Relationbefehle                               *
 ******************************************************************/

void
PGCRelCreate ( RelDescription*  Rel , GraphNumber Graph );


void
PGCRelKill ( RelDescription*  Rel );


void
PGCRelClear ( RelDescription*  Rel );


void
PGCRelRemoveAnyTuple ( RelDescription*  Rel , Surrogate*  Surr1 , Surrogate*  Surr2 , BOOLEAN*  Found );


SHORTCARD
PGCRelSize ( RelDescription Rel );



 
 /******************************************************************
 * Durchgeschleifte Setbefehle                                    *
 ******************************************************************/

void
PGCClearSet ( SetDescription*  Set );


void
PGCSetRemoveAnyElement ( SetDescription*  Set , Surrogate*  Elem , BOOLEAN*  Found );



 /******************************************************************
  Prozeduren, um an den Klassendescriptor gelangen *
  Normalerweise sind das einfach globale Variablen; dies ist fuer *
  den Uebergang nach C aber nicht machbar *
 ******************************************************************/

void
PGCGetEdgeDescriptionClass ( CARDINAL*  Class );


void
PGCGetUniqueIDClass ( CARDINAL*  Class );


void
PGCGetUniqueIDAttrClass ( CARDINAL*  Class );


void
PGCDieNow (void);



#ifdef __cplusplus
}
#endif

#endif /* C_PGC_h_ */
