/*********************************************************************/
/*                                                                   */
/* Copyright 1994/95/96 Carsten Friedrich, University of Passau.     */
/*                                                                   */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/
// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)
     based on code by Doug Schmidt

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _VOHSet_h
#ifdef __GNUG__
#pragma interface
#endif
#define _VOHSet_h 1

#include <string.h>
#include "MFSet.h"

#ifndef DEFAULT_INITIAL_CAPACITY
#define DEFAULT_INITIAL_CAPACITY 5
#endif

#define EMPTYCELL   0
#define VALIDCELL   1
#define DELETEDCELL 2

template<class T> class VOHSet : public MFSet<T>
{
  T*                  tab;
  char*                 status;
  int                   size;
  int                   cnt; // keeps track of VALIDCELLs and DELETEDCELLs

 VOHSet<T>& operator = (const VOHSet<T>&);

public:

 VOHSet(const VOHSet<T>&);
 VOHSet(int sz = DEFAULT_INITIAL_CAPACITY);
 ~VOHSet();
 
 Pix add(T x);
 void del(T key);
 int contains(T key) const;
 void clear();
 Pix first() const;
 void next(Pix& i) const;
 Pix seek(T key) const;
 void resize(int newsize = 0);
	
 T& operator () (Pix p) const;
 void operator |= (const VOHSet<T>&);
 void operator -= (VOHSet<T>&);
 void operator &= (VOHSet<T>&);
 int operator == (VOHSet<T>&);
 int operator != (VOHSet<T>&);
 int operator <= (VOHSet<T>&); 

 int capacity();
 int OK();
};

#endif
