//-+-c++-+-
/* ===========================================================================
 *
 *
 *                         Lehrstuhl fuer Informatik III
 *                                 Prof. Nagl 
 *            RWTH Aachen, Ahornstr. 55, 52074 Aachen, Germany
 *
 * ===========================================================================
 */


/* ---------------------------------------------------------------------------
 *			         MODULE INTERFACE
 *
 *   MODULE NAME:	NEWffgraph
 *
 *   MODULE KEY :	NEWffgraph
 *
 *   DESCRIPTION:
 *   
 *   RCS IDENTIFICATION:
 *
 *    $Author: tatjana $
 *    $Date: 2000/06/02 15:19:04 $
 *    $Revision: 1.7 $
 *    $State: Exp $
 *    $Locker:  $
 *    $RCSfile: ecu.h,v $
 *    $Log: ecu.h,v $
 *    Revision 1.7  2000/06/02 15:19:04  tatjana
 *    Aenderungen von Ansgar Rademacher uebernommen; Makefiles an Linux/Solaris angepasst
 *
 *    Revision 1.6  1999/01/11 10:14:07  tcup
 *    Konstruktor in Klasse Ecu definiert.
 *
 *    Revision 1.5  1998/12/09 18:36:51  tcup
 *    chalter fuer Random Matching und Constraint Checking eingebaut
 *    (letzterer "disabled", weil Manfred da noch Bedenken hat ;-) ). -ajw
 *
 *    Revision 1.4  1998/05/13 14:20:56  rolf
 *    Anpassungen und Erweiterungen fuer Kantendarstellung eines Knotens
 *
 *    Revision 1.3  1998/03/27 15:23:59  broens
 *    testweise mehrere MGraphen definiert
 *
 *    Revision 1.2  1998/03/18 10:20:02  tatjana
 *    Aendern die Klasse MGraph
 *
 *    Revision 1.1  1998/03/13 16:26:24  tcup
 *    Tolle neue Verzeichnisse in tcup.
 *
 *    Revision 1.44  1998/02/27 13:31:32  tatjana
 *    title.tcl wird erstmal in werkzeug gesucht sonst in GENDIR
 *
 *    Revision 1.43  1998/02/26 14:12:44  tatjana
 *    Initialisierung von beiden Tabellen mit InitMap
 *
 *    Revision 1.42  1998/02/25 17:03:46  krapp
 *    ecu.h angepasst
 *
 *    Revision 1.41  1998/01/28 16:26:50  tatjana
 *    ecu_close_ecu geaendert wegen dateinameerstellung
 *
 *    Revision 1.40  1997/12/16 18:32:08  juergenk
 *    comments
 *
 *    Revision 1.39  1997/12/03 15:48:18  tatjana
 *    .
 *
 *    Revision 1.38  1997/12/02 14:28:57  tatjana
 *    2 Module aus fh in ecu.h eingefuegt fuer FFProto.cc
 *
 *    Revision 1.37  1997/12/02 13:40:56  tatjana
 *    .
 *
 *    Revision 1.36  1997/11/28 18:10:44  tatjana
 *    ecu verschoben nach ecu.h
 *
 *    Revision 1.35  1997/11/28 15:50:56  tatjana
 *    Bearbeitung von ..._ecu.g jetzt in ecu_common/fh
 *
 *    Revision 1.34  1997/09/12 16:24:27  krapp
 *    ecu_reafgraph neu (achtung datei muss noch umbenannt werden !)
 *
 *    Revision 1.33  1997/09/12 12:23:06  krapp
 *    ecu_MenuToolInit jetzt auch aus der Schnittstelle entfernt
 *
 *    Revision 1.32  1997/09/11 14:51:01  juergenk
 *    build list an schnittstelle
 *
 *    Revision 1.31  1997/09/10 21:20:29  juergenk
 *    neues abgleichverfahren
 *
 *    Revision 1.30  1997/08/20 17:12:31  rolf
 *    Aufruf der TCL-Scripte proto_start und proto_end eingebaut
 *
 *    Revision 1.29  1997/08/20 14:58:09  rolf
 *    ECU-Datenstruktur um MainInterp erweitert
 *
 *    Revision 1.28  1997/08/18 14:49:19  juergenk
 *    ecu_close_ecu
 *
 *    Revision 1.27  1997/07/30 11:01:05  juergenk
 *    DisplayCurrentFFGraph aus GToFFGraph nach MGraph
 *
 *    Revision 1.26  1997/05/10 13:42:01  juergenk
 *    doIO => ecu.h
 *
 *    Revision 1.25  1997/05/10 10:48:01  krapp
 *    und wieder die Schnistelle fuer MGraph geandert --> ja ja der Zeitdruck
 *
 *    Revision 1.24  1997/05/09 18:03:10  krapp
 *    layouter durch Komma getrennt
 *
 *    Revision 1.23  1997/05/09 14:47:30  krapp
 *    Methoden zum MGraphen angepasst
 *
 *    Revision 1.22  1997/05/08 23:54:44  krapp
 *    MGraph erweitert
 *
 *    Revision 1.21  1997/05/08 12:41:29  krapp
 *    Mgraph besitzt jetzt Attribute fuer die verschiedenen Labels
 *
 *    Revision 1.20  1997/05/08 11:19:26  juergenk
 *    us
 *
 *    Revision 1.19  1997/05/07 15:36:17  juergenk
 *    so
 *
 *    Revision 1.18  1997/05/06 16:08:17  juergenk
 *    change to box v1.0
 *
 *    Revision 1.17  1997/05/03 17:13:35  juergenk
 *    test_aufruf auskommentiert
 *
 *    Revision 1.16  1997/05/01 13:53:52  krapp
 *    Neue globale Variabel newGraph eingefuehrt (fuer den sugy2 layoutalgo . Ist ein hack ich weiss, dafuer aber schnell!)
 *
 *    Revision 1.15  1997/04/25 13:29:44  krapp
 *    Nun all Schnistellen fuer den generierten Code hochgereicht
 *
 *    Revision 1.14  1997/04/25 11:05:56  juergenk
 *    schnittstelle von op_handler ergaenzt
 *
 *    Revision 1.13  1997/04/24 08:26:04  krapp
 *    SetCardinality hochgereicht
 *
 *    Revision 1.12  1997/04/23 21:10:28  juergenk
 *    makmakefile fuer submodule angepasst]
 *
 *    Revision 1.11  1997/04/20 14:28:15  krapp
 *    tcl.h hinzugefuegt
 *
 *    Revision 1.10  1997/04/20 14:20:19  krapp
 *    tcl.h wieder rausgenommen, da schon in ffgraph oncludiert
 *
 *    Revision 1.9  1997/04/20 14:10:07  krapp
 *    Schnittstellen hochgereicht
 *
 *    Revision 1.8  1997/04/19 12:03:09  krapp
 *    Pfadaenderung wieder rueckgenommen
 *
 *    Revision 1.7  1997/04/19 11:21:33  krapp
 *    Pfadnameen aus Headser rausgenommen
 *
 *    Revision 1.6  1997/04/17 15:49:15  juergenk
 *    ffgraph in $GRAS/p/graph_name_ecu.g
 *
 *    Revision 1.5  1997/04/15 13:14:41  krapp
 *    ecu jetzt als library verwendbar
 *
 *    Revision 1.4  1997/04/13 15:18:35  krapp
 *    ecu ist jetzt gemeinsam nutzbar vom Protottypen und von Browser (hoffentlich)
 *
 *    Revision 1.3  1997/03/27 13:46:56  krapp
 *    ecu nur noch normales Modul -> main nach main ausgelagert
 *
 *    Revision 1.2  1996/11/26 09:21:05  juergenk
 *    erste version mit sichtbarkeitssteuerung von typen
 *
 *    Revision 1.1  1996/10/11 08:39:07  juergenk
 *    diese uebersetzbare und lauffaehige verion ist so suaber wie ein BABYPOPO
 *
 * ---------------------------------------------------------------------------
 */

                    /* Make sure that this file is included only once */
#ifndef NEWffgraph_H
#define NEWffgraph_H


/* ---------------------------------------------------------------------------
 *                                INCLUDES
 * ---------------------------------------------------------------------------
 */
#include"C_StandardTypes.h"
  //wegen GraphNumber

#include "C_PGC.h" 
//wegen BacktrackInfo


#include "rgglobal.h"   
   //wegen GraphNumber

#include "ffgraph/FFGraph.h"
#include "ffgraph/FFNodeClass.h"
#include "ffgraph/FFEdgeClass.h"

#include "rgras.h"

#include <tcl.h>

/* ---------------------------------------------------------------------------
 *                                CONSTANTS
 * ---------------------------------------------------------------------------
 */
#define PPM 1 //fuer .ppm Datei 
#define ECU 2 // fuer _ecu.g Datei
#define DISP 3 // fuer disp.label Datei
#define TITLE 4 // fuer title.tcl
/* ---------------------------------------------------------------------------
 *                              TYPES and CLASSES
 * ---------------------------------------------------------------------------
 */

/*********************************************************************
 *   GENERAL INFORMATIONS
 *   this file does not only contains declarations, that originally belong here
 *   but some that do belog to other files e.g. MGraph belongs to MGraph.h
 *   BUT:
 *   as ecu should be usable as a library for externel use, 
 *   the user should only have to include the ecu.h in only ONE directory.
 *   Due to this restriction there are no other not-system-includes allowed here!
 *   thats why declarations of other files are unavaillable here - sorry
 *********************************************************************/

class nodeDispInfo;

typedef struct list List;
typedef struct elist EList;


class MGraph : public FFGraph{

public:
  int GrasGraphIndx;
  int GrasNodeIndx;
  int GrasEdgeIndx;
  int GLEdgeopsIndx;
  int nodeDispInfoIndx;


public:
  void addNodeEcu(Surrogate grasNode, TypeNumber nodeType);
  void removeNodeEcu(FFNode ffn, Surrogate grasNode);

  int  isVisibleNodeEcu(Surrogate grasNode,TypeNumber nodeType, nodeDispInfo * DispInfo);

  void addEdgeEcu(Surrogate source, Surrogate target, TypeNumber type);
  void removeEdgeEcu(FFEdge ffe, Surrogate source, Surrogate target,
		     TypeNumber typNo);

  void removePathEcu(Surrogate nodeNo, TypeNumber typNo);
};


/*******************************************************************
 * the Ecu-Class is global, yes G-L-O-B-A-L
 * BUT:
 * due to recycled code, that makes use off global vars it is 
 * impossible not to have global vars, or rewrite a lot :-(
 * Another problem is the use of C++ data-structures in tcl
 * sometimes it is impossible (difficult) to get these structs 
 * from c => tcl => c. they have to be usable in c-code called
 * within an tcl-proc. but it is not possible (not really) to give the structs
 * to tcl and then to c, so use the glob-var ;-)
 *******************************************************************/

class Ecu {
protected:
public:  
	Ecu() { doIO=YES; }
  GraphNumber HostGraph;
  GraphNumber ChoiceGraph;
  BacktrackInfo ChoiceInfo;
  MGraph maingraph;
  MGraph main2graph;
  MGraph main3graph;
  FFGraph newGraph;
  PoolName HostPoolName;
  GraphName HostGraphName;
  BOOL IsProto;
  BOOL doIO;
  Tcl_Interp *MainInterp;
private:
};

/* ---------------------------------------------------------------------------
 *                                VARIABLES
 * ---------------------------------------------------------------------------
 */

extern Ecu ecu;

/* ---------------------------------------------------------------------------
 *                                FUNCTIONS
 * ---------------------------------------------------------------------------
 */
void ecu_PrepareGraphOpening(int argc, char **argv, char **envp);

void startup_routine(int argc, char **argv, char **envp);

void main_routine(int argc, char **argv, char **envp);

void ecu_OpenGraph(char *poolName, char *graphName, BOOLEAN withLogs);

void ecu_AddGraphModNotification(GraphNumber HostGraph);

void ecu_VariableToolInit ();                                                              
void ecu_VariableToolInitComplete ();           

void ecu_OperationParameterToolInitComplete (); 

void ecu_PriorityToolInitComplete();            

void ecu_close_ecu(FFGraph graph);

void ecu_readgraph();

/* Hochgereichte Schntstellen. Werden aus dem generierten Code aufgerufen */
int ui_Evaluation(Tcl_Interp * interp, GraphNumber HostGraph,
	       int index, char *name, ADDRESS conv[]);

void err_ErrorMessage (Tcl_Interp *interp, char *message);

int op_Func_AddFunc (char *name, int (*command)(Tcl_Interp*, int, char*), int no, char *eval);

int ui_InitParam( int index, int paraNo, char *name); 

int op_GetNoOfParameters(int index);

void ui_KillConv(int index, int paraNo, ADDRESS conv[]);

int op_SetSchemeName(int index, int paraNo, char *name);

int ui_Prepare(Tcl_Interp * interp, GraphNumber HostGraph, int index,
	       char *name, ADDRESS * conv);

int op_SetIsOutParam(int index, int paraNo);

void tcl_c_AppendLogMsg(Tcl_Interp *interp, char *msg);

int op_SetParamType(int index, int paraNo, StandardType type);

/* Hochgereichte Schntstellen. Werden aus dem generierten Code aufgerufen */
extern "C" {
int Evaluation(Tcl_Interp * interp, GraphNumber HostGraph,
               int index, char *name, ADDRESS conv[]);
 
void ErrorMessage (Tcl_Interp *interp, char *message);
 
int Func_AddFunc (char *name, int (*command)(Tcl_Interp*, int, char*), int no, char *eval);
 
int InitParam( int index, int paraNo, char *name); 
 
int GetNoOfParameters(int index);
 
void KillConv(int index, int paraNo, ADDRESS conv[]);
 
int SetSchemeName(int index, int paraNo, char *name);
 
int Prepare(Tcl_Interp * interp, GraphNumber HostGraph, int index,
               char *name, ADDRESS * conv);
 
int SetIsOutParam(int index, int paraNo);
 
void AppendLogMsg(Tcl_Interp *interp, char *msg);
 
int SetParamType(int index, int paraNo, StandardType type);

int SetCardinality(int index, int paraNo, Cardinality Card);

int SetIsNotStandard(int index, int paraNo);

void AddIFunction(char *TypeName, void (*Size)(int *),  
		  void (*ValueToString)(PGCMString *, void *), 
		  void (*StringToValue)(void *, PGCMString *));
}
// vollstaendige Definition in ecu_common/fh -Module  
void fh_init(int argc, char **argv);
FILE *fh_open(char *modus, int dateiart);
void fh_close(FILE *fp);
void fh_load(int dateiart);
String fh_getDirName(void);

// Schalter fuer PGC Schnittstelle
void ToggleConstrCheck(void);
void ToggleRandomChoice(void);
BOOLEAN GetConstrCheck(void);
BOOLEAN GetRandomChoice(void);
void SetConstrCheck(BOOLEAN c);
void SetRandomChoice(BOOLEAN c);

/* ---------------------------------------------------------------------------
 *                            END OF FILE
 * ---------------------------------------------------------------------------
 */

#endif	/* NEWffgraph_H */
