/*********************************************************************/
/*                                                                   */
/* Copyright 1994/95/96 Carsten Friedrich, University of Passau.     */
/*                                                                   */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/
#ifndef FF_SPRING
#define FF_SPRING

#include <globdefs.h>
#include <ffgraph/FFGraph.h>

#include <container/AVLSet.h>
#include <container/VOHSet.h>
#include <container/VHSet.h>

#include <ffgraph/FFspringembedder.h>
#include <ffgraph/FFLayoutLabel.h>
#include <String.h>

#define ffSpringType String("FFSpringembedder")

class FFSpring : public FFLayoutLabel
{
  FSSpringInfo info;

  public:
  FFSpring ();
  virtual ~FFSpring ();

  virtual void init(const FFGraph& g);
  virtual BOOL parse(const String&) {return YES;}
  virtual String unparse() {return String("");}
  virtual FFGraphLabel* proto() const {return new FFSpring;}
  virtual BOOL isInspectable() const {return YES;}
  
  BOOL    getAnimation ();
  void    setAnimation (BOOL);

  BOOL    getUseEdgeWeight ();
  void    setUseEdgeWeight (BOOL);

  int     getMaxIteration ();
  BOOL    setMaxIteration (int);

  int     getAnimationIntervals ();
  BOOL    setAnimationIntervals (int);

  FFCoord getOptDistance ();
  BOOL    setOptDistance (FFCoord);

  FFCoord getxoff ();
  BOOL    setxoff (FFCoord);
  FFCoord getyoff ();
  BOOL    setyoff (FFCoord);
  FFCoord getzoff ();
  BOOL    setzoff (FFCoord);

  BOOL    getDimension ();
  void    setDimension (BOOL);

  void    layout (FFSet <FFNodeClass *>&);
  void    layout ();
};

#endif
