/*********************************************************************/
/*                                                                   */
/* Copyright 1994/95/96 Carsten Friedrich, University of Passau.     */
/*                                                                   */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/
#ifndef SUGIYAMA
#define SUGIYAMA

#include <globdefs.h>
#include <ffgraph/FFGraph.h>
#include <ffgraph/FFNodeClass.h>

#include <container/AVLSet.h>
#include <container/VOHSet.h>
#include <container/VHSet.h>


struct FSSugiInfo
{ 
    int     crossingAlg, maxSize, 
            iteration1, iteration2, 
            dimension;
    FFPoint offset;
    FFCoord xDistance, yDistance, zDistance, 
            dummyOffset;
    BOOL    useStartNode, 
            useEndNodes, 
            keepEdgePoints,
            sameSize, 
            grid, 
            leavesDown,
            sortLeaves,
            deterministic;
};

void sugiyama (FFGraph& graph, 
	       struct FSSugiInfo info, 
	       FFSet <FFNode> locNodes);
                     
#endif








