/*
 *
 *  Filter fuer die Anfrage- und Veraenderungs-Operationen von GRAS.
 *
 */

%#include "xdr/prim.h"

%/*
% * Anfrage, einziger berechtigter Klient zu Graphmodifikationen zu sein.
% */
struct C_RequestSingleWriter
{
  BOOLEAN      wait_for;
};


%/*
% * Erzeugen eines Knotens.
% */
struct C_CreateNode
{
  TypeNumber   NType;
  NodeNumber   Nodenr;
};


%/*
% * Erzeugen eines Knotens und einer Kante.
% */
struct C_CreateEdgeAndNode
{
  NodeNumber   Nodenr;
  TypeNumber   EType;
  TypeNumber   NType;
};

%/*
% * Loeschen eines Knotens und einer Kante.
% */
struct C_DeleteNodeAndEdges
{
  NodeNumber   Nodenr;
};

struct C_ShowAllNodesWithIndex
{
  AttributeNumber AttNo;
  AOB             Val;
};


struct C_ShowNodeWithKey
{
  AttributeNumber AttNo;
  AOB             Val;
};


struct S_ShowNodeWithKey
{
  BOOLEAN    Exist;
  NodeNumber Node;
};

struct C_ShowTypeOfNode
{
  NodeNumber   Node;
};


%/*
% * Kante erzeugen.
% */
struct C_CreateEdge
{
  NodeNumber   Sourcenode;
  NodeNumber   Targetnode;
  TypeNumber   EType;
};

%/*
% * Kante loeschen.
% */
struct C_DeleteEdge
{
  NodeNumber   Sourcenode;
  NodeNumber   Targetnode;
  TypeNumber   EType;
};

%/*
% * Abfrage, ob Kante existiert.
% */
struct C_EdgeExists
{
  NodeNumber   SourceNode;
  NodeNumber   TargetNode;
  TypeNumber   EType;
};

%/*
% * Quellknoten bestimmen.
% */
struct C_ShowSourceNode
{
  NodeNumber   Targetnode;
  TypeNumber   EType;
};

%/*
% * Quellknoten unter gewissen Umstaenden bestimmen.
% */
struct C_TestAndShowSourceNode
{
  NodeNumber   Targetnode;
  TypeNumber   EType;
};

struct S_TestAndShowSourceNode
{
  CARDINAL  Sourcenrs;
  NodeNumber Sourcenode;
};
%/*
% * Alle Quellknoten liefern.
% */
struct C_ShowAllSourceNodes
{
  NodeNumber   Targetnode;
  TypeNumber   EType;
};

%/*
% * Zielknoten bestimmen.
% */
struct C_ShowTargetNode
{
  NodeNumber   Sourcenode;
  TypeNumber   EType;
};

%/*
% * Zielknoten unter bestimmten Umstaenden bestimmen.
% */
struct C_TestAndShowTargetNode
{
  NodeNumber   Sourcenode;
  TypeNumber   EType;
};

struct S_TestAndShowTargetNode
{
  CARDINAL  Targetnrs;
  NodeNumber Targetnode;
};


%/*
% * Alle Zielknoten bestimmen.
% */
struct C_ShowAllTargetNodes
{
  NodeNumber   Sourcenode;
  TypeNumber   EType;
};

%/*
% * Testet Knoten auf einlaufende Kanten.
% */
struct C_TestIncomingEdge
{
  NodeNumber   Targetnode;
  TypeNumber   EType;
};

%/*
% * Testet Knoten auf auslaufende Kanten.
% */
struct C_TestOutgoingEdge
{
  NodeNumber   Sourcenode;
  TypeNumber   EType;
};

%/*
% * Alle Knoten liefern, deren Kanten zum Zielknoten fuehren.
% */
struct C_GetInContextOfNode
{
  NodeNumber   Targetnode;
};

%/*
% * Alle Knoten liefern, die vom Zielknoten ueber Kante verbunden sind.
% */
struct C_GetOutContextOfNode
{
  NodeNumber   Sourcenode;
};

%/*
% * Schreibt Attributwerte eines Knotens.
% */
struct C_PutAttributeSubstr
{
  NodeNumber      Nodenr;
  AttributeNumber AttNumber;
  CARDINAL        AttBegin;
  AOBP            Val;
  BOOLEAN         Truncate;
};


struct C_DeleteAttribute
{
  NodeNumber	  Node;
  AttributeNumber AttNo;
};

%/*
% * Liest Attributwerte eines Knotens.
% */
struct C_GetAttributeSubstr
{
  NodeNumber      Nodenr;
  AttributeNumber AttNumber;
  CARDINAL        AttBegin;
  CARDINAL        AttLength;
};


