#ifndef XDR_DEFS_H
#define XDR_DEFS_H

#ifdef USE_OWN_XDR

#include "rpc/types.h"
#include "rpc/xdr.h"

#define xdr_int xdr_INTEGER
#define xdr_u_int xdr_INTEGER
#define xdr_long(x, p) xdr_CARDINAL(x, (CARDINAL*)p)
#define xdr_u_long xdr_CARDINAL
#define xdr_short xdr_SHORTINT
#define xdr_u_short xdr_SHORTCARD
#define xdr_char xdr_CHAR
#define xdr_u_char xdr_BYTE
#define xdr_bool xdr_INTEGER

#define xdr_void myxdr_void
#define xdr_opaque myxdr_opaque
#define xdr_string myxdr_string
#define xdr_bytes  myxdr_bytes
#define xdr_reference  myxdr_reference
#define xdr_pointer  myxdr_pointer
#define xdr_vector  myxdr_vector
#define xdr_array  myxdr_array

#define xdr_netobj myxdr_netobj
#define xdr_wrapstring myxdr_wrapstring



bool_t
xdr_reference(register XDR * xdrs, caddr_t * pp, u_int size, xdrproc_t proc);
bool_t
xdr_pointer(register XDR * xdrs, char **objpp, u_int obj_size, xdrproc_t xdr_obj);

bool_t
xdr_vector(register XDR * xdrs, register char *basep, register u_int nelem, register u_int elemsize, register xdrproc_t xdr_elem);
bool_t
xdr_array(register XDR * xdrs, caddr_t * addrp, u_int * sizep, u_int maxsize, u_int elsize, xdrproc_t elproc);
bool_t
xdr_opaque(register XDR * xdrs, caddr_t cp, register u_int cnt);
bool_t
xdr_bytes(register XDR * xdrs, char **cpp, register u_int * sizep, u_int maxsize);
 bool_t
xdr_string(register XDR * xdrs, char **cpp, u_int maxsize);

bool_t
xdr_wrapstring(XDR * xdrs, char **cpp);

bool_t
xdr_void(void);

#define xdr_unionb xdr_myunionb
#define xdr_unioni xdr_myunioni
#define xdr_unionl xdr_myunionl
#define xdr_unions xdr_myunions

#define xdr_enumi xdr_myenumi
#define xdr_enuml xdr_myenuml
#define xdr_enumb xdr_myenumb
#define xdr_enums xdr_myenums

#endif
/*USE_OWN_XDR*/





#define xdr_enum(xdrs, ep)						      \
(									      \
 sizeof(*ep) == sizeof(char) ? xdr_enumb(xdrs, (char *)ep) :		      \
 sizeof(*ep) == sizeof(short) ? xdr_enums(xdrs, (short *)ep) :		      \
 sizeof(*ep) == sizeof(int) ? xdr_enumi(xdrs, (int *)ep) : xdr_enuml(xdrs, (long *)ep) \
 )
extern bool_t xdr_enumb(XDR *xdrs, char *ep);
extern bool_t xdr_enums(XDR *xdrs, short int *ep);
extern bool_t xdr_enumi(XDR *xdrs, int *ep);
extern bool_t xdr_enuml(XDR *xdrs, long int *ep);

#define xdr_union(xdrs, dscmp, unp, choices, dfault)			      \
(									      \
 sizeof(*dscmp) == sizeof(char) ?					      \
 xdr_unionb(xdrs, (char *)dscmp, unp, choices, dfault) :		      \
 sizeof(*dscmp) == sizeof(short) ?					      \
 xdr_unions(xdrs, (short *)dscmp, unp, choices, dfault) :		      \
 sizeof(*dscmp) == sizeof(int) ?					      \
 xdr_unioni(xdrs, (int *)dscmp, unp, choices, dfault) :			      \
 xdr_unionl(xdrs, (long *)dscmp, unp, choices, dfault)			      \
 )

extern bool_t xdr_unionb(register XDR *xdrs, char *dscmp, char *unp,
			struct xdr_discrim *choices, xdrproc_t dfault);
extern bool_t xdr_unions(register XDR *xdrs, short int *dscmp, char *unp,
			struct xdr_discrim *choices, xdrproc_t dfault);
extern bool_t xdr_unioni(register XDR *xdrs, int *dscmp, char *unp,
			struct xdr_discrim *choices, xdrproc_t dfault);
extern bool_t xdr_unionl(register XDR *xdrs, long int *dscmp, char *unp,
			struct xdr_discrim *choices, xdrproc_t dfault);


#endif

